# DO NOT PUT A VERSION MARKER HERE, ADDED AT RELEASE

Major Features, Bugfixes, and Backward Incompatible Changes

-- Fix: Convert assert on menubar syntax errors to log warning and skip the menu -- Jerry James

User-Visible Bug Fixes and Improvements

-- Fix: Remove a reference to 'efs-ftp-path from #'file-remote-p -- Mike Sperber
-- Improve: Allow :visible in menu specs; document -- Jerry James
-- Improve: Allow a string the LHS of a syntax-alist entry in `font-lock-defaults' to be a string (sync to GNU Emacs) -- Mike Sperber
-- Improve: Make #'byte-compile-if suppress spurious warnings from `(if (fboundp ...' or `(if (boundp ...' constructs (port of Dave Love patch to Emacs) -- Mike Sperber
-- Improve: Silence warnings about throws out of #'post-command-hook' -- Mike Sperber
-- New: Support bignums with MPIR -- Jerry James
-- Improve: Help buffer behaviour synced with GNU -- Mats Lidell

Build Infrastructure and Source Tree

-- Fix: Change several Mule-specific constructs to generic ones in core Lisp (paragraphs.el); fixes --without-mule build from tarballs -- Stephen Turnbull
-- Fix: Fix Windows portability issues -- Vin Shelton, Jerry James, Mats Lidell
-- Fix: Reverse sense of #if for insert-data-in-exec build -- Jerry James
-- Fix: Silence syntax warnings -- Jerry James
-- Improve: Update autoconf helpers to latest upstream version -- Jerry James

Documentation

-- Improve: Bignum documentation -- Jerry James
-- Improve: Port texi files to Texinfo 5, fix style -- Jerry James

Lisp API

-- Fix: Add optional ID-FORMAT to #'file-attributes (GNU compatibility); add tests -- Mats Lidell, Vin Shelton
-- Fix: Make #'apply-partially more intelligent about constructing compiled functions when making closures; add tests -- Aidan Kehoe
-- Improve: Add optional WHEN and DOCSTRING arguments to #'define-obsolete-function-alias, #'define-compatible-function-alias, #'define-obsolete-variable-alias, #'define-compatible-variable-alias (GNU compatibility) -- Stephen Turnbull, Mike Sperber, Jeff Sparkes
-- New: Add #'font-lock-extend-region-functions' from GNU Emacs, use it -- Mike Sperber

Internal API and Implementation

-- Fix: Canonicalize some ratios -- Jerry James
-- Fix: Change integer arithmetic to fixnums in check_valid_xbm_inline; adjust test to changed error -- Jerry James
-- Fix: Initialization of bignums from long longs -- Jerry James
-- Fix: Replace AC_FUNC_FSEEKO with HAVE_FSEEKO in config.h.in -- Jerry James
-- Improve: Add mp-specific allocation functions -- Jerry James
-- Improve: Prepare for large file support -- Jerry James
-- Improve: Reimplement #'process-synchronize-point as a label in #'call-process-internal -- Aidan Kehoe
-- Improve: Support for statically linked modules -- Jerry James
-- Improve: Use make_fixnum instead of make_integer where size is known to fit in many places -- Jerry James

Testing and Debugging

-- New: Add tests for #'file-attributes -- Mats Lidell


to XEmacs 21.5.33 "horseradish"

Major Features, Bugfixes, and Backward Incompatible Changes

-- Nothing major this time. -- nobody

User-Visible Bug Fixes and Improvements

-- Improve: Reorganize default menubar. -- Stephen J. Turnbull

Build Infrastructure and Source Tree

-- Fix: Prevent make distclean from deleting configure in modules. -- Mats Lidell
-- Improve: Make configure warn about missing system package hierarchies. -- Stephen J. Turnbull

Documentation

-- Fix: Description of Mercurial repositories. -- Stephen J. Turnbull
-- Fix: TUTORIAL to describe recenter-top-bottom correctly. -- Mats Lidell
-- Improve: Description of `mark-defun'. -- Steven Mitchell
-- Improve: Documentation of menus. -- Byrel Mitchell, Vin Shelton
-- Improve: INSTALL. -- Steven Mitchell, Stephen J. Turnbull, Robert D. Royar

Lisp API

-- Fix: Implement :active in submenu specs. -- Byrel Mitchell
-- New: Adopt GNU's ## syntax for the interned symbol with the zero-length name. -- Aidan Kehoe
-- New: Command remapping in keymaps from GNU. -- Aidan Kehoe
-- New: call-process-shell-command from GNU. -- Mats Lidell
-- New: delete-trailing-lines, delete-trailing-whitespace from GNU. -- Aidan Kehoe
-- New: recenter-positions, recenter-top-bottom, recenter-last-op from GNU. -- Mats Lidell
-- Improve: Accept GNU's UNIVERSAL argument in format-time-string. -- Aidan Kehoe
-- Improve: Allow noninteractive call of self-insert-command with null count. -- Stephen J. Turnbull

Internal API and Implementation

-- Fix: Avoid malloc'ing inside search. -- Aidan Kehoe
-- Fix: GCPRO etc in define-specifier-tag. -- Aidan Kehoe
-- Fix: Incorrect handling of empty sets in subsetp. -- Stephen J. Turnbull, Benson Mitchell, Steven Mitchell
-- Fix: Inhibit error at compile time in equal, member, assoc, rassoc. -- Aidan Kehoe
-- Fix: Regexp in describe-register-1. -- Stephen Turnbull, Mats Lidell
-- Fix: Respect face and display table information in the minibuffer prompt. -- Aidan Kehoe
-- Improve: Charset not in table warning message. -- Stephen J. Turnbull
-- Improve: find-coding-system-magic-cookie-in-file moved to C. -- Aidan Kehoe

Testing and Debugging

-- New: Simple test cases for call-process-shell-command. -- Mats Lidell
-- New: Test regular expression in describe-register-1. -- Mats Lidell
-- New: Test search for character ranges with dirty syntax table. -- Aidan Kehoe
-- New: Test the new command remapping functionality. -- Aidan Kehoe
-- New: Tests of #'subsetp. -- Stephen J. Turnbull, Steven Mitchell, Benson Mitchell

to XEmacs 21.5.32 "habanero"

Major Features, Bugfixes, and Backward Incompatible Changes

-- Fix: Prevent SIGPIPEs in deactivate_process(). -- Stephen Turnbull
-- Fix: Prevent assert at frame.c, l. 6311. -- Stephen Turnbull

User-Visible Bug Fixes and Improvements

-- Fix: 'most-positive-fixnum-on-32-bit-machines value. -- Aidan Kehoe, Raymond Toy
-- Fix: Bug where syntax cache overruns restriction. -- Stephen Turnbull, Alan Mackenzie
-- Fix: Don't initialize bit 7 as meta if native coding system uses that bit. -- Aidan Kehoe
-- Fix: Handling of face background values. -- Vin Shelton, Aidan Kehoe
-- Improve: Determine terminal type dynamically, not from TERM envvar. -- Aidan Kehoe
-- Improve: Implement printing of circular structures readably. -- Aidan Kehoe
-- New: 'foreback property for faces. -- Didier Verna
-- New: 'shrink property for faces. -- Didier Verna
-- New: Custom group "view". -- Aidan Kehoe

Build Infrastructure and Source Tree

-- Fix: CPP error breaking build on OpenBSD/NetBSD. -- Aidan Kehoe, Adam Sjøgren
-- Fix: Creation of etc/dbxrc and src/.dbxrc. -- Marcus Crestani
-- Fix: Disable ASLR on Mac OS X Lion & Mountain Lion (breaks pdump). -- Marcus Crestani, Stephen Turnbull, Robert Royer
-- Fix: Printing of Lisp_Object types in dbxrc. -- Marcus Crestani
-- Fix: Use libraries in /usr/lib/w32api on Cygwin. -- jeff
-- Fix: Workaround link problem in pdump.  -- Stephen Turnbull, Hans de Graaf, Marcus Crestani
-- Fix: configure detection of VDB_POSIX vs. VDB_MACH. -- Aidan Kehoe
-- Improve: Move dbxrc.in (back?) to ./src. -- Marcus Crestani
-- Improve: Prefer dlopen() to dyld() in configure on Mac OS X. -- Aidan Kehoe
-- Improve: Refactor check for Xaw3d. -- Stephen Turnbull
-- Improve: Remove unused include of process.h from Cygwin. -- Vin Shelton
-- Improve: gnuclient to fall back to /tmp to search for socket. -- Aidan Kehoe
-- New: Support DESTDIR. -- Jerry James
-- New: Support building texinfo.info in native builds. -- Vin Shelton

Documentation

-- Fix: #'eq-hash docstring. -- Aidan Kehoe
-- Fix: Comment in #'byte-compile-funcall. -- Aidan Kehoe
-- Fix: Comment typo. -- Didier Verna
-- Fix: Comments in fns.c. -- Aidan Kehoe
-- Fix: Correct usage of the term "special operator" in manuals. -- Aidan Kehoe
-- Fix: Docstrings of #'posix-charset-to-coding-system-hash, load-time-value. -- Aidan Kehoe
-- Fix: Document change of location of packages from lib/ to share/. -- Aidan Kehoe
-- Fix: Typos. -- Didier Verna
-- Improve: Docstrings in syntax.c. -- Stephen Turnbull
-- Improve: Document a reasonable approach to improving #'symbol-macrolet. -- Aidan Kehoe
-- Improve: Emphasize #'labels of #'flet in CL manual. -- Aidan Kehoe
-- Improve: Make describe-function-1 mention whether byte-compiled functions are built-in. -- Aidan Kehoe
-- Improve: Update versions numbers for libs in config.inc.samp. -- Vin Shelton
-- Improve: Use ISO-IR-196 sequences to encode Unicode in HELLO. -- Aidan Kehoe
-- New: Comment re: background pixmaps in faces.c, cache coherency in glyphs.c. -- Didier Verna
-- New: Docstring for #'cl-transform-lambda. -- Aidan Kehoe
-- New: Document Mercurial techniques in Internals manual. -- Stephen Turnbull
-- New: Internals documentation of sequence.c. -- Aidan Kehoe

Lisp API

-- Fix: Correctly lex a bignum with leading "+". -- Aidan Kehoe
-- Improve: #'face-property-matching-instance 21.4 compatibility. -- Stephen Turnbull
-- Improve: #'labels supports inline label declaration. -- Aidan Kehoe
-- Improve: Add .pdf and other types to 'binary-file-regexps.
-- Improve: Common Lisp conformance. -- Aidan Kehoe, Didier Verna
-- Improve: Default print_gensym to t (CL compatibility). -- Aidan Kehoe
-- Improve: Make #'built-in-symbol-file ignore non-built-ins. -- Aidan Kehoe
-- Improve: Make #'make-modeline-command-wrapper evaluate COMMAND lazily. -- Aidan Kehoe
-- Improve: Obsolete #'remassoc and friends, and remove instances from core. -- Aidan Kehoe
-- Improve: Partial, undocumented support for #'macro-declaration-function in #'defmacro. -- Aidan Kehoe.
-- Improve: Provide API for disabling symbol macros in cl-macroexpand. -- Aidan Kehoe
-- Improve: Refactor completion code, improve GNU compatibility. -- Aidan Kehoe-- Improve: Remove XEmacs-specific #'remassoc functions, and substitute CL-style #'delete* for uses. -- Aidan Kehoe
-- Improve: Remove cl-compat.el and related documentation. -- Aidan Kehoe
-- Improve: Remove long-obsolete cl-compat.el. -- Aidan Kehoe
-- Improve: Remove obsolete compatibility aliases from cl*.el. -- Aidan Kehoe
-- Improve: Support POSIX semantics in #'posix-string-match. -- Aidan Kehoe
-- Improve: Sync #'batch-byte-recompile-directory API. -- Mike Sperber
-- Improve: Sync #'shell-command{,-on-region}. -- Mats Lidell
-- Improve: Sync #'truncate-string-to-width. -- Aidan Kehoe
-- Improve: Character syntax of JIT Unicode characters. -- Aidan Kehoe
-- Improve: Update #'file-name-remote-p. -- Mike Sperber
-- New: #'apply-partially. -- Aidan Kehoe
-- New: #'event-apply-modifiers. -- Aidan Kehoe
-- New: #'looking-back. -- Didier Verna
-- New: #'macro-declaration-function support (GNU compatibility). -- Aidan Kehoe
-- New: #'special-mode. -- Didier Verna
-- New: #'test-completion. -- Aidan Kehoe
-- New: 'function-key-map-parent improves x-compose processing. -- Aidan Kehoe
-- New: 'print-circle, 'print-continuous-numbering. -- Aidan Kehoe
-- New: Add a defsetf for #'get-char-table. -- Aidan Kehoe
-- New: Implement #'load-time-value, #'labels. -- Aidan Kehoe
-- New: Sexp movement recognises notation for circular lists. -- Aidan Kehoe
-- New: Support POSIX classes in regexps, #'skip-chars-{forward,backward}. -- Aidan Kehoe
-- New: syntax-ppss.el. -- Mats Lidell

Internal API and Implementation

-- Fix: Array declaration and bounds checks of syntax_spec_code. -- Stephen Turnbull
-- Fix: Autoload `custom-set-face-bold'. -- Vin Shelton
-- Fix: Duplicate arglist info in autoloads. -- Aidan Kehoe
-- Fix: Ignore extent info in select-convert-to-text functions, fixing a copy problem in ERC. -- Aidan Kehoe
-- Fix: Loss of precision in building FIXNUMs. -- Jerry James
-- Fix: Redundant division in bignum_ceil. -- Aidan Kehoe
-- Fix: Remove 'device' parameter from 'clear_region' methods. -- Didier Verna
-- Fix: Syntax error in #'get-other-frame. -- Didier Verna, Steven Mitchell
-- Fix: pixel_to_glyph_translation to handle redisplay edge case. -- Mike Kupfer
-- Improve: #'copy-symbol handles non-list plists. -- Aidan Kehoe
-- Improve: Backward-compatible MATCHSPEC in face-property-matching-instance. -- Stephen Turnbull
-- Improve: Byte-optimize more carefully. -- Aidan Kehoe
-- Improve: Coding style in select.el. -- Aidan Kehoe
-- Improve: Error when compiling an eval-when-compile form that changes the current buffer. -- Aidan Kehoe
-- Improve: Handling of 'byte-compile-initial-macro-environment. -- Aidan Kehoe
-- Improve: Handling of X keysyms. -- Aidan Kehoe
-- Improve: Implementation of #'labels forms. -- Aidan Kehoe
-- Improve: Lexical analysis of bignums. -- Aidan Kehoe
-- Improve: Move #'split-path to Lisp. -- Aidan Kehoe
-- Improve: Move #'x-keysym-on-keyboard-sans-modifiers-p, #'x-keysym-on-keyboard-p here from device-x.c to Lisp. -- Aidan Kehoe
-- Improve: Move #'x-keysym-on-keyboard{,-sans-modifiers}-p to Lisp. -- Aidan Kehoe.
-- Improve: Move config.h macros to configure. -- Aidan Kehoe
-- Improve: Refactor #'cl-defsubst-expand, #'enable-behavior, #'disable-behavior, #'cl-transform-lambda. -- Aidan Kehoe
-- Improve: Refactor #'macroexpand, various CL macros. -- Aidan Kehoe
-- Improve: Refactor X keystroke handling to avoid XKeysymToString. -- Aidan Kehoe.
-- Improve: Refactor XLIKE redisplay functions to use display, not frame. -- Didier Verna
-- Improve: Refactor selection C code to use va_run_hooks_with_args. -- Aidan Kehoe
-- Improve: Refactor some subr.el functions to use CL for circularity checking. -- Aidan Kehoe
-- Improve: Refactor syntax cache. -- Stephen Turnbull
-- Improve: Refactor text_width methods to expect a frame, not a window. -- Didier Verna
-- Improve: Refactor to avoid #'mapcar where result is discarded. -- Aidan Kehoe
-- Improve: Refactor to use #'labels for efficiency. -- Aidan Kehoe
-- Improve: Remove #'bind-inits and fix up related functions. -- Aidan Kehoe
-- Improve: Remove .elc from 'binary-file-regexps, and ensure all .elcs have coding cookies. -- Aidan Kehoe
-- Improve: Remove MULE-only cases from non-MULE code. -- Stephen Turnbull
-- Improve: Remove all autoload cookies from dumped files. -- Aidan Kehoe
-- Improve: Remove obsolete LOSING_BYTECODE compile-time option. -- Aidan Kehoe
-- Improve: Remove obsolete syntax code parsing macros. -- Stephen Turnbull
-- Improve: Remove superfluous GCPRO in sublis. -- Aidan Kehoe
-- Improve: Remove support for generating Emacs 19-compatible bytecode. -- Aidan Kehoe
-- Improve: Rename INT to FIXNUM. -- Aidan Kehoe
-- Improve: Warning removal. -- Stephen Turnbull
-- New: Refactor sequence code into sequence.c. -- Aidan Kehoe, Vin Shelton

Testing and Debugging

-- Fix: Test leading ?+ in bignum read syntax. -- Aidan Kehoe
-- Fix: Various cases testing changed APIs. -- Aidan Kehoe
-- Fix: pobj printing of symbols and strings with NEW_GC. -- Jerry James
-- Improve: #'substitute-in-file-name tests belong in os, not syntax. -- Stephen Turnbull
-- Improve: Known bug code in test harness. -- Stephen Turnbull
-- Improve: Replace #'flet with #'labels in tests where appropriate. -- Aidan Kehoe
-- Improve: Replace obsolete function names in tests. -- Aidan Kehoe
-- Improve: lisp-maint compliance in syntax-tests.el. -- Stephen Turnbull
-- Improve: pobj falls back to $lrecord_type. -- Marcus Crestani
-- New: File completion-tests.el. -- Aidan Kehoe
-- New: File syntax-ppss-tests.el. -- Mats Lidell
-- New: Syntax cache test. -- Stephen Turnbull, Alan Mackenzie
-- New: Tests for #'byte-compile-catch, bignums, #'labels, #'print-circle, #'apply-partially. -- Aidan Kehoe
-- New: Tests for #'shell-command. -- Mats Lidell

to XEmacs 21.5.31 "ginger"

Major Features and Backward Incompatible Changes

-- improve: Verify copyright status and restrict license to GPL version 3 or later. -- Mats Lidell, Mike Sperber, Stephen Turnbull (see hg log)

to XEmacs 21.5.30 "garlic"

Major Features and Backward Incompatible Changes

-- remove: Last release under GPL v2; future releases will be GPL v3 or later. -- Mats Lidell, Jerry James, Stephen Turnbull, Aidan Kehoe, Ben Wing, Mike Sperber
-- new: Functions may return multiple values as in Common Lisp (incompatible with cl.el implementation in some cases).

User-Visible Bug Fixes and Minor Improvements

-- fix: Crash by registering all CCL programs. -- Aidan Kehoe
-- fix: Crash in PNG handling (issue570). -- Stephen Turnbull
-- fix: Crash in _wgetdcwd(...) when linking against msvcrt8 -- Adrian Aichner
-- fix: Crash in printing if gc_in_progress and in_debug_print -- Ben Wing
-- fix: Crash when printing window with Qt as its buffer. -- Ben Wing
-- fix: Crash when reset_glyph_cachels() is called on the minibuffer window when creating a frame. -- Ben Wing
-- fix: #'gnuserv-edit-files goes to line only if linenumber non-nil. -- It's me FKtPp ;)
-- fix: Make winclient startup more reliable.  -- Vin Shelton
-- fix: Remove dk.xemacs.org from list of package download sites. -- Adrian Aichner
-- fix: issue 546, use #'next-single-char-property-change in list-mode.el -- Aidan Kehoe
-- improve: Exclude the current buffer in switch-to-buffer completion. -- Didier Verna
-- improve: Font locking of Common Lisp source. -- Didier Verna
-- improve: GNU-compatible optional COLUMN in indent-region. -- Aidan Kehoe
-- improve: Handling of coding systems for new or zero-length files. -- Aidan Kehoe
-- improve: Support the precomposed characters with stroke. -- Aidan Kehoe
-- improve: Fallback to whole file in describe-char-unicode-data if database is unreadable. -- Aidan Kehoe
-- improve: Make iso-left-tab equivalent to shift-tab. -- Aidan Kehoe
-- improve: Indentation handling in Lisp modes. -- Ben Wing
-- improve: Name lock symlinks .#FN# for file FN to avoid confusing extensions. -- Ben Wing
-- improve: Set debug-xft to 0. -- Stephen Turnbull
-- improve: Recognize bitmaps/ directory as containing bitmap files. -- Didier Verna
-- new:  Use `emacs-data-roots' instead of `emacs-roots' where appropriate. -- Mike Sperber
-- new: The `absolute' property for background pixmaps. -- Ben Wing
-- improve: Match X11 bgcolor fallback of default face to gui element face. -- Didier Verna
-- new: The background-placement face property. -- Didier Verna

Build Infrastructure and Source Tree

-- fix: Cygwin and MinGW need -export-all-symbols. -- Ben Wing
-- fix: Cygwin needs pdump -- Jerry James
-- fix: Windows link if --with-msw=no in modules. -- Ben Wing
-- improve: Use cygwin_conv_path() when available. -- Ben Wing
-- improve: make-mswin-unicode.pl Cygwin header compatibility, overridden prototypes, `review' command. -- Ben Wing, Vin Shelton
-- improve: Darwin needs system malloc, s&m moved into configure. -- Stephen Turnbull
-- fix: Turn warnings (disabled by accident) back on. -- Ben Wing
-- improve: C++/G++ detection and configuration. -- Ben Wing
-- fix: XE_COMPLEX_ARG registration of options in _AC_USER_OPTS (fixes "unknown option" warnings). -- Stephen Turnbull
-- improve: Clean more build and debug products. -- Stephen Turnbull
-- improve: Don't install silly symlinks when $(prefix) != $(exec_prefix). -- Mike Sperber
-- improve: Installation log refers to "Xft feature" for safer grepping. -- Ben Wing
-- improve: Paths configuration. -- Mike Sperber
-- improve: Use HAVE_CONFIG_H to find config.h and prototypes. -- Ben Wing
-- improve: `--with-error-checking' means `--with-error-checking=all'. -- Ben Wing
-- improve: make-src-depend. -- Ben Wing
-- improve: ndbm configuration -- Karl Kleinpaste, Stephen Turnbull, Ben Wing
-- refactor: New targets config-changed, fix-perms -- Ben Wing
-- refactor: Rename all enable-FOO variables to with-FOO. -- Ben Wing
-- remove: Support for InfoDock, NeXTstep, old Ultrix, SCO Unix, Bull DPX/2, Data General Unix, RTU, Unisoft Unix, OffiX DND, dynodump, idd, sparcworks,  NEC EWS. -- Jerry James
-- remove: Wise installer subtree, netinstall subtree, many files: ppc.ldscript, make-msgfile.c, make-po.c, yow.c, rcs-checkin, gnudepend.pl, leditcfns.c, wakeup.c -- Jerry James, Mats Lidell

Documentation

-- fix: Comment, docstring, and string non-syntactic defects and formatting. -- Stephen Turnbull, Ben Wing, Aidan Kehoe, Didier Verna
-- improve: --quick-build, --with-debug, and --with-error-checking option help. -- Ben Wing
-- improve: Bignum and fixnum correctness in manual. -- Aidan Kehoe
-- improve: Change "special form" to "special operator". -- Aidan Kehoe
-- improve: Docstrings for #'cadr, #'caddr, #'cadddr, #'debug-on-error, #'eval-when-compile, #'eval-and-compile, #'interactive, #'lisp-indent-specform, #'range-table-type, defun movement, #'make-coding-system-internal, #'make-syntax-table, docstring/formal argument matching. -- Stephen Turnbull, Aidan Kehoe, Ben Wing
-- improve: FAQ describes repositories and VCS usage. -- Stephen Turnbull
-- improve: Internals nodes on magic symbols, hash tables, finalizer methods, the new allocator, the new garbage collector, old-style DFC conversion macros, the different types of character and their uses, frame handling, window-system support, allocation of Lisp objects, sequence/list functions and their keywords. -- Marcus Crestani, Ben Wing, Aidan Kehoe
-- improve: PROBLEMS describes crash on recent Cygwin 1.7. -- Ben Wing
-- improve: PROBLEMS describes duplicate symbol warnings on Mac OS X. -- Stephen Turnbull
-- improve: Show the double-quotes in the sample output correctly for function-arglist. -- Aidan Kehoe
-- improve: Startup paths, Lisp, Emacs.ad, xemacs.1 reflect the change from `lib' to `share' for the architecture-independent directories. -- Mike Sperber, Jerry James
-- improve: Treatment of hex and octal character escapes. -- Aidan Kehoe
-- refactor: Move term.texi to the eterm package. -- Jerry James
-- refactor: Remove custom.texi. -- Jerry James

Lisp API

-- fix: #'autoload-featurep-protect-autoloads always inserts a coding-system cookie. -- Ben Wing
-- fix: #'compare-strings coerces bounds to be within strings -- Stephen Turnbull
-- fix: #'insert-file-contents always sets the buffer coding system. -- Aidan Kehoe
-- fix: #'letf checks whether arguments to #'values are bound, and make them unbound after evaluating BODY. -- Aidan Kehoe
-- fix: #'next-list-mode-item, #'switch-to-completions pay attention to non-text-property extents. -- Aidan Kehoe
-- fix: #'pre-display-buffer-function is not set to `get-frame-for-buffer'. -- Michael Sperber
-- fix: Add argument information built-in special operators. -- Aidan Kehoe
-- fix: Allow	deleting windows in `post-command-hook'. -- Michael Sperber
-- fix: Argument annotations of For, Fand, Fif, Fwhen, Fcond, Fprogn, Fprog1, Fprog2, FletX, Flet, Fwhile, Fdefvar, Fdefconst, Frun_hooks, Frun_hooks_with_args, Frun_hooks_with_args_until_success, Frun_hooks_with_args_until_failure -- Aidan Kehoe
-- fix: Argument handling in make-autoload. -- Mike Sperber
-- fix: Canonicalize spaces in argument lists for function-documentation-1. -- Ben Wing
-- fix: Correct error in specifier canonicalization -- Aidan Kehoe
-- fix: Disable specifier memory-usage stats due to circularities. -- Ben Wing
-- fix: Ffunctionp does not return t for special operators. -- Aidan Kehoe
-- fix: Fnbutlast, Fbutlast accept dotted lists. -- Aidan Kehoe
-- fix: Initialize ?\012 as whitespace -- Aidan Kehoe
-- fix: Issue145: Allow default-network-coding-system and default-process-coding-system to be nil. -- Stephen Turnbull
-- fix: Many bugs revealed by Paul Dietz's test suite. -- Aidan Kehoe
-- fix: Search for Control-1 chars in boyer_moore() -- Ben Wing
-- fix: Signal a read error upon encountering a ratio constant with a zero denominator. -- Jerry James
-- improve: #'beginning-of-defun, #'end-of-defun behavior customizable via beginning-of-defun-function, end-of-defun-function. -- Andreas Roehler
-- improve: #'cd use of cd-path and CDPATH. -- It's me FKtPp ;), Aidan Kehoe
-- improve: #'ceiling, #'floor, #'round, #'truncate, #'fceiling, #'ffloor, #'fround, #'ftruncate: support Common Lisp, including optional DIVISOR arguments, returning multiple values, obey contamination rules, round towards the even number in ambiguous cases. -- Aidan Kehoe
-- improve: #'coerce takes 'fixnum as a destination type.  -- Aidan Kehoe
-- improve: #'list-length, #'remf, #'getf, #'tailp, #'cl-set-getf, #'cl-do-remf, #'ldiff, #'endp, #'subseq (new, Common Lisp compatible). -- Aidan Kehoe
-- improve: #'char<, #'char>=, #'char>, #'char<=, #'alpha-char-p, #'graphic-char-p, #'standard-char-p, #'char-name, #'name-char, #'upper-case-p, #'lower-case-p, #'both-case-p, #'char-upcase, #'char-downcase, #'integer-length (new, Common Lisp compatible). -- Aidan Kehoe
-- improve: #'mapvector, #'mapconcat, #'mapcar to support multiple SEQUENCES and error with circular lists -- Aidan Kehoe
-- improve: #'nreverse, #'reverse accept any sequence. -- Aidan Kehoe
-- improve: #'try-completion, #'suggest-key-bindings, #'float-time, #'substring-no-properties, #'turn-off-auto-fill, #'describe-char-unihan-field-descriptions (GNU compatibility). -- Aidan Kehoe, Malcolm Purvis, Mike Sperber
-- improve: #remove*, #cl-delete-duplicates, #delete-duplicates, #'symbol-file, #'find-function. -- Aidan Kehoe
-- improve: 'buffer-display-count, 'buffer-display-time (new, GNU-compatible) -- Jeff Sparkes, Aidan Kehoe
-- improve: 'discarded-consing, 'quoted-lambda new warning types. -- Aidan Kehoe
-- improve: Accept #B<binary>, #O<octal>, and #X<hex> like GNU Emacs. -- Mike Sperber
-- improve: Accept keywords in the hash table read syntax. -- Aidan Kehoe
-- improve: Handling of object plists, especially processes. -- Aidan Kehoe
-- improve: Keyword arguments handling. -- Aidan Kehoe
-- improve: Turn on load-ignore-out-of-date-elc-files by default -- Ben Wing
-- improve: Type spec handling in coerce, cl-make-type-test -- Aidan Kehoe
-- improve: Use keywords instead of ordinary symbols in some XEmacs-specific functions. -- Aidan Kehoe
-- improve: read-buffer gets new optional argument EXCLUDE.
-- new: #'bytecomp-load-hook. -- Aidan Kehoe
-- new: #'canoncase; use it with chars in internal_equalp. -- Aidan Kehoe
-- new: #'constantly from ANSI Common Lisp, with SBCL extension. -- Aidan Kehoe
-- improve: #device-color-cells (tty_device_system_metrics()) returns metrics for num-color-cells and num-bit-planes (issue757) on TTYs. -- Jeff Sparkes
-- new: #'error-unless-tests-match, #'byte-compile-file-being-compiled, #'compiled-if, #'compiled-when for supporting conditional compilation of different code depending on the presence or absence of features. -- Ben Wing
-- new: #'format-time-string implements Roman month numbers. -- Aidan Kehoe
-- new: #'get-properties. -- Didier Verna
-- new: #'process-get, #'process-put, #'process-plist, #'set-process-plist for GNU compatibility -- Aidan Kehoe
-- new: #'save-some-buffers-action-alist, #'diff-files-for-recover, #'diff-buffer-with-file, -- Mike Sperber
-- new: #'set-window-configuration gets optional `set-frame-size-p' argument. -- Mike Sperber
-- new: #'set-window-pixel-width, #'set-window-pixel-height. -- Mike Sperber
-- new: #'stable-union, #'stable-intersection. -- Ben Wing
-- new: 'debug-xemacs, 'debug-regexps, 'debug-soe, 'debug-xft (was 'xft-debug-level), 'debug-searches (was 'debug-xemacs-searches), 'byte-code-meter, 'byte-metering-on variables for debugging. -- Ben Wing
-- new: Common-Lisp-compatible #'the, #'array-dimension-limit, #array-total-size-limit, #'array-rank-limit, #'equalp (especially in hash tables). -- Aidan Kehoe
-- new: Errors 'invalid-keyword-argument, 'scan-error. -- Aidan Kehoe, Ben Wing
-- new: Implement multiple values a la Common Lisp.  New bytecodes: Bbind_multiple_value_limits, Bmultiple_value_call, Bmultiple_value_list_internal, Bthrow.  Modified bytecodes: BRgotoifnilelsepop, BRgotoifnonnilelsepop. Bcall, Bdup, Bgotoifnilelsepop, Bgotoifnonnilelsepop, Breturn.  New macros: DISCARD_PRESERVING_MULTIPLE_VALUES, POP_WITH_MULTIPLE_VALUES, TOP_ADDRESS, TOP_LVALUE, TOP_WITH_MULTIPLE_VALUES.  Modified macros: DISCARD, POP, TOP.  New functions: Fand, Fcond, Fdefconst, Fdefvar, Feval, Ffuncall, Fif, Flet, FletX, Fmultiple_value_call, Fmultiple_value_list_internal, Fmultiple_value_prog1, For, Fprog2, Fsetq, Fsetq_default, Fsignal, Fthrow, Fvalues, Fvalues_list, Fwhile, Fwith_output_to_temp_buffer.  Modified functions: Fcall_interactively, bind_multiple_value_limits, button_item_to_widget_value, check_if_suppressed, connector, dde_eval_string, evaluate_xpm_color_symbols, execute_help_form, flagged_a_squirmer, glyph_instantiator_to_glyph, gui_item_display_flush_left, gui_item_value, make_multiple_value, mark_multiple_value, menu_convert, menu_descriptor_to_widget_1, multiple-values-limit, multiple_value_aref, multiple_value_aset, multiple_value_call, multiple_value_list_internal, pop_kbd_macro_event, populate_menu_add_item, print_multiple_value, size_multiple_value, syms_of_eval, values2. wv_set_evalable_slot, x_IO_error_handler.  Exported functions: throw_or_bomb_out. New variables: multiple-values-limit, multiple_value_current_limit.  Exported symbols: Qobsolete_throw, Qthrow.  New lrecord_type: multiple_value.  -- Aidan Kehoe
-- new: macro -- Aidan Kehoe
-- refactor:  #'bq-vector-contents, #'bq-list*, #'format-decode removed; #'purecopy aliased to #'identity and uses removed. -- Aidan Kehoe
-- refactor: #'byte-compile-compiled-obj-to-list, #'custom-declare-variable-list removed. -- Aidan Kehoe
-- refactor: #'car-less-than-car, #'cdr-less-than-cdr move to format.el, #'list* moved to subr.el. -- Aidan Kehoe
-- refactor: #'ceiling*, #'floor*, #'round*, #'truncate* obsoleted. -- Aidan Kehoe
-- refactor: #'cl-function-arglist takes exactly one arg. -- Ben Wing
-- refactor: #'init-file-user, #'pui-add-install-directory, #'user-original-login-name, #'isearch-yank-x-selection, #'isearch-yank-x-clipboard removed. -- Ben Wing.
-- refactor: #'paths-filter, #'paths-uniq-append removed.  -- Aidan Kehoe
-- refactor: #'show-buffer, #'buffer-flush-undo, #'buffer-local-value, #'x-color-values, #'mswindows-color-list, #'Info-default-directory-list, #'line-beginning-position, #'line-end-position, #'obsolete-throw, #'cl-mapc, #'byte-code-function-p, #'interactive-form, #'assq-delete-all, #'makehash, #'display-column-mode obsoleted. -- Ben Wing

Internal API and Implementation

-- fix: #'canna-henkan-begin. -- Ben Wing
-- fix: #'condition-case gets correct syntax in #'progress-feedback-dispatch-non-command-events. -- Stephen Turnbull
-- fix: #'custom-variable-prompt checks explicitly for nil before for symbol. -- Aidan Kehoe
-- fix: #'delete-duplicates compiler macro and calls to it. -- Aidan Kehoe
-- fix: #'eql Byte-compilation -- Aidan Kehoe
-- fix: #'eql for extended number types and the hash implementation -- Aidan Kehoe
-- fix: #'fc-name-unparse memory leak. -- Jerry James
-- fix: #'fill is much more careful about resizing a string argument. -- Aidan Kehoe
-- fix: #'finish-set-language-environment generation of display-table entries for error octet characters. -- Ben Wing
-- fix: #'with-trapping-errors gets correct :operation arguments in #'font-lock-pre-idle-hook and #'find-tag-default. -- Stephen Turnbull
-- fix: #83, #8C mapping in koi8-c, #A6 mapping in viscii. -- Ben Wing, Aidan Kehoe
-- fix: Bignum initialization and finalization. -- Jerry James
-- fix: Buffer overrun (issue630). -- Stephen Turnbull, Aidan Kehoe
-- fix: Build failure, Apple's g++-4.0.1, Mac OS 10.4. -- Aidan Kehoe
-- fix: Call MODE-mode for -*-MODE-*- only if it has a function binding. -- Aidan Kehoe
-- fix: Call character_to_event() on characters received from XIM. -- Aidan Kehoe
-- fix: Check for Xft before using it, fixing openSUSE bug #558764. -- Stephen Turnbull
-- fix: Coding system initialization. -- Aidan Kehoe
-- fix: Compile errors under C++ and/or Visual Studio 6 in syswindows.h. -- Ben Wing
-- fix: Computation of fastmap in charset_mule_not() -- Ben Wing
-- fix: Conditionalize COM support on HAVE_MS_WINDOWS -- Ben Wing
-- fix: Don't use Boyer-Moore for case-insensitive search if the search pattern contains repeated Ibytes. -- Aidan Kehoe
-- fix: Fall back from GTK to X11 in gnuclient. -- Aidan Kehoe
-- fix: Frame geometry (especially pixelized) to make it a bit easier to understand and fix some bugs. -- Ben Wing
-- fix: Function prototype/definition mismatches. -- Ben Wing
-- fix: GCPROing. -- Ben Wing, Aidan Kehoe
-- fix: GNU coding standards in modules/base64. -- Ben Wing
-- fix: Handling of errors in bytecode.c and floatfns.c. -- Jerry James
-- fix: Handling of escape characters when splitting strings. -- Aidan Kehoe
-- fix: Handling of possible meta characters (?\x80-?\xFF) -- Aidan Kehoe
-- fix: I18N encapsulation commands for Windows. -- Ben Wing
-- fix: Initialize `result' before calling FcFontMatch in Ffc_font_match and xft_find_charset_font -- Jerry James
-- fix: Integer canonicalization. -- Aidan Kehoe
-- fix: Integer overflow when allocating image memory -- Jerry James
-- fix: JPEG macro FAR conflict in eimage code. -- Vin Shelton
-- fix: Match integer sizes in assignment in read_event_from_tty_or_stream_desc -- Ben Wing
-- fix: Missing includes to termcap.c. -- Aidan Kehoe
-- fix: Missing names and ISO 639 codes for Arabic, Russian, and Thai. -- Stephen Turnbull
-- fix: Move CYGWIN_HEADERS to s/cygwin32.h and s/mingw32.h, fixing some compile problems. -- Ben Wing
-- fix: Move HAVE_SCROLLBARS test so the code can compile under Visual Studio 6. -- Vin Shelton
-- fix: Notices in aclocal.m4, ad2c, build-msw-release.sh, compface.mak, cvtmail.c, easymenu.el, elhash.c, emacs.c, emodules.texi, europe-theme.el, example-theme.el, external-widget.texi, fakemail.c, font.el, fontconfig.el, frame.el, glade.c, glyph-test.el, gnome.el, gnuserv.c, gnuserv.h, gnuslib.c, gtk test files, gtk-compose.el, gtk-glue.c, gtk-marshal.el, gtk-package.el, gtk-widget-accessors.el, gtk-xemacs.c, gtk-xemacs.h, gtk.el, gutter-items.el, gutter-test.el, gutter.el, hyper-apropos.el, insert-data-in-exec.c, installexe.sh, lao.txt, lwlib-internal.h, m/alpha.h, make-path.c, menu-items.el, modules/sample/external/Makefile.in.in, modules/sample/external/configure.ac, modules/sample/external/sample.c, modules/sample/internal/sample.c, mule/canna-leim.el alist.el, mule/kinsoku.el, multicast.el, number*.[ch], profile.c, regressiontest.pl, reproduce-crashes.el, s/hpux11-shr.h, s/mach-bsd4-3.h, s/sco7.h, s/sco7.h, sigpipe.c, site-load.el, symsinit.h, tcp.c, term/bg-mouse.el, term/sup-mouse.el, term/vt100.el, test-ew-motif.c, test-ew-xlib.c, tests/external-widget/Makefile, tiff.mak, ui-byhand.c, ui-gtk.c, ui-gtk.h, view-less.el, xemacs.rc, and xpm.mak. -- Jerry James, Stephen Turnbull
-- fix: Parse UNUSED and USED_IF right in make-docfile.c -- Stephen Turnbull
-- fix: Prune correct number of entries from load-history. -- Aidan Kehoe
-- fix: Qlist, Qstring mistakenly declared twice. -- Ben Wing
-- fix: Simplify assertion in event_pixel_translation for Visual C 6. -- Vin Shelton
-- fix: Synchronization of window point with current point when switching buffers. -- Michael Sperber
-- fix: Syntax errors in Ffc_config_app_font_add_file and Ffc_config_app_font_add_dir -- Jerry James
-- fix: Type correctness in split_string_by_ichar_1. -- Aidan Kehoe
-- fix: Type correctness of char and Ichar types. -- Ben Wing
-- fix: UTF-8-ize mule-wnnfns.c. -- Ben Wing
-- fix: Upper and lowercase mappings were reversed for some old-Cyrillic chars. -- Ben Wing
-- fix: Use correct timestamp with XSetInputFocus. -- Mike Sperber
-- fix: Use of REGISTER in certain functions. -- Aidan Kehoe
-- fix: Use unencumbered texts in #'split-string-by-char -- Aidan Kehoe
-- fix: Warning elimination. -- Aidan Kehoe, Ben Wing, Jerry James, Stephen Turnbull
-- fix: `escape-quoted' handling of characters in the 0x80 - 0x9F range. -- Ben Wing
-- fix: const handling in fileio.c. -- Ben Wing, Vin Shelton
-- fix: count_with_tail(), FdeleteX(), FremoveX() handling of COUNT argument. -- Aidan Kehoe
-- fix: fontmgr may not use Fsignal() in C, as it may return. -- Ben Wing
-- fix: g++ 4.3 complaints about implicit conversions of const char * to char * -- Ben Wing
-- fix: gif_instantiate() tries harder to find an appropriate GIF colormap. -- Adam Sjøgren
-- fix: gnuserv found in `exec-directory'. -- Michael Sperber
-- fix: gtk_xpm_instantiate() hotspot coordinates are Lisp integers -- Stephen Turnbull
-- fix: integerp byte code gets fixnump semantics. -- Aidan Kehoe
-- fix: lpRemoteName is an XELPTSTR. -- Vin Shelton
-- fix: memmove() substituted for strcpy() in etags.c -- Sjoerd Mullender
-- fix: modeline face avoids using fallbacks. -- Aidan Kehoe
-- fix: module_load() gets one more dereference on f = dll_variable(. -- Stephen Turnbull
-- fix: off-by-one bug in mswindows_link -- Ron Isaacson
-- fix: query_string_font() uses proper domain for cachel updating. -- Didier Verna
-- fix: query_string_geometry() lookup domain. -- Didier Verna
-- fix: realpath() supplied by Darwin used to get the canonical case for filenames. -- Aidan Kehoe
-- fix: resize_string() must not free dumped data. -- Aidan Kehoe
-- fix: staticpro_names() stores actual names. -- Ben Wing
-- fix: ulong_to_bit_string() prints a zero, not the empty string. -- Aidan Kehoe
-- fix: undecided_canonicalize_after_coding() to retain CODESYS info -- Aidan Kehoe
-- fix: unicode_convert() handles very short input strings correctly. -- Aidan Kehoe
-- fix: unicode_query() initializes invalid_lower_limit. -- Ben Wing
-- fix: unicode_query() missing return type. -- Stephen Turnbull
-- fix: xface_normalize() to handle inline data properly. -- Didier Verna
-- improve: #'byte-compile-initial-macro-environment uses #'the and compilable lambda expressions -- Aidan Kehoe
-- improve: #'byte-compile-lambda issues warnings for interactive forms. -- Aidan Kehoe
-- improve: #'cl-prettyprint handles (function ...) specially. -- Aidan Kehoe
-- improve: #'documentation, #'function-documentation-1, #'describe-function-1, #'hyper-apropos-get-doc, #'describe-function, #'function-arglist, #'function-documentation. -- Aidan Kehoe, Didier Verna, Ben Wing
-- improve: #'frame-pixel-height and friends reflect what will happen as of the next redisplay. -- Ben Wing
-- improve: #'function now parallels #'quote. -- Aidan Kehoe
-- improve: #'handle-pre-motion-command-current-command-is-motion. -- Aidan Kehoe
-- improve: #'read-from-minibuffer uses buffer (format " *Minibuf-%d*" (minibuffer-depth)), regardless of depth. -- Aidan Kehoe
-- improve: #'show-memory-usage, #'show-object-memory-usage-stats. -- Ben Wing, Marcus Crestani
-- improve: #'some, #'every used in info.el, format.el, files.el -- Aidan Kehoe
-- improve: #'the may warn at byte-compile time. -- Aidan Kehoe
-- improve: Allocate lrecord arrays in own size class. -- Marcus Crestani
-- improve: Case map handling. -- Ben Wing
-- improve: Colormap handling on Windows. -- Aidan Kehoe
-- improve: Context-specific handling of system coding systems where we used to just use Qnative. -- Ben Wing
-- improve: Cygwin handling of pathname coding systems. -- Ben Wing
-- improve: Dynarr code. -- Aidan Kehoe, Ben Wing
-- improve: Error-checking in Fquote, Ffunction, -- Aidan Kehoe
-- improve: Fontconfig API more complete. -- Stephen Turnbull
-- improve: Hash table's rehash threshold default now based on size and test function. -- Aidan Kehoe
-- improve: Keymap handling. -- Ben Wing	
-- improve: Make error messages better reflect the text that was encountered in read_escape. -- Aidan Kehoe
-- improve: Make sure distinct symbol macros with identical names expand distinctly. -- Aidan Kehoe
-- improve: Mule-ize database.c partially, modules/postgresql, mule-wnnfns.c. -- Ben Wing
-- improve: Optimizations: remove redundant lambdas and interning of symbols for temporary character sets, #'hash-table-key-list, #'hash-table-value-list, #'hash-table-key-value-alist, #'hash-table-key-value-plist, #'read-behavior, #'complement, #'regexp-quote, #'concatenate, #'mapc, #'do-autoload-commands, #'packages-find-package-library-path, #'frame-list, #'extent-descendants, #'buffer-tag-table-files, #'preloaded-file-list, #'device-list, #'proclaim-inline, #'proclaim-notinline, #'inx-available-font-sizes, #'let-specifier, #'pui-add-required-packages, #'mswindows-available-font-sizes, #'modeline-minor-mode-menu, #'minibuf-directory-files, #'handle-pre-motion-command-current-command-is-motion, #'finish-set-language-environment, #'mod*, #'rem*, #'xpm-color-symbols, #'=, #'<, #'>, #'<=, #'>= -- Aidan Kehoe
-- improve: Print the device in a frame structure. -- Aidan Kehoe
-- improve: Qunbound, not Qnil used as second arg to call to syntax_error() -- Ben Wing
-- improve: Remove the TYPE argument from xfree(). -- Ben Wing
-- improve: Replace "obscure" symbol names with uninterned symbols. -- Aidan Kehoe
-- improve: Track type of range tables. -- Ben Wing
-- improve: UTF-8-ize canna/canna_api.c, unicode.el. -- Ben Wing
-- improve: Use external giflib instead of internal GIF support. -- Jerry James
-- improve: Warn or error if (quote ...) or (function ...) quotes more than one object -- Aidan Kehoe
-- improve: emacs_rint() always used for bignum consistency -- Aidan Kehoe
-- improve: emodules_doc_sym() and emodules_doc_subr() take Ascbyte * pointers -- Ben Wing
-- improve: extern Lisp_Object declarations moved -- Ben Wing
-- improve: lrecord UID's get separate UID space for each type.  Display UID's consistently when appropriate. -- Ben Wing
-- improve: print_symbol() escapes symbols that look like ratios. -- Aidan Kehoe
-- improve: put_range_table() becomes O(log n) for adding a localized range. -- Ben Wing
-- improve: specifier_instance_from_inst_list calls call_with_suspended_errors() with ERROR_ME_WARN. -- Aidan Kehoe
-- improve: stat() failure ignored in file_name_completion -- Henrique Martins
-- fix: Bignums handled correctly by NATNUMP, #'member*, #'eql, #'assoc*. -- Aidan Kehoe
-- new: DEFAULT_DIRECTORY_FALLBACK is a directory that should "always" be available; avoid fatal error if the current directory doesn't exist, chdir to DEFAULT_DIRECTORY_FALLBACK instead. -- Aidan Kehoe
-- new: ERROR_CHECK_DYNARR, dynarr_checking_assert(), ERROR_CHECK_ANY. -- Ben Wing
-- new: Macros for getting the size/edges of various rectangles surrounding the paned area. -- Ben Wing
-- new: Symbols for type checks in sequence functions. -- Aidan Kehoe
-- new: Typedefs for PCVOID and PDWORD_PTR for non-Cygwin. -- Ben Wing
-- new: USED_IF_SCROLLBARS, fix warnings. -- Ben Wing
-- new: UTF-8 support in Cygwin. -- Ben Wing
-- new: deadbeef_memory() exported. -- Ben Wing
-- new: pluralize_word(), pluralize_and_append(). -- Ben Wing
-- new: printing_unreadable_lcrecord(). -- Ben Wing
-- refactor: #'byte-compile-file-form so that #'symbol-value and #'load-time-value can be implemented directly. -- Aidan Kehoe
-- refactor: #'byte-compile-funarg-n (new) used to create the various byte-compile-funarg functions, which check for quoted lambdas in given positions. -- Aidan Kehoe
-- refactor: #'capitalize-string-as-title uses #'with-string-as-buffer-contents. -- Ben Wing
-- refactor: #'custom-quote is aliased to #'quote-maybe. -- Aidan Kehoe
-- refactor: #'list-length, #'default-file-system-ignore-case, #'equalp, #'fill, #'sort*, #'merge, #'mapcar*, #'map, #'maplist, #'mapc, #'mapl, #'mapcan, #'mapcon, #'query-coding-region, #'make-coding-system, #'reduce, #'replace, #'some, #'every moved to C. -- Aidan Kehoe
-- refactor: #'notany, #'notevery get compiler macros. -- Aidan Kehoe
-- refactor: #'substring aliased to #'subseq. -- Aidan Kehoe
-- refactor: #if 0 out some unused functions in malloc.c. -- Ben Wing
-- refactor: 'Qcoerce moved to general-slots.h -- Aidan Kehoe
-- refactor: 'default-file-system-ignore-case moved to fileio.c. -- Aidan Kehoe
-- refactor: ARRAYP(), SEQUENCEP(), CHECK_ARRAY(), CHECK_SEQUENCE(), Fbit_vector, Fstring, FmapcarX in lisp.h -- Aidan Kehoe
-- refactor: Always use platform Xmu. -- Jerry James
-- refactor: Bignums get: New macros ROUNDING_CONVERT, CONVERT_WITH_NUMBER_TYPES, CONVERT_WITHOUT_NUMBER_TYPES, MAYBE_TWO_ARGS_BIGNUM, MAYBE_ONE_ARG_BIGNUM, MAYBE_TWO_ARGS_RATIO, MAYBE_ONE_ARG_RATIO, MAYBE_TWO_ARGS_BIGFLOAT, MAYBE_ONE_ARG_BIGFLOAT, MAYBE_EFF, MAYBE_CHAR_OR_MARKER.  New functions ceiling_two_fixnum, ceiling_two_bignum, ceiling_two_ratio, ceiling_two_bigfloat, ceiling_one_ratio, ceiling_one_bigfloat, ceiling_two_float, ceiling_one_float, ceiling_one_mundane_arg, floor_two_fixnum, floor_two_bignum, floor_two_ratio, floor_two_bigfloat, floor_one_ratio, floor_one_bigfloat, floor_two_float, floor_one_mundane_arg, round_two_fixnum, round_two_bignum_1, round_two_bignum, round_two_ratio, round_one_bigfloat_1, round_two_bigfloat, round_one_ratio, round_one_bigfloat, round_two_float, round_one_float, round_one_mundane_arg, truncate_two_fixnum, truncate_two_bignum, truncate_two_ratio, truncate_two_bigfloat, truncate_one_ratio, truncate_one_bigfloat, truncate_two_float, truncate_one_float, truncate_one_mundane_arg.  Modified functions: emacs_doprnt_1, internal_coerce_number, Ffloat, BIGFLOAT_ARITH_RETURN, BIGFLOAT_ARITH_RETURN.  New variable scratch_ratio2. -- Aidan Kehoe
-- refactor: Byte code #o117 is #'subseq, not #'substring. -- Aidan Kehoe
-- refactor: Call init_string_ascii_begin() in FsortX, Ffill. -- Aidan Kehoe
-- refactor: Case sensitivity of file paths via new variables default-file-system-ignore-case, file-system-case-alist, function file-system-ignore-case-p. -- Aidan Kehoe
-- refactor: Coding system initialization.  Rename default-process-coding-system-read -> process-read, default-process-coding-system-write -> process-write, buffer-file-coding-system-for-read -> bfcs-for-read, default-buffer-file-coding-system -> default-bfcs, no-conversion-coding-system-mapping	-> no-conv-cs, unix-no-mule-no-eol-detection -> no-mule-no-eol-detection, unix-no-mule-eol-detection -> no-mule-eol-detection, unix-mule -> mule. -- Ben Wing
-- refactor: Dynarr code. -- Ben Wing
-- refactor: Eliminate bogus special-casing of standard abbrev tables. -- Aidan Kehoe
-- refactor: Fquote_maybe moved from callint.c to eval.c. -- Aidan Kehoe
-- refactor: Fregexp_quote declared in lisp.h. -- Ben Wing
-- refactor: Gutter geometry code. -- Ben Wing	
-- refactor: Link image code only when HAVE_WINDOW_SYSTEM. -- Ben Wing
-- refactor: Lisp objects allocation/declaration simplified; documented in lrecord.h. -- Ben Wing
-- refactor: Lisp objects get advertised API.  Eliminate macros for copying, freeing, zeroing objects, getting their storage size. -- Ben Wing
-- refactor: Move code and comments from lisp.h to text.h. -- Ben Wing
-- refactor: Move creation of utf-8 coding system to unicode.c. -- Ben Wing
-- refactor: Move gap array from extents.c to array.c.  Extract dynarr, gap array and stack-like malloc into new file array.h.  Rewrite range table code to use gap arrays. -- Ben Wing
-- refactor: Move the Thai language environment and the TIS-620 coding system to mule/thai.el; add support for Microsoft's code page 874. -- Aidan Kehoe
-- refactor: NEED_TO_HANDLE_21_4_CODE replacing the previous NO_NEED_TO_HANDLE_21_4_CODE. -- Aidan Kehoe
-- refactor: Redo memory-usage mechanism. -- Ben Wing
-- refactor: Reduce the number of words in an lcrecord from 3 to 2.  New macro NORMAL_LISP_OBJECT_UID() abstracts out the differences between NEWGC and old-GC in accessing the `uid' value from a "normal Lisp Object pointer". -- Ben Wing
-- refactor: Rename EXTERNAL_TO_C_STRING -> EXTERNAL_TO_ITEXT, EXTERNAL_TO_C_STRING_MALLOC -> EXTERNAL_TO_ITEXT_MALLOC, SIZED_EXTERNAL_TO_C_STRING -> SIZED_EXTERNAL_TO_ITEXT, SIZED_EXTERNAL_TO_C_STRING_MALLOC -> SIZED_EXTERNAL_TO_ITEXT_MALLOC, C_STRING_TO_EXTERNAL -> ITEXT_TO_EXTERNAL, C_STRING_TO_EXTERNAL_MALLOC -> ITEXT_TO_EXTERNAL_MALLOC, LISP_STRING_TO_EXTERNAL, LISP_STRING_TO_EXTERNAL_MALLOC, LISP_STRING_TO_TSTR, C_STRING_TO_TSTR -> ITEXT_TO_TSTR, TSTR_TO_C_STRING -> TSTR_TO_ITEXT and change to return result directly rather than as a "return parameter."  Rename C_STRING_TO_SIZED_EXTERNAL -> ITEXT_TO_SIZED_EXTERNAL, LISP_STRING_TO_SIZED_EXTERNAL, C_STRING_TO_SIZED_EXTERNAL_MALLOC -> ITEXT_TO_SIZED_EXTERNAL_MALLOC, LISP_STRING_TO_SIZED_EXTERNAL_MALLOC.  Eliminate SIZED_C_STRING macros in favor of TO_*TERNAL_FORMAT. -- Ben Wing
-- refactor: Rename pixel_to_char_size -> pixel_to_frame_unit_size, char_to_pixel_size -> frame_unit_to_pixel_size, pixel_to_real_char_size -> pixel_to_char_size, char_to_real_pixel_size -> char_to_pixel_size.  Reverse second and third arguments of change_frame_size().  Eliminate old round_size_to_char, and rename round_size_to_real_char -> round_size_to_char.  The set_frame_size() method is now passed sizes in "frame units". -- Ben Wing
-- refactor: Rename src/objects* -> src/fontcolor*. -- Ben Wing
-- refactor: Rename the specifier-font-matching stages -- Ben Wing
-- refactor: Rename write_c_string -> write_cistring, build_intstring -> build_istring, build_string -> build_cistring, build_ext_string -> build_extstring, make_ext_string -> make_extstring, buffer_insert_c_string -> buffer_insert_ascstring, intern_int -> intern_istring -- Ben Wing
-- refactor: Rename: LISP_TO_VOID -> STORE_LISP_IN_VOID, VOID_TO_LISP -> GET_LISP_FROM_VOID.  New functions STORE_VOID_IN_LISP and GET_VOID_FROM_LISP.  Eliminate the use of make_opaque_ptr() in unwind_protect code. -- Ben Wing
-- refactor: Rename: default_face_height_and_width -> default_face_width_and_height and reverse width/height arguments. -- Ben Wing
-- refactor: Separate out regular and disksave finalization, with a separate object method `disksaver'. -- Ben Wing
-- refactor: TTY mapper for faces gets 2 args. -- Stephen Turnbull
-- refactor: USE_XFT* -> HAVE_XFT*. -- Ben Wing
-- refactor: Unused or easily implemented functions Fsave_window_excursion, save_window_excursion_unwind removed.  -- Aidan Kehoe
-- refactor: Use #'string-to-number with the BASE argument instead of #'font-hex-string-to-number, #'display-warning instead of #'font-warn in font.el. -- Aidan Kehoe
-- refactor: Use defcustom in cmdloop.el. -- Aidan Kehoe
-- refactor: Use of syswindows.h. -- Ben Wing
-- refactor: XLIKE contains code common to GTK and X -- Ben Wing
-- refactor: XLIKE_get_gc takes a frame instead of a device as first argument. -- Didier Verna
-- refactor: assert() improved to replace "if (...) ABORT()". -- Ben Wing
-- refactor: bignum_butlast(). -- Aidan Kehoe
-- refactor: change_frame_size_1().  Rename FRAME_BORDER_* to FRAME_INTERNAL_BORDER_*.  Add FRAME_INTERNAL_BORDER_SIZE().  Add FRAME_REAL_TOOLBAR_BOUNDS() and top/left/bottom/right versions.  Rewrite FRAME_*_BORDER_START and FRAME_*_BORDER_END. -- Ben Wing
-- refactor: check_int_range() is now check_integer_range(), taking Lisp_Objects (and thus bignums). -- Aidan Kehoe
-- refactor: cl-macs is loaded if cl-extra.el being loaded interpreted. -- Aidan Kehoe
-- refactor: enum edge_pos (new) with TOP_EDGE, BOTTOM_EDGE, LEFT_EDGE, RIGHT_EDGE; subsume TOP_BORDER, TOP_GUTTER, enum toolbar_pos, enum gutter_pos, etc.  New macro EDGE_POS_LOOP.  New parameter NUM_EDGES. -- Ben Wing
-- refactor: find-file-create-switch-thunk, new macro. -- Aidan Kehoe
-- refactor: find/get_ccl_program() moved functionality out of several functions where it was duplicated. -- Aidan Kehoe
-- refactor: iso-8859-2, windows-1250, iso-8859-3, iso-8859-4, iso-8859-14, iso-8859-15, iso-8859-16, iso-8859-9, macintosh, windows-1252, iso-8859-8, iso-8859-7, windows-1253, iso-8859-5, koi8-r, koi8-u, windows-1251, alternativnyj, koi8-ru, koi8-t, koi8-c, koi8-o, iso-8859-6, windows-1256 are of type fixed-width. -- Aidan Kehoe
-- refactor: shortest_length_among_sequences, new function. -- Aidan Kehoe
-- refactor: test-harness.el moved to lisp/. -- Ben Wing
-- refactor: text_width() method takes a window instead of a frame. -- Ben Wing
-- remove: #'cl-string-vector-equalp, #'cl-bit-vector-vector-equalp, #'cl-vector-array-equalp, #'cl-hash-table-contents-equalp, #'cl-mapcar-many. -- Ben Wing
-- remove: Creation of windows-874 in mule/mule-win32-init.el. -- Aidan Kehoe
-- remove: Deactivate obsolete code in X face initialization. -- Didier Verna
-- remove: Dead code in cl.el. -- Aidan Kehoe
-- remove: OffiX DND support -- Jerry James
-- remove: PDWORD_PTR typedef (unused) from syswindows.h. -- Aidan Kehoe
-- remove: Support for "old" GNU malloc. -- Jerry James
-- remove: Support for emacs versions where keywords are not self-quoting. -- Aidan Kehoe
-- remove: mule/thai-util.el, mule/thai-xtis.el. -- Aidan Kehoe

Testing and Debugging

-- refactor: Clean up KKCC code related to DEBUG_XEMACS.  New macros IF_OLD_GC(), IF_NEW_GC(). -- Ben Wing
-- new: valgrind debugging of allocation gets support. -- Jerry James
-- improve: debug_can_access_memory. -- Ben Wing
-- improve: Print more variables upon --debug-paths. -- Mike Sperber
-- improve: Debug facilities. -- Ben Wing
-- improve: 'debug-xemacs allows exit-to-debugger/assertion failure upon Lisp error during loadup. -- Ben Wing
-- fix: Type consistency between debug and non-debug builds. -- Ben Wing
-- fix: Conditionalize DEBUG_FONTS* definitions on DEBUG_XEMACS, provide empty definitions otherwise. -- Didier Verna
-- improve: .gdbinit.in.in gets file argument to check-xemacs and check-temacs -- Ben Wing
-- fix: lrecord_type_popup_data, lrecord_type_window_configuration from .gdbinit. -- Aidan Kehoe
-- fix: Type detection in gdb pobj and friends. -- Aidan Kehoe
-- fix: @srcdir@ correctness in .gdbinit.in.in -- Ben Wing
-- improve: Generation of src/.gdbinit. -- Ben Wing
-- fix: #'Check-Message comma syntax error. -- Aidan Kehoe
-- fix: .dbxrc looks for test-harness.el in lisp directory. -- Ben Wing
-- fix: Bignum expected errors. -- Aidan Kehoe
-- fix: Check for fixed-width coding systems. -- Aidan Kehoe
-- fix: Correct line endings in tests. -- Ben Wing
-- fix: Don't check the fixed-width coding systems with odd line endings for ASCII-transparency. -- Aidan Kehoe
-- fix: List of character sets in HELLO. -- Aidan Kehoe, Ben Wing
-- fix: Operation of c-tests. -- Ben Wing, Stephen Turnbull
-- fix: Restore mapping for scaron after testing. -- Aidan Kehoe
-- fix: Results must not be written into source file. -- Ben Wing
-- fix: Revert to the original language environment in tests. -- Aidan Kehoe
-- fix: SXEmacs -> XEmacs in lisp-reader-tests.el. -- Stephen Turnbull
-- fix: Set buffer of new file to be non-modified here before killing it. -- Aidan Kehoe
-- fix: Syntax of tests for signaled errors. -- Ben Wing
-- fix: Use utf-8 as file-name-coding-system under Cygwin 1.7+. -- Ben Wing
-- fix: letf test passes. -- Aidan Kehoe
-- improve: #'Assert. -- Ben Wing, Stephen Turnbull, Aidan Kehoe
-- improve: #'test-harness-from-buffer reverses order of "got" and "expected" values. -- Ben Wing
-- improve: Case tests. -- Ben Wing
-- improve: Docs. -- Ben Wing, Aidan Kehoe, Stephen Turnbull
-- improve: Refactor search and regexp tests, file tests. -- Ben Wing
-- improve: Replace asserts in test-format-data-conversion. -- Stephen Turnbull
-- new: #'equalp hash table test, #'define-hash-table-test. -- Aidan Kehoe
-- new: #'equalp. -- Aidan Kehoe
-- new: #'functionp. -- Aidan Kehoe
-- new: #'generate-rounding-output (useful for generating data). -- Aidan Kehoe
-- new: #'mapcar, #'map and #'list-length throw malformed-list. -- Aidan Kehoe
-- new: #'nbutlast, #'butlast with dotted lists, #'ldiff, #'tailp with circular lists, dotted lists. -- Aidan Kehoe
-- new: #'reduce. -- Aidan Kehoe
-- new: (equal "hi there" [hi there]) => nil, not ==> error. -- Aidan Kehoe
-- new: Binding default-process-coding-system to nil. -- Stephen Turnbull
-- new: CODESYS in #'find-file is respected for files without content. -- Aidan Kehoe
-- new: Circularity checking with #'merge. -- Aidan Kehoe
-- new: Clearer error messages from image instantiation. -- Aidan Kehoe
-- new: Common Lisp-compatible multiple values. -- Aidan Kehoe
-- new: Common Lisp-compatible rounding functions. -- Aidan Kehoe
-- new: Control-1 search bug. -- Ben Wing, Aidan Kehoe
-- new: Discard of multiple values in #'mapcar. -- Aidan Kehoe
-- new: Format strings with %b. -- Aidan Kehoe
-- new: More tests of equalp. -- Stephen Turnbull
-- new: Printing symbols with names that look like ratios. -- Aidan Kehoe
-- new: Some multidimensional characters should not use boyer_moore(). -- Aidan Kehoe
-- new: Torture test for case mappings. -- Ben Wing
-- new: Unicode detection with very short inputs. -- Aidan Kehoe
-- new: Variables to control backtraces in tests. -- Ben Wing
-- new: Zero-length files get sane coding system. -- Aidan Kehoe
-- new: escape-quoted for the range U+0000 to U+00FF. -- Stephen Turnbull
-- new: reproduce-crashes.el #12, #13. -- Adam Sjogren, Stephen Turnbull, Jerry James
-- new: split-string-by-char. -- Aidan Kehoe
-- remove: DLL/dltest.c. -- Jerry James
-- remove: Unused binding. -- Ben Wing
-- remove: auc-tex-test. -- Jerry James

to XEmacs 21.5.29 "garbanzo"

Major Features and Backward Incompatible Changes

-- new: (incompatible) with-esc coding systems for 8-bit coding systems -- Aidan Kehoe
-- improve: (incompatible) Avoid errors in substitute-in-file-name -- Aidan Kehoe

User-Visible Bug Fixes and Minor Improvements

-- new: Command-line argument --script (GNU compatible) -- Aidan Kehoe
-- new: Just-in-time Unicode charsets -- Aidan Kehoe
-- new: Support extended mouse buttons -- Mats Lidell
-- new: Support printing big numbers as base 2 -- Aidan Kehoe
-- new: Windows icons -- Dan Polansky, Stephen Turnbull
-- new: write_region_inhibit_fsync -- Aidan Kehoe
-- fix: ?\<newline> caused assert -- Mike Sperber
-- fix: Crash on null font instance -- Aidan Kehoe
-- fix: Cygwin run command needs an extra ShowWindow -- Vin Shelton
-- fix: Frame change pending flag doesn't get reset -- Ron Isaacson
-- fix: GTK key defaults initialized incorrectly -- Aidan Kehoe
-- fix: Little-endian UTF-16 surrogate handling is incorrect -- Aidan Kehoe
-- fix: Off-by-one error in ccl_driver -- Julian Bradfield
-- fix: Printed char table values confuse strings and symbols -- Aidan Kehoe
-- fix: Setting noninteractive window-system to 'stream contradicts docs -- Aidan Kehoe
-- fix: Stage 2 font matching doesn't work for msprinter -- Aidan Kehoe
-- fix: Window grow and shrink weren't quite inverses -- Mike Sperber
-- fix: at_dot in regexps fails on non-ASCII -- Julian Bradfield
-- fix: bigfloat_to_string is very broken -- Jerry James
-- fix: open-database ignores CODESYS -- Aidan Kehoe
-- fix: openbox can't find frame icons -- Henry S. Thompson, Stephen Turnbull
-- fix: set_window_pixsize ignores modeline -- Mike Sperber
-- fix: simple_search would underrun in reverse search -- Stephen Turnbull
-- improve: User variable (including customize) handling -- Aidan Kehoe
-- improve: bind mousewheel by default -- Aidan Kehoe
-- improve: custom-face-prompt suggests faces at point -- Didier Verna, Andreas Rohler

Build Infrastructure

-- new: Check for FcConfig{Get,Set}RescanInterval -- Aidan Kehoe
-- new: Preliminary work to support bundled packages -- Stephen Turnbull
-- new: Support Intel's compiler -- Vin Shelton
-- fix: %WindowsSdkDir%, %MSSddk% weren't checked for headers -- Aidan Kehoe
-- fix: AC_CHECK_LIB was applied to variable -- Andreas Schwab, Mike Fabian, Martin Buchholz
-- fix: Autoload processing might miss some -- Mike Sperber
-- fix: Bad M4 syntax leading to bogus compile failures in configure -- Vladimir Ivanovic, Aidan Kehoe, Martin Buchholz, Stephen Turnbull
-- fix: Check for explicit installation path were bogus -- Mike Sperber
-- fix: Configuration of write barrier failed on Mac OS X/Intel -- Marcus Crestani
-- fix: INFOPATH was not set by configure -- Mike Sperber
-- fix: Inadvertant diversion of 'share' to 'lib' for datadir -- Mike Sperber
-- fix: Make used the wrong finder*.el -- Ville Skyttä
-- fix: Move autoload operator definitions to xemacs-base to handle new operators more easily -- Mike Sperber, Stephen Turnbull
-- fix: Multiple late package directories were allowed -- Stephen Turnbull
-- fix: Typos (bugs) -- Mats Lidell
-- fix: Typos (ugly) -- Stephen Turnbull, Ville Skyttä
-- fix: URL for optional libraries in config.inc.samp -- Mike Sperber
-- fix: dbm and Berkeley db checks -- Hans de Graaf, Aidan Kehoe
-- fix: make-docfile.el sometimes checks wrong dependency -- Aidan Kehoe
-- improve: G++ detection with --xemacs-compiler -- Stephen Turnbull
-- improve: Pointers to package docs in INSTALL -- Stephen Turnbull
-- improve: Use Mercurial tip hash to identify beta builds -- Mike Sperber
-- improve: Use different defaults for --with-xft=yes/no -- Mats Lidell
-- improve: Use pkg-config to find Xft -- Mike Sperber
-- improve: gnudbm is universally called "gdbm" now -- Stephen Turnbull
-- update: Create xe_fst to replace m4_fst (gone in autoconf 2.62) -- Ville Slyttä
-- update: Makefiles for Windows -- Adrian aichner
-- update: PATH defines -- Mike Sperber
-- update: config.guess, config.sub to 2009-02-02 -- Jerry James
-- update: datarootdir conformance -- Mike Sperber
-- update: install.sh is now install-sh, and sync to current FSF -- Jerry James
-- update: nt/xemacs.mak (sync to Unix) -- Adrian Aichner
-- update: support for Visual Studio 2005 manifests in nt -- Vin Shelton

Documentation

-- improve: Description of image files in README -- Stephen Turnbull
-- improve: FAQ -- Stephen Turnbull
-- improve: HELLO uses UTF-8 for Arabic -- Aidan Kehoe
-- improve: Internals manual -- Stephen Turnbull, Ville Skyttä, Aidan Kehoe, Adrian Aichner
-- improve: Lisp Reference -- Aidan Kehoe
-- improve: Misc. Texinfo manuals -- Ville Skyttä
-- improve: User Guide -- Aidan Kehoe
-- improve: xemacs.1 -- Shyamal Prasad
-- update: Personal info -- Vin Shelton, Didier Verna

Lisp API

-- new: Support hash table lookup in CCL -- Dave Love, Aidan Kehoe
-- new: ascii-case-table (GNU API) -- Aidan Kehoe
-- new: bit-vector-to-integer -- Aidan Kehoe
-- new: check-coding-systems-region (API from GNU) -- Aidan Kehoe
-- new: debug-xemacs-searches -- Aidan Kehoe
-- new: encode-coding-char (GNU API) -- Aidan Kehoe
-- new: error-sequence-coding-system -- Aidan Kehoe
-- new: fc-pattern-get-or-compute-size -- Mike Sperber
-- new: format-time-string specs %z, %g, %G and %V (GNU sync) -- Shyamal Prasad
-- new: frob-unicode-errors-region -- Aidan Kehoe
-- new: improve ability to describe text (GNU sync) -- Aidan Kehoe
-- new: integer-to-bit-vector -- Aidan Kehoe
-- new: intern-soft DEFAULT argument -- Aidan Kehoe
-- new: make-temp-file (GNU sync) -- Aidan Kehoe
-- new: map-charset-chars (GNU API) -- Aidan Kehoe
-- new: no-fallback flag for specifier instantiation -- Didier Verna
-- new: query-coding-clear-highlights (internal) -- Aidan Kehoe
-- new: query-coding-region -- Aidan Kehoe
-- new: query-coding-string -- Aidan Kehoe
-- new: replace-regexp-in-string handles SUBEXP incorrectly -- Stephen Turnbull
-- new: resize-temp-buffer-window (GNU-compatible alias) -- Aidan Kehoe
-- new: skip-chars-quote -- Aidan Kehoe
-- new: subr-arity (API from GNU) -- Aidan Kehoe
-- new: support auto-autoload of coding systems -- Aidan Kehoe
-- new: system-type-file-name-coding -- Aidan Kehoe
-- new: temp-buffer-resize-mode (GNU API) -- Aidan Kehoe
-- new: unencodable-char-position (GNU API) -- Aidan Kehoe
-- new: unicode-error-default-translation-table -- Aidan Kehoe
-- new: unicode-error-sequence-regexp-range -- Aidan Kehoe
-- new: unicode-error-translate-region -- Aidan Kehoe
-- new: with-case-table (GNU sync) -- Aidan Kehoe
-- fix: Map all Big5 characters -- Aidan Kehoe
-- fix: ascii-case-table called put-case-table-pair incorrectly -- Aidan Kehoe
-- fix: check-coding-systems-region returned wrong value -- Aidan Kehoe
-- fix: coding-system-for-read defaults to undecided -- Mike Sperber
-- fix: custom-save-all can corrupt GNU code in .emacs -- Jason Spiro, Aidan Kehoe
-- fix: custom-theme-reset-internal called get incorrectly -- Stephen Turnbull
-- fix: display-graphic-p could pass an invalid device -- Aidan Kehoe
-- fix: expand-region-abbrevs is case-sensitive -- Adrian Aichner
-- fix: insert-file-contents and load called substitute-in-file-name -- Mike Sperber
-- fix: leim-list-file-name wasn't used -- Aidan Kehoe
-- fix: revert-buffer, recover-file set modiff in Mule -- Aidan Kehoe
-- fix: setenv gets confused by implicit abbrev table -- Aidan Kehoe
-- fix: special-form-p errors on subrs -- Jerry James, Aidan Kehoe
-- fix: split-window and delete-window can be broken by advice -- Henry S. Thompson
-- fix: write-region can give bogus results with coding system symbols -- Aidan Kehoe
-- fix: x-color-list-internal didn't return a list of strings -- Stephen Turnbull
-- fix: x_init_device maybe used uninitialized variables -- Jerry James
-- improve: CODING-SYSTEM-OR-MUSTBENEW argument to write-region (GNU compatibility) -- Aidan Kehoe
-- improve: Distinguish can't find pixmap from don't have method -- Didier Verna
-- improve: Maybe use bignums in file-attributes -- Aidan Kehoe

Internal API and Implementation

-- new: 8-bit coding systems in CCL -- Aidan Kehoe
-- new: Bind shift-delete to kill-primary-selection -- Aidan Kehoe, Glynn Clements
-- new: English environments with Windows-1252 and UTF-8 -- Aidan Kehoe
-- new: Implement invalid octet sequence handling in codecs -- Aidan Kehoe
-- new: Implement safe-charsets and safe-chars -- Aidan Kehoe
-- new: Installation-file-coding-system -- Aidan Kehoe
-- new: TYPE argument for symbol-file (GNU API) -- Aidan Kehoe
-- new: UTF-32 coding systems -- Aidan Kehoe
-- new: vars_of_console_gtk -- Aidan Kehoe
-- new: version.el, refactored from loadup.el -- Aidan Kehoe
-- fix: 64-bit cleanliness -- Stephen Turnbull, Aidan Kehoe
-- fix: Argument order in query-coding-string was wrong -- Aidan Kehoe
-- fix: Assertion in make-docfile: Visual C++ doesn't think Unix line endings are text -- Aidan Kehoe
-- fix: Buffer overflow in doprnt -- Sebastian Freundt, Aidan Kehoe
-- fix: Buffer overrun in pdump_load -- Nix
-- fix: Build chokes on deprecated LDAP API -- Mats Lidell
-- fix: Changing load-file-name-internal is bad news -- Aidan Kehoe
-- fix: Checking Qunbound fails to catch unspecified charset -- Aidan Kehoe
-- fix: Comments reference long-defunct mocklisp -- Aidan Kehoe
-- fix: Config-dependent defuns wrapped in eval-when-compile -- Aidan Kehoe
-- fix: Cygwin >=1.7 doesn't like widechar interfaces -- Vin Shelton
-- fix: Cygwin warning on undefined __STDC_VERSION__ -- Aidan Kehoe
-- fix: Decode Installation-string -- Aidan Kehoe
-- fix: Document that query-coding-clear-highlights can take a string -- Aidan Kehoe
-- fix: Dynarr_add used where Dynarr_increment is needed -- Jerry James
-- fix: EOF handled incorrectly in ccl_driver -- Ken'ichi Handa, Aidan Kehoe
-- fix: Fmswindows_short_file_name, Fmswindows_long_file_name should not have interactive specs -- John Paul Wallington
-- fix: Functions can be called if not fboundp -- Aidan Kehoe
-- fix: GCC 4.3 warning elimination -- Stephen Turnbull
-- fix: Handle missing directory for init files -- Aidan Kehoe
-- fix: Image init assigns to rvalues in GTK -- Ville Skyttä, Dominique Quatravax
-- fix: Incompatibilities in image libraries on Win32 -- Aidan Kehoe
-- fix: Initialize Cygwin X and X.org (as XFree86) -- Aidan Kehoe
-- fix: Language environment set up -- Aidan Kehoe
-- fix: Local hooks sometimes aren't -- Didier Verna
-- fix: Many faces need defvars; add some -- Hans de Graaf, Vin Shelton
-- fix: Memory leaks -- Jerry James, Aidan Kehoe
-- fix: Migration can corrupt init files -- Mike Sperber
-- fix: Mismatched parens in ut-log-text -- Paul Keusemann
-- fix: Modifying build-in-face-specifiers is bad news -- Aidan Kehoe
-- fix: Nonrepresentable character caused assert in Boyer-Moore -- Aidan Kehoe
-- fix: Numeric overflow in recompute_need_to_garbage_collect -- Nix
-- fix: Saved windows save buffer point, but shouldn't -- Mike Sperber
-- fix: Stream and TTY image conversion rules don't make sense -- Didier Verna
-- fix: Turkish is ISO-8859-9, not -5 -- Aidan Kehoe
-- fix: Undocumented internal Xt functions were used -- Kenny Chien
-- fix: Unused parameter warnings -- Jerry James
-- fix: Use escape-quoted when needed, add cookie to .elcs -- Aidan Kehoe
-- fix: Warning elimination in Canna module -- Stephen Turnbull
-- fix: Warnings and breakage vs. POSIX/C9X functions on Windows -- Aidan Kehoe
-- fix: We don't have jit-lock-mode, needs if-fboundp -- Aidan Kehoe
-- fix: Window configuration handling -- Henry S. Thompson, Mike Sperber
-- fix: XCHAR_OR_INT invoked with side effects in ccl_driver -- Mike Fabian, Aidan Kehoe
-- fix: XftFont memory leak -- Jerry James
-- fix: abbrev file coding is wrong -- Aidan Kehoe
-- fix: autofilling of comments -- Didier Verna
-- fix: build-report.el doesn't understand Mercurial id -- Mike Sperber
-- fix: byte-compile-file encoding was vulnerable to latin-unity -- Stephen Turnbull
-- fix: face DEFAULT_INDEX is not necessarily 0 -- Didier Verna
-- fix: file-name-coding-system and its alias -- Aidan Kehoe, Katsumi Yamaoka
-- fix: function-key-map was incorrect for xfree86 and sun -- Aidan Kehoe
-- fix: gnuserv needs to quote temp-directory -- Mike Sperber
-- fix: isearch highlights matches during keyboard macro -- Aidan Kehoe
-- fix: iso-8859-1 on non-Mule breaks EOLs -- Aidan Kehoe, Stephen Turnbull
-- fix: lost docs due to functions not at toplevel -- Aidan Kehoe
-- fix: make-src-depend fails with Perl 5.10 -- Mike Sperber
-- fix: modeline-update-tty-frame-specifier calls non-existent frame-tty-p -- Ron Isaacson
-- fix: mouse-read-file-name-1 inconsistent with resize-minibuffer-mode -- Mike Sperber
-- fix: msprinter specifier tag needs to be always available -- Aidan Kehoe
-- fix: mswindows-font-regexp is too strict -- Aidan Kehoe
-- fix: other-frame cycles through too many (all) frames -- Ron Isaacson
-- fix: po is not Polish -- Aidan Kehoe
-- fix: raw-text isn't TRT in detected_coding_system -- Mike Sperber
-- fix: startup code was usurping device-specific roles -- Aidan Kehoe
-- fix: winclient didn't try hard enough to connect -- Vin Shelton
-- fix: xm_update_progress crash (missing values) -- Stephen Turnbull
-- improve: Add locale information for many languages -- Aidan Kehoe
-- improve: Add package-get-download-sites -- Adrian Aichner
-- improve: Always provide x, tty, mswindows, msprinter, gtk and carbon as device tags -- Aidan Kehoe
-- improve: Avoid printing spurious gensyms -- Aidan Kehoe
-- improve: Byte compilation warning elimination -- Aidan Kehoe
-- improve: Byte compile lambdas in default menus -- Aidan Kehoe
-- improve: Byte compiler tweaks -- Aidan Kehoe
-- improve: Cyrillic coding and environment support -- Aidan Kehoe
-- improve: Description of bindings in describe-function -- Aidan Kehoe
-- improve: Detect overlong hex escapes in Lisp reader -- Aidan Kehoe
-- improve: Display information functions use accurate device types -- Aidan Kehoe
-- improve: Docstrings and comments -- Stephen Turnbull, Aidan Kehoe, Dider Verna
-- improve: Functions for querying window parameters -- Aidan Kehoe
-- improve: Hash function for (short) lists -- Sebastian Freundt, Aidan Kehoe
-- improve: Identification of source files from Lisp -- Aidan Kehoe
-- improve: Info support for LZMA compression -- Aidan Kehoe
-- improve: Init file migration -- Mike Sperber
-- improve: Interactive spec of lm-synopsis -- Stephen Turnbull
-- improve: Make help distinguish special forms and subrs -- Aidan Kehoe
-- improve: Make preloaded-file-list respect new dependencies -- Aidan Kehoe
-- improve: Maybe inline delete-duplicates -- Aidan Kehoe
-- improve: More characters in x-compose.el -- Aidan Kehoe
-- improve: More debug info from startup-setup-paths -- Mike Sperber
-- improve: NEW_GC implementation (write barrier) -- Marcus Crestani
-- improve: Optimize Feval -- Sebastian Freundt, Aidan Kehoe
-- improve: Optimize binding in some compiled functions -- Aidan Kehoe
-- improve: Optimize feature checks for xemacs, cl, cl-extra, cl-19, and backquote -- Aidan Kehoe
-- improve: Optimize string-to-sequence, string-to-list, string-to-vector (GNU sync) -- Aidan Kehoe
-- improve: Path-finding code now deals with multiple bases -- Mike Sperber
-- improve: Printing of gensyms -- Aidan Kehoe
-- improve: Profiler -- Aidan Kehoe
-- improve: Refactor symbol-file to use defun* and return-from.
-- improve: Remove baroque font initialization for GTK -- Aidan Kehoe
-- improve: Remove commented code -- Stephen Turnbull
-- improve: Remove no-op code -- Jerry James
-- improve: Remove unused functions -- Aidan Kehoe
-- improve: Remove unused {x,gtk}-iso8859-1.el -- Aidan Kehoe
-- improve: Rework display tables as char-tables -- Aidan Kehoe
-- improve: STRBUFFER in replace-match can be a subexpression (GNU sync) -- Stephen Turnbull
-- improve: Suppress experimental tutorials -- Aidan Kehoe
-- improve: Use Boyer-Moore in more cases -- Aidan Kehoe
-- improve: Use delete-duplicates instead of local defuns -- Aidan Kehoe
-- improve: custom-variable-p needs to be a subr -- Aidan Kehoe
-- improve: lambda expression correctness -- Aidan Kehoe
-- improve: load-history -- Aidan Kehoe
-- improve: make-image-specifier -- Aidan Kehoe
-- improve: user options interactive prompting -- Didier Verna
-- improve: x-compose code -- Aidan Kehoe
-- update: Add 'macintosh' as coding system name -- Aidan Kehoe
-- update: FSF address -- Stephen Turnbull
-- update: INLINE_HEADER for C99 semantics -- Jerry James
-- update: Look for "share", not "lib", as data root (FHS) -- Mike Sperber
-- update: Remove automatic-conversion coding system -- Aidan Kehoe
-- update: Remove vscii and viqr coding systems -- Aidan Kehoe
-- update: Rename mule-ccl.el to ccl.el (GNU sync) -- Aidan Kehoe
-- update: Support NOMODIFY in set-buffer-file-coding-systems (GNU API) -- Aidan Kehoe
-- update: Sync API of encode-coding-char to GNU -- Aidan Kehoe
-- update: Sync font lock keyword handling to GNU -- Jerry James
-- update: add-to-list supports compare-fn (GNU sync) -- Brian Palmer, Aidan Kehoe, Stephen Turnbull
-- update: etags to Francesco Potorti's 17.33 -- Stephen Turnbull
-- update: fontconfig has removed some misspelled names -- Aidan Kehoe

Testing and Debugging

-- new: #$ is not modifiable test -- Aidan Kehoe
-- new: 8-bit coding system tests -- Aidan Kehoe
-- new: Case test -- Aidan Kehoe
-- new: Char table printing test -- Aidan Kehoe
-- new: Error condition tests for replace-regexp-in-string -- Stephen Turnbull
-- new: Language environment tests -- Aidan Kehoe
-- new: Lists differing only in order hash differently test -- Aidan Kehoe
-- new: Little-endian Unicode surrogate tests -- Aidan Kehoe
-- new: Symbol documentation tests -- Stephen Turnbull
-- new: Test that revert does not leave buffer-modified-p -- Stephen Turnbull
-- new: Unicode coverage tests -- Aidan Kehoe
-- new: format tests -- Aidan Kehoe
-- new: load-file-name is modifiable -- Aidan Kehoe
-- new: print-gensym-alist tests -- Aidan Kehoe
-- new: query-coding-tests.el -- Aidan Kehoe
-- new: skip-chars-* tests -- Aidan Kehoe
-- new: subr-arity tests -- Aidan Kehoe
-- new: substitute-in-file-name with nonexistent envvar tests -- Aidan Kehoe
-- new: test of at_dot with non-ASCII -- Stephen Turnbull
-- fix: Tried to test symlinks where they don't work -- Aidan Kehoe
-- fix: tests using with-string-as-buffer-contents were doing nothing -- Stephen Turnbull
-- improve: Checked and renamed reproduce-bugs.el as reproduce-crashes.el. -- Stephen Turnbull
-- improve: Silence-message doesn't disable clear-message -- Aidan Kehoe
-- improve: Use make-temp-file where appropriate -- Aidan Kehoe
-- improve: escape-quoted tests -- Aidan Kehoe
-- improve: remove unneeded debug code from tests -- Stephen Turnbull
-- improve: sanity[sic] of CCL tests -- Aidan Kehoe
-- update: Test all 2^21 characters in Mule -- Aidan Kehoe

to 21.5.28 "fuki"

Major Features and Backward Incompatible Changes

-- fix: Check for missing dimensions for default face and window -- Aidan Kehoe, Mike Sperber
-- fix: Crash in PNG error handler -- Stephen J. Turnbull, Ron Isaacson
-- fix: Crash in device-matching-specifier-list -- Stephen J. Turnbull
-- fix: Crash in gtk/x_reset_modifier_mapping -- Aidan Kehoe
-- fix: Crash in linux_play_data_or_file on 64-bit linux -- Hans Graff, Vin Shelton
-- fix: Crash on double-close of fd in pdump -- Steve Higham, Vin Shelton
-- fix: Crash via buffer overflow in doc.c -- Aidan Kehoe, Fabrice Popineau
-- fix: Crash via buffer overrun in init_native_sound -- Jerry James
-- fix: Crash when deleting dialog via window manager -- Stephen J. Turnbull
-- fix: Device type of msprinter is non-window-system -- Aidan Kehoe
-- fix: Float formats overflow output buffer -- Aidan Kehoe
-- fix: Font menu on non-Mule -- Aidan Kehoe
-- fix: ISO 2022 decoding kludges -- Aidan Kehoe
-- fix: Make snarf-documentation robust to nonconforming DOC files -- Aidan Kehoe
-- fix: Non-existent charset ID is specified for a mule-to-unicode call -- Aidan Kehoe
-- fix: Sanity checks before accessing frame in x_set_frame_properties -- Aidan Kehoe
-- fix: Type of arguments to GaugeMercury (related to progress bar crash?) -- Stephen J. Turnbull
-- fix: init_native_sound is called on a msprinter device -- Aidan Kehoe
-- fix: set-buffer-file-coding-system now sets buffer-modified-flag by default -- Aidan Kehoe
-- new: Echo area resizing -- Adrian Aichner, Stephen J. Turnbull

User-Visible Bug Fixes and Minor Improvements

-- fix: Avoid delays in TTY-only builds by checking dispatch event queue -- Aidan Kehoe
-- fix: Avoid looking up variable bindings during GC -- Nix
-- fix: Buffer overruns in gnuclient and gnuslib -- Jerry James
-- fix: Remove references to unimplemented input methods from language environments -- Aidan Kehoe
-- fix: Find modules correctly -- Ville Skyttä, Mike Sperber, Stephen Turnbull
-- fix: Get X11 window property correctly on 64-bit platforms -- Stephen J. Turnbull, Mike Fabian, Takashi Iwai
-- fix: Handle coding system in file insertion in buffer properly -- Mike Sperber
-- fix: Info broke invariant `(equal buffer-file-truename (file-truename buffer-file-name))' -- Stephen J. Turnbull, Nelson Ferreira
-- fix: Lots of tweaking of Windows read-only handling -- Vin Shelton, Benson Margulies
-- fix: Make --unmapped work again -- Malcolm Purvis
-- fix: Make copying of char tables work -- Olivier Galibert, Stephen J. Turnbull
-- fix: Prevent C-z in a gnuclient frame from suspending the process -- Aidan Kehoe
-- fix: Regex for finding command nodes -- Jeff Miller
-- fix: Reversion should check buffer-file-coding-system -- Aidan Kehoe
-- fix: Syntax of guillemets -- Aidan Kehoe
-- fix: Window configuration should not restore window position unless requested -- Nix
-- improve: Better version info in etags -- Stephen Turnbull, Steve Youngs
-- improve: Case table, syntax table information for Cyrillic, Greek -- Aidan Kehoe
-- improve: Face initialization from X resources -- Aidan Kehoe
-- improve: Give x-compose-map an entry for sharp S -- Aidan Kehoe
-- improve: Handling of Asian "full-width" characters on TTY -- Aidan Kehoe
-- improve: Language environment detection from locale -- Aidan Kehoe
-- improve: Look harder for X11 locale-specific app-defaults files -- Malcolm Purvis
-- improve: Make read-quoted-char terminate, not error, on non-character keys -- Aidan Kehoe
-- improve: Sort abbrev database -- Adrian Aichner
-- improve: Support non-ISO Cyrillic keysyms -- Aidan Kehoe
-- improve: Sync etags to pot version 17.26; improve version report -- Stephen J. Turnbull, Steve Youngs
-- improve: Sync etags to pot version 17.32; move improved version report to configure, lose pot version report -- Stephen J. Turnbull
-- improve: Try to rationalize resources of Xft in lwlib -- Stephen J. Turnbull
-- improve: Use short list fixed string registries, not long list pruned by regexp for X11 fonts -- Aidan Kehoe
-- improve: charsets-in-region now in C -- Aidan Kehoe
-- improve: what-cursor-position gives Unicode and Mule information on non-ASCII -- Aidan Kehoe
-- new: Add raw string support like SXEmacs -- Aidan Kehoe
-- new: Find C source files for Lisp primitives -- Aidan Kehoe
-- new: Just-in-time definition of Unicode characters and X keysyms -- Aidan Kehoe
-- update: New package download sites -- Adrian Aichner
-- update: Sync etags to pot_etags_version 17.19 -- Stephen J. Turnbull
-- update: Sync pop[ch] to Emacs -- Jerry James
-- update: Update to 2003 version of ISO 8859-7 table -- Aidan Kehoe

Build Infrastructure

-- fix: Allow lowercase file names in mswin SDK -- Benson Margulies
-- fix: Avoid using Motif for cygwin -- Dr. Volker Zell
-- fix: C is not C++ -- Robert Pluim
-- fix: Check for u_int*_t typedefs -- Dr. Volker Zell
-- fix: Correct help strings, remove obsolete configure.* files -- Stephen J. Turnbull
-- fix: Documentation of --with-error-checking options -- Stephen J. Turnbull
-- fix: Don't call ichar_to_unicode on non-MULE -- Mike Sperber
-- fix: Enable SYSTEM_MALLOC on ppc64, alpha and ia64 systems -- Malcolm Purvis
-- fix: Make user-defined directories work in configure -- Mike Sperber
-- fix: Register --enable and --with forms with the option checking list -- Malcolm Purvis
-- fix: Remove Autoconf 2.13-isms -- Stephen J. Turnbull
-- fix: Revert workaround for now-fixed Cygwin bug of missing d_ino field -- Dr. Volker Zell
-- fix: Typo in configure shell syntax -- Jerry James
-- fix: Use $EGREP, not egrep -- Malcolm Purvis
-- fix: Use new Cygwin XPM lib name -- Rick Rankin
-- fix: Work around m4_cdr change -- Malcolm Purvis
-- fix: `config.status --recheck' bug in Autoconf 2.60/2.61 -- Malcolm Purvis
-- fix: char type correctness -- Vin Shelton, Aidan Kehoe
-- fix: configure debugger init files correctly -- Stephen J. Turnbull
-- improve: Conditionalize GCC warnings on version -- Jerry James
-- improve: Create $srcdir/src/depend if missing -- Stephen J. Turnbull
-- improve: Detect Intel Macs, use POSIX-style write barrier in NewGC -- Marcus Crestani
-- improve: Refactor Canna detection -- Stephen J. Turnbull
-- improve: Setup kit configuration -- Vin Shelton
improvement -- debugger init sources can use XCOMM convention
-- new: Check for utilities that are not on "normal" Solaris PATH -- Stephen J. Turnbull, S L Baur

Documentation

-- fix: Description of kanji read syntax, size of Ichar (now 21 bits) -- Aidan Kehoe
-- fix: Improve docstrings -- Stephen J. Turnbull, Aidan Kehoe
-- fix: Make manual conform to reality -- Malcolm Purvis, Robert Pluim, Aidan Kehoe, Stephen J. Turnbull
-- fix: New compatibility alias string-to-char-list -- Vin Shelton, Ville Skyttä
-- fix: Typo fixes in manual -- Stephen J. Turnbull, Aidan Kehoe
-- fix: Update FSF address -- Jerry James, Stephen Turnbull
-- fix: Update copyrights -- Stephen J. Turnbull
-- improve: Small rephrasing in TUTORIAL.de -- Adrian Aichner, hroptatyr
-- new: Describe X errors when using ssh in PROBLEMS -- Malcolm Purvis
-- new: Describe XFree86 crash in PROBLEMS -- Stephen J. Turnbull, Aidan Kehoe
-- new: Describe how X11R7 loses x11/bitmaps/gray in PROBLEMS -- Stephen J. Turnbull
-- update: Addresses in files and ChangeLogs -- Adrian Aichner, Stephen J. Turnbull

Lisp API

-- fix: Catch error in cloning language environment -- Aidan Kehoe
-- fix: Make shell-command use requested output buffer -- Jerry James
-- fix: xft-version is now DEVAR_CONST_INT.
-- improve: Face initialization and specification -- Aidan Kehoe
-- improve: Make `split-char' available in no-mule -- Aidan Kehoe
-- improve: New unicode-type property of Unicode coding systems -- Aidan Kehoe
-- improve; Partial sync of coding-category stuff to GNU -- Aidan Kehoe
-- improve: Reorganize Mule lisp -- Aidan Kehoe
-- new: Full access to FcConfig objects -- Stephen J. Turnbull
-- new: ccl-compile-mule-to-unicode, ccl-compile-unicode-to-mule, ccl-dump-mule-to-unicode, ccl-dump-unicode-to-mule -- Aidan Kehoe
-- new: deprecate set-charset-registry, charset-registry -- Aidan Kehoe
-- new: font-lock-keywords-alist, font-lock-removed-keywords-alist,  font-lock-add-keywords, font-lock-update-removed-keyword-alist, font-lock-remove-keywords -- Adrian Aichner
-- new: set-charset-registries, charset-registries -- Aidan Kehoe
-- new: x-coverage-instantiator specifier tag identifies Unicode fallbacks -- Aidan Kehoe
-- update: Sync font-lock-add-keywords and font-lock-remove-keywords from GNU Emacs. -- Adrian Aichner

Internal API and Implementation

-- fix: Dead code elimination in font-mgr -- Stephen J. Turnbull
-- fix: Eliminate buffer overflows and NULL pointer references -- Jerry James, Adrian Aichner
-- fix: Memory leaks -- Jerry James
-- fix: Mule correctness with strings passed to warning functions -- Aidan Kehoe
-- fix: Syntax errors -- Aidan Kehoe
-- fix: Typo in string_direct_data_description -- Marcus Crestani
-- fix: Use defined APIs -- Stephen J. Turnbull, Aidan Kehoe
-- fix: Warning elimination -- Stephen J. Turnbull
-- improve: Cache Xrm coding system -- Aidan Kehoe
-- improve: GCPRO correctness -- Aidan Kehoe
-- improve: NewGC fault handling -- Marcus Crestani
-- improve: Reorganize and document separate_textual_runs -- Olivier Galibert, Stephen J. Turnbull
-- improve: 21-bit Mule chars to support JIT charsets -- Aidan Kehoe
-- update: Get Unicode tables with permissive license -- Stephen J. Turnbull, Mike Fabian

Testing and Debugging

-- improve: Sort results of charset-in-* before comparing to expected. -- Aidan Kehoe
-- improve: gdbinit.in recognizes new FcConfig objects -- Stephen J. Turnbull
-- new: Silence-Message macro in test-harness.el -- Stephen J. Turnbull
-- new: Test for ISO-2022 decoder not choking on invalid UTF-8 -- Aidan Kehoe
-- new: Test for copy-syntax-table bug -- Stephen Turnbull, Ralf Angeli
-- new: Test for correct usage of escape-quoted cookie -- Aidan Kehoe
-- new: Test for availability of input methods referenced in language environments -- Aidan Kehoe
-- new: Test raw strings -- Aidan Kehoe
-- new: Test Unicode non-BMP support -- Aidan Kehoe

to 21.5.27 "fiddlesticks"

Major Features and Backward Incompatible Changes

-- fix: better autodetect of ISO 8859 vs. Big5 -- Joachim Schrod
-- fix: shell widget geometry management (metacity maximize bug) -- Stephen J. Turnbull
-- new: read multibyte characters as Unicode instead of Mule -- Aidan Kehoe, Pete Forman

User-Visible Bug Fixes and Minor Improvements

-- fix: separate resources for fcFontName and xftFont, fixes "can't change buffers-tabs font" bug -- Stephen J. Turnbull
-- improve: speed up read of process output -- Tony Bennett
-- improve: support more ALSA versions -- Jerry James
-- new: document Xft font customization in User Guide -- Stephen J. Turnbull
-- new: record load file name information for built-in symbols. -- Aidan Kehoe

Build Infrastructure

-- fix: update MS VC project files -- Adrian Aichner
-- improve: configure.ac: Add stubs for fontconfig configuration. -- Stephen J. Turnbull

Documentation

-- fix: remove obsolete comment at next-line-add-newlines -- Ville Skyttä
-- fix: COPYING: Update to latest upstream version. -- Jerry James
-- improve: comments in fontconfig.el, x-init.el -- Stephen J. Turnbull
-- improve: diagnostics for tab controls -- Stephen J. Turnbull
-- improve: docstrings for CL functions -- Aidan Kehoe
-- improve: geometry diagnostics in RootGeometryManager -- Stephen J. Turnbull,  Francois L'Archeveque
-- improve: reorganize beta.texi -- Stephen J. Turnbull
-- new: internals node for creating new device types -- Stephen J. Turnbull
-- new: read multibyte characters as Unicode in User Guide -- Aidan Kehoe

Lisp API

-- fix: pass a device to x-font-menu-font-data-xft. -- Jerry James
-- fix: typo in code -- Aidan Kehoe
-- improve: GNU sync of goto-line -- Ville Skyttä
-- improve: error and usage messages -- Stephen J. Turnbull
-- improve: fontconfig refactoring  -- Stephen J. Turnbull

Internal API and Implementation

-- fix: 64-bit cleanliness in number.c -- Jerry James
-- fix: 64-bit cleanliness in printing lwlib resources -- Jerry James
-- fix: copy_command_builder left console uninitialized -- Jerry James
-- fix: memory leak in font initialization -- Stephen J. Turnbull
-- fix: remove spurious diagnostics in FcPattern creation -- Stephen J. Turnbull
-- fix: signedness warnings in lwlib -- Jerry James
-- fix: use of char-like types -- Aidan Kehoe
-- fix: we don't support Xft v.1, remove pretense -- Stephen J. Turnbull
-- improve: fontconfig refactoring -- Stephen J. Turnbull

to 21.5.26 "endive"

Major Features and Backward Incompatible Changes

-- Improve: search for package roots on Windows. -- Vin Shelton
-- Improve: support asynchronous finalization, remove explicit finalizers, and support for statistics for explicitly finalized objects. -- Marcus Crestani, Adrian Aichner
-- New: support ALSA sound on Linux. -- Jerry James

User-Visible Bug Fixes and Minor Improvements

-- Fix: GC cursor display in mc-alloc. -- Marcus Crestani
-- Fix: next-error.el vs. compile.el name clashes. -- Malcolm Purvis
-- Fix: restore memory usage stats (fix regexp). -- Marcus Crestani
-- Fix: synch widget-move-and-invoke, used by Gnus. -- Jerry James
-- Fix: uncomment-region in C files. -- Jerry James
-- Fix: use set-text-properties, not remove-list-of-text-properties. -- Jerry James
-- Improve: convert decode-coding-region, encode-coding-region to interactive commands. -- Stephen Turnbull
-- Improve: synch regex failure limits with GNU Emacs, avoiding asserts. -- Malcolm Purvis

Build Infrastructure

-- Fix: eliminate configure idioms obsolete in Autoconf 2.59. -- Jerry James, Ilya Golubev
-- Improve: merge mc-alloc features into --with-newgc. -- Marcus Crestani

Documentation

-- Fix: document dependence of `run-lisp' on os-utils package. -- Mike Sperber
-- Improve: move historical READMEs, etc, to internals.texi. -- Stephen Turnbull

Lisp API

-- Improve: remove dead API (lisp-send-defun). -- Mike Sperber

Internal API and Implementation

-- Fix: add missing do to RETURN_UNGCPRO_EXIT_PROFILING. -- Jerry James
-- Fix: avoid malloc in vdb signal handler. -- Marcus Crestani
-- Fix: broken use of memset in vdb_install_signal_handler. -- Mike Fabian
-- Fix: eliminate bogus pointer to nowhere. -- Stephen Turnbull, Jerry James
-- Fix: malloc size in Dynarr_realloc. -- Marcus Crestani
-- Improve: add internal API to zero uninitialized string. -- Marcus Crestani
-- Improve: dynamic array cleanup, remove duplicate code. -- Marcus Crestani
-- Improve: handle memory shortage in mc-alloc properly. -- Marcus Crestani
-- Improve: mc-alloc APIs now return number of pages processed. -- Marcus Crestani

to 21.5.25 "eggplant"

Major Features and Backward Incompatible Changes

-- Fix: crash due to broken initialization of syntax cache. -- Stephen Turnbull
-- Fix: crash due to incomplete Mule-ization of x_font_instance_truename. -- Stephen Turnbull
-- Improve: configure UI for packages. -- Mike Sperber

User-Visible Bug Fixes and Minor Improvements

-- Fix: default char-syntax of CJK to ?w failed. -- Aidan Kehoe
-- Fix: missing fonts due to MAX_FONT_COUNT = 5000 isn't infinite any more. -- Aidan Kehoe
-- Fix: missing setlocale(3) initialization in Mule. -- Aidan Kehoe
-- Improve: Java support in font-lock. -- Martin Buchholz
-- Improve: Russian C-x processing. -- Aidan Kehoe
-- Improve: use logical "beta" path to downloads. -- Adrian	
-- New: euc-cn coding system alias for cn-gb-2312. -- Aidan Kehoe	
-- Update: package download sites. -- Adrian Aichner

Build Infrastructure

-- Fix: conditionalization of checks for Xft library. -- Mike Sperber
-- Fix: deletion of user-created links in distclean. -- Mike Sperber
-- Fix: reporting of Xft in Installation. -- Stephen Turnbull
-- Improve: cygwin include and no-X Xpm handling in configure. -- Vin Shelton

Documentation

-- Improve: comments. -- Aidan Kehoe, Stephen Turnbull
-- New: node on keyboards with which one can't type Latin. -- Aidan Kehoe
-- Update: Info docs for new package-path configuration syntax. -- Mike Sperber

Lisp API

-- New: rename command and binding in buffer menu mode. -- Stephen Turnbull

Internal API and Implementation

-- Fix: "not char-or-int-p: nil" bug in easymenu. -- Aidan Kehoe
-- Fix: C++ correctness. -- Marcus Crestani
-- Fix: buggy computation of dynarr size. -- Marcus Crestani
-- Fix: char/event confusion introduced by a GNU Emacs sync. -- Aidan Kehoe
-- Fix: missing hardware-specific X11 keycode initialization. -- Aidan Kehoe
-- Fix: syntax errors. -- Andrey Slusar
-- Fix: workaround missing d_ino field from 'struct dirent'. -- Rick Rankin
-- Fix: x_find_charset_font returned Qunboundp inefficiently. -- Aidan Kehoe
-- Fix: x_find_charset_font wasn't Mule-ized. -- Stephen Turnbull
-- Improve: Cygwin support in MC_ALLOC. -- Marcus Crestani
-- Improve: silence redundant gc cache warning. -- Marcus Crestani
-- Improve: syntax cache factoring and documentation. -- Stephen Turnbull

to 21.5.24 "dandelion"
Major features

-- New: Xft font support. -- Stephen J. Turnbull, Aidan Kehoe, Daniel Pittman, Clemens Fruhwirth, Eric Knauel, Matthias Neubauer, Hrvoje Niksic, Olivier Galibert
-- New: incremental garbage collector. -- Marcus Crestani

User-Visible Bug Fixes and Minor Improvements

-- Fix: autoload list-matching-lines. --  Malcolm Purvis
-- Fix: change_window_height must change the window width when requested. -- Aidan Kehoe
-- Fix: crashes printing ISO2022 coding systems. -- Ben Wing
-- Improve: initializations depending on locale or language environment. -- Aidan Kehoe
-- Update: etags to upstream 17.15. -- Malcolm Purvis
-- Update: package download site list. -- Adrian Aichner
-- Update: X11 search paths to include /usr(/local)/share/X11. -- Ville Skyttä

Build Infrastructure

-- Fix build output directory structure on Windows. -- Marcus Crestani
-- Fix: configuration of native sound on Windows. -- Ben Wing
-- Fix: small bugs in configure of AC_INIT and PostgreSQL. -- Stephen J. Turnbull
-- Improve: CVS behavior. -- Stephen J. Turnbull, Marcus Crestani, Malcolm Purvis
-- Improve: treatment and docs XE_COMPLEX_ARGs defaults. -- Malcolm Purvis, Stephen Turnbull
-- Improve: refactor make clean, nuke .elcs. -- Ben Wing
-- New: tests for backward-up-list. -- Stephen J. Turnbull

Documentation

-- Fix: Don't mention standard-syntax-table and standard-category-table. -- Aidan Kehoe
-- Fix: typos. -- Stephen J. Turnbull, Adrian Aichner
-- Improve: Add 'Known Problems' to the Help menu. -- Malcolm Purvis
-- Improve: HELLO in Irish and Tajik. -- Aidan Kehoe
-- Improve: INSTALL. -- Stephen J. Turnbull
-- Improve: consistency of symbol quoting in documentation. -- Ben Wing
-- Improve: docstrings. -- Stephen J. Turnbull
-- Improve: reorganize option list from configure. -- Malcolm Purvis
-- Improve: texi document CVS branching. -- Ben Wing
-- Improve: texi documentation of DEFSYMBOL. -- Stephen J. Turnbull
-- Improve: texi documentation of XEmacs Autoconf macros. -- Malcolm Purvis
-- Improve: update PROBLEMS, and install in etc. -- Malcolm Purvis
-- Update: about Jerry James. -- Stephen J. Turnbull
-- Update: about Malcolm Purvis. -- Malcolm Purvis
-- Update: descriptions of font name syntaxes. -- Stephen J. Turnbull

Lisp API

-- Improve: generalize describe-syntax-table to describe-char-table. -- Ben Wing
-- Improve: memory statistics reporting. -- Marcus Crestani

Internal API and Implementation

-- Fix: C++ build. -- Ben Wing, Marcus Crestani
-- Fix: Mule-ize canna_api module. -- Ben Wing, Stephen J. Turnbull
-- Fix: byte compile by conditional compilation. -- Ben Wing
-- Fix: compilation errors and warnings in GTK code. -- Malcolm Purvis
-- Fix: compile stuff_buffered_input only if HAVE_TTY. -- Malcolm Purvis
-- Fix: help on functions without documentation. -- Ben Wing
-- Fix: integer types for Berkeley db. -- Stephen J. Turnbull, Volker Zell
-- Fix: make modules build on Cygwin and Mac. -- Stephen J. Turnbull, Rick Rankin, Ben Wing
-- Fix: quiet byte-compiler. -- Stephen J. Turnbull
-- Fix: syntax error -- Marcus Crestani
-- Fix: uninitialized local variables. -- Stephen J. Turnbull
-- Fix: use princ, not prin1 in debug print. -- Ben Wing
-- Fix: use uint32_t declaration, fixing build on FreeBSD. -- Steve Youngs, Andrey Slusar
-- Fix: value of MAX_STRING_ASCII_BEGIN under MC_ALLOC. -- Ben Wing
-- Fix: warning elimination, mark UNUSED parameters -- Marcus Crestani, Stephen J. Turnbull
-- Improve: bignum support on mingwin. -- Ben Wing
-- Improve: lrecord uid handling. -- Ben Wing
-- Improve: refactor default_object_printer. -- Marcus Crestani
-- Improve: remove dead code in lwlib. -- Stephen J. Turnbull
-- Improve: reorganize lisp.h. -- Ben Wing
-- Improve: set default syntax class to word. -- Aidan Kehoe, Ben Wing
-- Improve: tabs widget internals. -- Stephen J. Turnbull

to 21.5.23 "daikon"
Major features

-- New: all-singing, all-dancing --with/--enable aliasing.  -- Malcolm Purvis
-- New: native NT support for building gmp, db, postgresql, ldap. -- Ben Wing
-- New: non-XPM color images can be mouse pointers. -- Ben Wing

User-Visible Bug Fixes and Minor Improvements

-- Fix: change address for crash reporting to xemacs-beta. -- Ben Wing
-- Fix: configure requires explicit choice of Motif (from 21.4). -- Malcolm Purvis
-- Fix: crash due to duplicate subrs with MC_ALLOC and modules. -- Marcus Crestani
-- Improve: memory usage reporting, especially with MC_ALLOC. -- Ben Wing
-- Improve: remove obsolete autoconf 2.13 files. -- Malcolm Purvis.
-- Improve: --with-cflags-optimization now forces optimization. -- Ben Wing
-- Update: sync package-get.el mirrors with website. -- Adrian Aichner, Ville Skyttä

Build Infrastructure

-- Fix: Cygwin, non-X build needs XPM header and library files in XE_CFLAGS. -- Mike Alexander, Rick Rankin
-- Fix: guess VC++ version; set debug and browser flags appropriately. -- Ben Wing
-- Fix: pass -I$(SRC) to minitar.c so it compiles. -- Ben Wing
-- Fix: pass module sources, not objects, to make-docfile. -- Ben Wing
-- Fix: stop installexe.sh from adding redundant exe extension. -- Rick Rankin
-- Fix: variable initialization misordering in xemacs.mak. -- Adrian Aichner
-- Improve: Canna API is now a module. -- Stephen Turnbull
-- Improve: delete more stuff in `make clean'. -- Ben Wing
-- Improve: options now added to one OPT_*, rather than many FOO_*, variables. -- Ben Wing
-- Improve: replace support for autoconf 2.13 with warning to use autoconf 2.59. -- Malcolm Purvis
-- Improve: update config.inc.samp to recent versions and add gmp, db, postgresql, ldap support; also optimization in non-debug builds. -- Ben Wing
-- Improve: xemacs.mak now caters to VC++ version,  support for building gmp, db, postgresql, ldap; other fixes. -- Ben Wing

Documentation

-- Fix: force C-h N to find etc/NEWS, not some package's. -- Steve Youngs
-- Fix: texinfmt.el can build all Info files again. -- Adrian Aichner
-- Fix: typos in Texinfo docs. -- Adrian Aichner
-- Improve: Texinfo docs about specifiers. -- Ben Wing
-- Improve: comment style, 'foo -> `foo'. -- Ben Wing
-- Improve: comments and docstrings. -- Stephen Turnbull
-- Improve: document --with/--enable, improve Mac OS X in INSTALL. -- Malcolm Purvis
-- Improve: emodules.texi tells how to add modules to core. -- Stephen Turnbull
-- Improve: FAQ includes examples of 21.5 configure options. -- Malcolm Purvis
-- Improve: nt/README tells how to compile optional libs. -- Ben Wing
-- New: FAQ on `rebaseall' under Cygwin. -- Ben Wing
-- New: internals documents XEmacs treatment of --with/--enable configure args. -- Malcolm Purvis

Lisp API

-- Fix: finder-find-library returns accurate filename. -- Adrian Aichner
-- Fix: xemacs-composefunc kvetching when noninteractive. -- Stephen Turnbull
-- Improve: GC now triggers on relative, not absolute, consing. -- Ben Wing
-- Improve: memory usage reporting. -- Ben Wing
-- Improve: sync build-report.el to Adrian's version. -- Stephen Turnbull
-- Improve: sync read-buffer, line-number-at-pos, delete-dups, occur to GNU Emacs 22.0.50. -- Malcolm Purvis
-- New: batch-build-report command. -- Stephen Turnbull
-- New: inherit properties for faces and custom. -- Ben Wing
-- New: next-error from GNU Emacs. -- Malcolm Purvis
-- New: `specifier-instantiator' and related primitives. -- Ben Wing

Internal API and Implementation

-- Fix: address of register variable can't be taken. -- Ben Wing
-- Fix: asserts in lwlib are now consistent with src. -- Ben Wing
-- Fix: bitrot in sysdep.c and nt.c. -- Ben Wing
-- Fix: bug in range tables with non-default closure. -- Ben Wing
-- Fix: don't use C++ reserved words "new" and "catch", append '_'. -- Ben Wing
-- Fix: initialization in mc-alloc. -- Marcus Crestani
-- Fix: non-MULE needs mswindows_current_locale too. -- Mike Alexander
-- Fix: setlocale return string is volatile, dup it. -- Olivier Galibert
-- Fix: unexec for _LP64 ELF architectures. -- Andrey Slusar
-- Fix: use of config.h, especially in Windows files. -- Ben Wing
-- Improve: refactor MC_ALLOC to reduce #ifdefs. -- Ben Wing
-- Improve: use _CRT_SECURE_NO_DEPRECATE to suppress VC8 warnings. -- Ben Wing
-- Improve: warning elimination. -- Ben Wing, Stephen Turnbull

to 21.5.22 "cucumber"

Major features

-- New: support for Unnnn-style keysyms on X11. -- Aidan Kehoe

User-Visible Bug Fixes and Minor Improvements

-- Fix: window configuration subsystem. -- Michael Sperber, Fabrice Popineau

Build Infrastructure

-- Fix: add generated dumper files to .cvsignore. -- Marcus Crestani
-- Fix: add generated makefiles to .cvsignore in ./modules. -- Craig Lanning

Documentation

-- Fix: lispref - compose processing now goes direct to character, not
   keysym. -- Aidan Kehoe
-- Improve: lispref - Mule explanations. -- Aidan Kehoe
-- Improve: lispref - remove discussion of pure storage, long disabled.
   -- Aidan Kehoe
-- New: lispref - face aliasing. -- Didier Verna

Lisp API

-- New: face aliasing. -- Didier Verna

Internal API and Implementation

-- Fix: DLL implementation for Mac OS X "Tiger". -- Atanu Ghosh
-- Fix: false load path shadows after package update. -- Jeff Mincy,
   Adrian Aichner
-- Fix: make CCL check for existence before using characters. -- Aidan Kehoe
-- Fix: memory descriptions for gap variables for better 64-bit support.
   -- Darryl Okahata
-- Fix: various cleanups for MC_ALLOC. -- Marcus Crestani
-- Improve: use characters instead of keysyms in x-compose.el.  Remove
   iso8859 .els from dumped-lisp.el. -- Aidan Kehoe

to 21.5.21 "corn"

Major features

-- New: An alternative memory allocator. -- Marcus Crestani

User-Visible Bug Fixes and Minor Improvements

-- Fix: Calculations in font-spatial-to-canonical. -- Ralf Angeli
-- Fix: Honor coding system argument when creating a file. -- Aidan Kehoe
-- Fix: Prevent stripping of items from Command menu. -- Ralf Angeli
-- Fix: Selection handling on Win32. -- Fabrice Popineau
-- Improve: Better defaults for mail-user-agent. -- Aidan Kehoe
-- Improve: Deprecate use of Emacs X resource class. -- Aidan Kehoe
-- Improve: Initialize fontlock properly in *scratch*. -- Aidan Kehoe
-- Improve: Make %backup%~ honor auto-save-directory. -- Steve Youngs,
   Jamie Zawinski
-- Improve: Recognize some constructed Unicode keysyms. -- Aidan Kehoe
-- Improve: Synch dired features from GNU Emacs. -- Mike Sperber,
   Richard Stallman, Luc Teirlinck, Stefan Monnier, Andreas Schwab
-- Improve: Syntax and case mapping for ISO 8859 parts 14-16. -- Aidan Kehoe
-- Improve: Warn about unbound Unicode keysyms. -- Aidan Kehoe

Build Infrastructure

-- Fix: Asserts can't contain active code. -- Melvin Hadasht
-- Fix: Avoid "head -#", coreutils doesn't like it. -- Vin Shelton
-- Fix: Build for non-DEBUG_XEMACS native Windows build. -- Marcus Crestani
-- Fix: Cater to OpenBSD /bin/sh. -- Malcolm Purvis
-- Fix: Check $ac_cv_build not $canonical for libossaudio. -- Aidan Kehoe
-- Fix: Define elfw(type) for unexec on Alpha and amd64 for FreeBSD.
   -- Andrey Slusar
-- Fix: Make get-user-response available regardless of config. -- Mike Sperber
-- Fix: Make srcdir absolute, include X header, terminate lines.
   -- Malcolm Purvis
-- Fix: Remove do-nothing --no-gnu-linker in Solaris builds. -- Vin Shelton
-- Fix: Specifying optimization flags implies optimization. -- Stephen Turnbull
-- Fix: Use HAVE_DECL_SYS_SIGLIST, not SYS_SIGLIST_DECLARED. -- Volker Zell
-- Fix: configure needs to include X11/Intrinsic.h to check for Xaw.
   -- Robert Delius Royar, Aidan Kehoe, Jerry James
-- Fix: egetenv needs process.h in device-x.c. -- Marcus Crestani
-- New: Conditionally compile insert-data-in-exec. -- Marcus Crestani

Documentation

-- Fix: Add "--with" prefix in docstrings in configure.ac. -- Aidan Kehoe
-- Fix: Documentation typos. -- Aidan Kehoe, Adrian Aichner
-- Improve: Mention and deprecate atomic extents in docstring. -- Aidan Kehoe
-- Improve: Texinfo docs. -- Aidan Kehoe, Stephen Turnbull, Ben Wing

Lisp API

-- Improve: Use override-redirect to suppress WM decorations.
   -- Stephen Turnbull
-- New: More stats for show-memory-usage. -- Marcus Crestani

Internal API and Implementation

-- Fix: Argument count in issue_call_trapping_problems_warning.
   -- Stephen Turnbull
-- Fix: Avoid use of nonexistent insert-for-yank. -- Aidan Kehoe
-- Fix: Buffer overflow in pdump backtrace array. -- Jerry James
-- Fix: Control-1 handling in CCL. -- Aidan Kehoe
-- Fix: fakemail for FreeBSD >= 4. -- Andrey Slusar
-- Improve: Dynamic diagnostic backtrace for KKCC. -- Marcus Crestani

to 21.5.20 "cilantro"

Major Features

-- New: Handle various X selection targets properly. -- Aidan Kehoe

User-Visible Bug Fixes and Minor Improvements

-- Fix: Handle active regions properly. -- Adrian Aichner
-- Fix: pui-list-packages handles longer filenames. -- Norbert Koch

Build Infrastructure

-- Improve: Port configure to autoconf 2.59. -- Malcolm Purvis
-- Fix: make-docfile.c misparsed UNUSED macro in defuns. -- Stephen Turnbull
-- Fix: Don't copy non-existent BUGS file on NT. -- Adrian Aichner
-- Fix: Typo in PDUMP section of Makefile.in.in. -- Mike Alexander

Documentation

-- Improve: Update info/dir. -- Adrian Aichner
-- Improve: Automate updating of release date in about.el. -- Stephen Turnbull
-- New: about.el entry for Simon Josefsson.  (Simon Josefsson
-- Fix: Typos.  (Adrian Aichner
-- Improve: Sort memory usage report sections by usage. -- Adrian Aichner
-- Improve: Glyphs documentation. -- Ben Wing
-- Improve: Description of build configuration system. -- Malcolm Purvis
-- New: Description of build configuration system. -- Stephen Turnbull
-- New: Lispref node on CCL Example. -- Aidan Kehoe
-- Improve: Describe \c and \C in Syntax of Regexps. -- Aidan Kehoe
-- Improve: Future Work -- Better Rendering Support. -- Stephen Turnbull
-- Improve: Comments. -- Stephen Turnbull, Aidan Kehoe

Lisp API

-- New: GNU semi-compatible decode-char and encode-char.  (Aidan Kehoe

Internal API and Implementation

-- Fix: Avoid consing in operate-on-matching-lines. -- Adrian Aichner
-- Fix: Correctly disable geometry negotiation in tabs widget. -- Stephen Turnbull
-- New: Backtrace feature for KKCC. -- Marcus Crestani
-- Fix: Type casts in database.c. -- Marcus Crestani
-- Fix: Adjust s&m to FreeBSD 6.x reality. -- Andrey Slusar

Quality Assurance Infrastructure

-- New: USED_IF_BIGFLOAT macro. -- Jerry James
-- New: region-tests.el. -- Adrian Aichner
-- New: autoconf/regressiontest.pl. -- Malcolm Purvis

to 21.5.19 "chives"

Major Features

-- Improve: major reorganization of source tree docs. -- Ben Wing
-- Improve: behaviors get new code and many new implementations. -- Ben Wing

User-Visible Bug Fixes and Minor Improvements

-- Fix: security hole (CAN-2005-0100) in movemail. -- Vin Shelton
-- Fix: data truncation in i.c. -- Ben Wing
-- Fix: region deletion bug. -- Stephen Turnbull
-- Fix: crash in Frecord_buffer. -- Yoshiki Hayashi
-- Fix: Metacity maximize bug. -- Stephen Turnbull
-- Fix: data truncation bugs in unix_send_process. -- David Evers, Jerry James
-- Fix: recognise AltGr as a valid modifier in GTK. -- Malcolm Purvis
-- Fix: recognize ISO keysyms. -- Ville Skyttä
-- New: on Windows, dump Unicode tables to allow non-ASCII invocation.
   -- Ben Wing
-- New: splash screen. -- Ben Wing
-- New: support treating shortcuts under Windows as symbolic links. -- Ben Wing
-- Improve: GNU-compatible coding system aliases. -- Aidan Kehoe
-- Improve: help system. -- Ben Wing
-- Improve: mouse-track. -- Ben Wing
-- Improve: support ISO 8859/16 by default. -- Aidan Kehoe

Build Infrastructure

-- Fix: copy BUGS, README, COPYING and Installation on installation on
   Windows. -- Ben Wing
-- Fix: installation for Cygwin. -- Marcus Crestani
-- Fix: various build problems. -- Ben Wing
-- Fix: various things in configure. -- Ben Wing
-- New: default pdump on for Cygwin. -- Marcus Crestani
-- New: support NetBSD sound via Linux API. -- Aidan Kehoe
-- Improve: generation of CFLAGS (Jerry James, Ben Wing
-- Improve: parallel build support. -- Malcolm Purvis
-- Improve: support --package-prefix as simple interface to --package-path
   facility. -- Ben Wing
-- Improve: support mmdf and pop arguments to --mail-locking. -- Ben Wing

Documentation

-- Fix: beta.texi. -- Stephen Turnbull, Robert Royar
-- Fix: typos. -- Alexey Mahotkin, Andreas Eder
-- New: "Future Work -- Better Rendering Support". -- Stephen Turnbull
-- New: "Future Work" collects feature proposals in Internals. -- Ben Wing
-- New: empty ChangeLog entry. -- Ben Wing
-- New: personal photos. -- Malcolm Purvis
-- Improve: Lispref (Shyamal Prasad, Stephen Turnbull, Aidan Kehoe
-- Improve: Users' Guide. -- Ben Wing
-- Improve: about.el. -- Malcolm Purvis, Ben Wing
-- Improve: docstrings. -- Ben Wing, Stephen Turnbull, Adrian Aichner,
   Aidan Kehoe
-- Improve: gnuserv docs. -- Stephen J. Turnbull
-- Improve: incorporate source tree docs in FAQ. -- Ben Wing
-- Improve: major overhauls of FAQ, Internals. -- Ben Wing
-- Improve: various comments. -- Ben Wing

Lisp API

-- Improve: sync bytecomp-runtime.el (make-obsolete, make-obsolete-variable).
   -- Ville Skyttä
-- Improve: sync paragraphs.el, custom.el, subr.el, newcomment.el,
   fill.el, page.el, register.el. -- Ben Wing
-- New: move regexp-opt.el and easy-mmode.el from packages to core. -- Ben Wing
-- New: next/previous-single-char-property-change and make
   next/previous-single-property-change work like in FSF. -- Ben Wing
-- New: xemacs-font-lock-c-keywords and friends. -- Ben Wing

Internal API and Implementation

-- Fix: ^M brokenness in res.rc. -- Ben Wing
-- Fix: adapt to recent changes in Cygwin. -- Ben Wing
-- Fix: byte-char conversion, should speed up Mule if there are
   non-ASCII characters in the buffer. -- Ben Wing
-- Fix: coding cookie recognition in .elc. -- Ben Wing
-- Fix: data-in-executable problems. -- Olivier Galibert, Ben Wing
-- Fix: find-coding-system-magic-cookie-in-file. -- Ben Wing
-- Fix: leaking process handles. -- Ben Wing
-- Fix: only call device method compute_scrollbar_instance_usage() if it
   is defined. -- Zajcev Evgeny
-- Fix: protect callers of MSFT syscalls from MSFT API randomization.
   -- Ben Wing
-- Fix: typos. -- Robert Royar
-- Fix: warnings. -- Aidan Kehoe, Ben Wing
-- New: Hashcode type. -- Ben Wing
-- New: color API. -- Ben Wing
-- New: rename abort() macro to ABORT() to placate VC 7. -- Ben Wing
-- Improve: GCPRO macros. -- Ben Wing
-- Improve: Mule-ize various things. -- Ben Wing
-- Improve: Suppress aliasing warning in free_hook; Jerry says not a fix?
   -- Ben Wing
-- Improve: UNUSED parameter marking, UNO support. -- Malcolm Purvis,
   Jerry James
-- Improve: Unicode-ize various things. -- Ben Wing
-- Improve: critical section protection. -- Ben Wing
-- Improve: debug info on attempt to throw outside of a function where
   call_trapping_problems() has been used. -- Ben Wing
-- Improve: menubar support. -- Ben Wing
-- Improve: more orthogonality in emacs-root-finding. -- Mike Sperber
-- Improve: move etc/aliases.ksh to xemacs-builds CVS module. -- Ben Wing
-- Improve: move etc/chr.png, etc/chrm.png to etc/photos/ (Ben Wing
-- Improve: partially rework Unicode support. -- Ben Wing
-- Improve: path handling correctness. -- Ben Wing
-- Improve: rangetabs get different types of ranges (open/closed start
   and end).  Change default to be start-closed, end-open. -- Ben Wing
-- Improve: refactor Initialization changes: (Ben Wing
-- Improve: refer to init.el not .emacs in menus. -- Stephen Turnbull
-- Improve: s&m files by removing autodetected stuff. -- Ben Wing
-- Improve: support dumping bignums. -- Jerry James, Olivier Galibert
-- Improve: support for crashing gently. -- Ben Wing
-- Improve: type and keyword pedantry. -- Jerry James, Ben Wing
-- Improve: update etags from upstream. -- Jerry James
-- Remove: EXTERNAL_LIST_LOOP because it can infloop. -- Ben Wing
-- Remove: etc/gnu.xpm, etc/gnu.xbm, etc/sink.xbm, etc/ms-kermit,
   etc/ms-kermit-7bit (Ben Wing
-- Remove: unneeded/unused code. -- Ben Wing, Stephen Turnbull

Quality Assurance Infrastructure

-- Fix: conflict with builtin in .gdbinit. -- Golubev I. N.
-- New: regexp tests. -- Stephen Turnbull, Vin Shelton
-- New: os-tests.el. -- Stephen Turnbull
-- Improve: profiling support. -- Ben Wing

to 21.5.18 "chestnut"

Major Features

-- Improve: GTK support gets many fixes and improvements -- Purvis.
-- Improve: pdump gets data in executable support, -si option -- Galibert.
-- New: GTK gets default gtkrc -- Purvis.
-- New: bignum support -- James (lead), Sivakumar, Turnbull.

User-Visible Bug Fixes and Minor Improvements

-- Fix: 'no-conversion is special in eol detection -- Turnbull.
-- Fix: `display-completion-list' does not overflow window -- Grundmann.
-- Fix: X error handler must not call stderr_out -- Clements.
-- Fix: bogus error in `apropros' -- Turnbull.
-- Fix: bogus error in `package-require' -- Youngs.
-- Fix: buffer editing by `call-process-region' -- Aichner.
-- Fix: coredump from bogus position computation in syntax cache -- Euler.
-- Fix: coredump from redisplay wrapping in signal.c -- James.
-- Fix: coredump in giflib -- Hines.
-- Fix: etags.el correctly handles tags with name fields -- Grundmann.
-- Fix: prevent minibuffer from hijacking marks -- Sperber.
-- Fix: respect `allow-deletion-of-last-visible-frame' -- Zajcev.
-- Fix: sync revert-buffer to 21.4 -- Turnbull, Sparapani.
-- Improve: error message formatting -- Gatzemeier.
-- Improve: etags.el optimized for exuberant ctags -- Grundmann.
-- Improve: isearch-abort preserves interim successes -- Turnbull, Zawinski.
-- Improve: package info reporting -- Youngs.
-- Improve: window configuration handling -- Rychter.

Build Infrastructure

-- Fix: 64-bit support -- Purvis, SuSE.
-- Fix: configure.in syntax, logic -- Turnbull, James, Purvis.
-- Fix: make install went interactive -- Aichner.
-- Fix: rebuild finder-inf.el -- Turnbull.
-- Improve: Makefile diagnostics -- Turnbull.
-- Improve: Windows build support -- Aichner.
-- Improve: configure compiler warning setup -- James, Purvis.
-- Improve: configure diagnostics -- Turnbull.
-- Improve: configure feature detection -- Purvis, James, Turnbull.
-- Improve: configure report -- Turnbull, James.
-- Improve: icc support -- James.
-- Improve: install procedure -- Galibert.
-- New: configure supports Playstation2 -- Myrkraverk.
-- New: support for parallel builds -- Purvis.

Documentation

-- Improve: about.el version reporting -- Turnbull.
-- Improve: comments and docstrings -- Turnbull, Aichner, Gatzemeier.
-- New: lispref.texi documents bignum support -- Turnbull, James.
-- New: lispref.texi documents text field support -- James.
-- Update: FAQ -- Turnbull.
-- Update: NEWS -- Turnbull.
-- Update: PACKAGES -- Koch.
-- Update: about.el -- Turnbull.
-- Update: internals.texi -- James, Turnbull.
-- Update: lispref.texi -- Turnbull, Okahata.
-- Update: menus to XEmacs config file reality -- Turnbull.

Lisp API

-- Improve: pixel position reporting -- Okahata.

Internal API and Implementation

-- Fix: C macro definition for icc -- James.
-- Fix: C++ build problems -- James, Verna.
-- Fix: Cygwin bug workaround conditionalized -- James.
-- Fix: Lisp internal type manipulation -- James.
-- Fix: bogus CVS conflict in package-ui.el -- Aichner.
-- Fix: callproc.c vestiges removed -- James.
-- Fix: format conversions in pdump report -- Turnbull.
-- Fix: function argument usage -- James.
-- Fix: incomplete macro in external widget support -- Golubev.
-- Fix: lwlib GC handling -- James.
-- Fix: lwlib computation of widget changes -- James.
-- Fix: mark unused parameters -- James, Wing.
-- Fix: remove duplicate functions -- Turnbull.
-- Fix: remove unused variables -- James.
-- Fix: specifier validation -- James.
-- Fix: update byte compiler function database -- James.
-- Fix: warning suppression -- James, Gatzemeier.
-- Fix: workaround Darwin's distaste for ISO 8859/2 filenames.
-- Improve: custom database save -- Aichner, Niksic.
-- Improve: itimer implementation -- James, Jones, Buchholz, Yamaoka.
-- Improve: test-harness.el Assert macro -- James.
-- New: LTDL support in ELLs -- James.
-- Update: INSTALL Canna, Make descriptions -- James, Purvis.
-- Update: SERVICE sync with upstream -- James.
-- Update: derived.el, subr.el, cl*.el sync to Emacs 21.3 -- James.
-- Update: etags sync with upstream v17.6 -- James.

Quality Assurance Infrastructure

-- Fix: regression tests using most-negative-fixnum -- James.
-- Improve: faster Mule tests -- Turnbull.
-- New: Uno support -- James.
-- New: regression tests -- Turnbull, Youngs, Yamaoka, Shelton, James.

to 21.5.17 "chayote"

Build

-- New: configure reports cc and libc versions -- Kletnieks, Turnbull.
-- New: configure supports icc -- James.
-- New: configure supports typeof extension -- James.
-- New: use XCFLAGS to allow different flags for XEMACS_CC -- Turnbull.
-- Improve: module build process -- James.
-- Fix: compiler warnings -- Turnbull.
-- Fix: configure CFLAGS detection -- James, Turnbull.
-- Fix: configure arg parsing on Solaris -- Niksic, Shelton, Turnbull.
-- Fix: configure warning and progress messages -- Turnbull.
-- Fix: force regeneration of Lisp on every build -- Turnbull.
-- Fix: minitar compiler warnings, errors -- Aichner.
-- Fix: mislocation of installexe.sh -- James.
-- Fix: missing $(ldflags) in libsrc -- James.
-- Fix: remove dead references to GNU DLD -- James.
-- Fix: remove obsolete makefile cruft -- Turnbull.

Documentation

-- Improve: charset registry docs -- Golubev.
-- Improve: specifier and internals docs -- Turnbull.
-- Improve: test-harness reporting -- Aichner, Shelton, Turnbull.
-- New: weak data structure testing -- Kaltenbach.
-- Remove: own photos and personal information -- Youngs.
-- Update: library versions in Windows docs -- James.
-- Update: package list -- Koch.
-- Fix: TeXinfo syntax -- Golubev, Turnbull.
-- Fix: clarifications -- Turnbull.
-- Fix: typos -- Aichner, Golubev, Turnbull.
-- Fix: workaround version issues in NAS headers -- Turnbull.

Lisp API

-- New: device-num-screens, device-backing-store, device-save-under,
    add-to-invisibility-spec, remove-from-invisibility-spec -- James.
-- New: lazy (widget), widget-child-value-get, widget-child-value-inline,
    widget-child-validate, widget-type-value-create, widget-type-default-get,
    widget-type-match -- Abrahamsen, Youngs.
-- New: package-get-list-packages-where -- Youngs.
-- New: pui-display-maintainer command -- Youngs.
-- New: pui-help-echo displays both installed and available versions -- Youngs.
-- Synch: frame.el to GNU Emacs 21.3 -- James.
-- Fix: cl-do-prettyprint formatting of prog* -- Youngs.
-- Fix: update coding system name usage -- James.

Internals

-- Improve: KKCC -- Kaltenbach.
-- Improve: compiler.h for use with modules -- James.
-- Improve: make QUIT-related APIs visible to modules -- James.
-- New: support more device metrics on X11 -- James.
-- New: support symbols in Darwin shared libraries -- Purvis.
-- New: widget-default-create uses char-table -- Haddock.
-- New: xfree gets a type parameter for error-checking -- James.
-- Fix: (remove) duplicated code -- James.
-- Fix: GCPRO_STACK in byte interpreter -- Turnbull.
-- Fix: GTK marshalling code -- Purvis.
-- Fix: aliasing problems -- Turnbull.
-- Fix: bad interaction in initialization of args with pdumper -- Benson.
-- Fix: bit fields need to be unsigned in unicode detectors -- James.
-- Fix: coding system for GPG verification -- Youngs.
-- Fix: hard-coded options to use APIs -- Pakoulin.
-- Fix: improper use of XSetArg in frame-x.c -- Turnbull.
-- Fix: lstream close code -- Euler.
-- Fix: paragraph detection in Japanese -- Yamaoka, Turnbull.
-- Fix: regexps using \{ -- Monnier, Turnbull.
-- Fix: set dirty flag in mirror window at proper time -- Galibert.
-- Fix: several missing GC wrappers which caused crashes -- James.
-- Fix: some GCPROed variables were declared register -- McPherson.
-- Fix: stale info in realpath computation -- James.
-- Fix: two infloops in GC -- James.
-- Fix: usage of prin1 and princ in help -- Eide, Shelton.


to 21.5.16 "celeriac"

Build

-- Don't detect GNU DLD -- James.
-- Better detection of sound on Solaris9 -- Buchholz.
-- Add support detecting SunOS 5.10 in configure -- Buchholz.
-- Use '-bundle' when testing ability to build shared libs, but use
     '-bundle_loader' in ellcc -- Begel.
-- Output separate declaration and definition for dump_id -- James.
-- Add Makefile targets to build PDF docs -- Wambold.
-- Don't mangle the unload function in `unload_postgresql' and
     `unload_ldap' when compiling with C++ -- James.
-- Use extern "C" for C++ builds -- James.
-- Conditionally compile messages missing from the Cygwin headers -- James.
-- Add cast to quiet compiler in unexcw.c -- James.
-- Quiet compiler warnings about struct stat in syswindows.h -- James.
-- Test \{m,n\} in regexp-tests -- Turnbull.

Documentation

-- Propose bash as workaround for buggy Solaris sh in PROBLEMS -- Sparapani.
-- Fix the PRINTED-MANUAL-TITLE arg for cross ref to "The XEmacs User's Manual"
     -- Aichner.
-- New node: "A Reader's Guide to XEmacs Coding Conventions" -- Turnbull.
-- New node: "Customizing Message Display" -- Golubev.

Internals

-- In ellcc.c don't mangle external symbols in generated doc file -- James.
-- Add PARTIALLY parameter to support Fpos_visible_in_window_p parameter in
     redisplay -- James.
-- Use 'point_would_be_visible' parameter in `scrollbar_reset_cursor' -- James.
-- Add PARTIALLY parameter fo `Fpos_visible_in_window_p' -- James.
-- Use new 'point_would_be_visible' parameter in `window_scroll' -- James.
-- dll_open now takes a Lisp_Object -- James.
-- Remove useless call to dll_init -- James.
-- char to CIbyte conversion in emodules.c, sysdll.c -- James.
-- Do not mangle module initialisation function names -- James.
-- char to Extbyte conversion in sysdll.c -- James.
-- Return a Lisp_Object instead of a string in `dll_error' -- James.
-- Make eval-related functions visible to modules -- James.
-- Allow specifying elisp function for waiting user input while displaying
     message while in minibuffer -- Golubev.
-- Use OS_RELEASE=os_release_major*100+os_release_minor in s/sol2.h -- Buchholz.
-- Add lrecord_memory_descriptions -- Crestani.
-- Remove GetLongPathNameW -- Harris.
-- A couple of new macros to compare w32api versions -- James.
-- KKCC fixes -- Crestani.

Lisp API

-- Allow user to specify alternative function for displaying message -- Golubev.
-- New var to specify the maximum received fonts -- LewisMoss.
-- Allow gnuserv to fallback to GTK if X device fails -- LewisMoss.
-- Eval the initialisation value of `eol-detection-enabled-p' -- Alexander.
-- Make sure `setbuffer-file-coding-system' sets the eol type -- Alexander.
-- Remove unnecessary definitions of 'null-device' -- Turnbull.
-- Actually implement the specified semantics for 'defvar' -- Sperber.
-- Fix `shrink-to-fit' by calling `shrink-window-if-larger-than-buffer' -- Aichner.


to 21.5.15 "celery"

Build

-- Autoconf configure updates -- James, Turnbull.
-- Makefile updates -- James.
-- Minor updates to make-docfile.c -- Begel.
-- Wrap assert_failed with EXTERN_C for modules -- James.
-- Updates to modules Makefile.common -- James.
-- Include emodules.h when building modules in postgresql.c
     and ldap.c -- James.
-- Updates to xemacs.mak -- Aichner.
-- Add some extern "C" declarations for C++ module builds
     -- James.
-- Add casts for C++ builds in mule-canna.c -- James.
-- Add type casts in database.c to satisfy C++ compilers.
-- Log result summary of tests when the testsuite is running
     noninteractive -- Aichner.
-- Add some tests for weak-lists -- Crestani, Kaltenbach.


Documentation

-- Update README.(HYPERBOLE|OO-BROWSER) -- Turnbull.
-- Update etc/PACKAGES -- Turnbull, Koch, Youngs.
-- Update etc/sample.Xresources -- Turnbull.
-- Major update and audit of all documents relating to PUI -- Youngs.
-- Mention `line-move-ignore-invisible' (display.texi "Invisible Text")
     -- Kyllingstad.
-- Document that end-glyph is still displayed when invisible
     is set (extents.texi "Extent Properties") -- Kyllingstad.
-- Document that only begin-glyph is highlighted (extents.texi "Extents
     and Events") -- Kyllingstad.
-- Various typo and docstring fixes -- Turnbull, Sperber.
-- Add missing '@end' defun in lists.texi -- Shelton.
-- Document ?\x00 read syntax and range limitations on ?\000 and
     ?\x00 read syntaxes (objects.texi "Character Type") -- Turnbull.
-- Document `true-list-p' (lists.texi "List-related Predicates")
     -- Turnbull.


Internals

-- KKCC updates -- Crestani, Kyllingstad.
-- Define DECLARE_MODULE_API_LRECORD when not ERROR_CHECK_TYPES
     -- James.
-- Updates to DSO code -- James.
-- Remove unused (X)OPAQUE_MARKFUN definitions -- James.
-- GCPRO updates -- Sperber.
-- Mouse wheel fixes in event-msw.c -- Kyllingstad.
-- Use 'HAVE_DLD_INIT' instead of 'HAVE_INIT_DLD' in sysdll.c -- James.
-- Rewrite ephemeron marker code -- Sperber.
-- Fix printing of symbol names in .gdbinit -- Golubev.
-- Fixes to `update_frame_toolbars_geometry' -- Sperber.
-- Fix missing commas in `fonts' initialiser -- Golubev.
-- Add `opaque_ptr_description' -- Crestani.
-- Add `allocate_big_string_chars' -- Turnbull, Buchholz.


Lisp API

-- New alias `apropos-customize' -> `customize-apropos' -- Aichner.
-- Remove unnecessary arg from `pui-set-local-package-get-directory -- Youngs.
-- New key bindings in mwheel.el -- Kyllingstad.
-- Make `insert-directory' to be more like FSF version -- Sperber.
-- Window configuration fixes in isearch code -- Sperber.
-- Implement simple object finalisation in post-gc.el -- Sperber.
-- Updates to etags.el -- Turnbull.
-- Updates to cl-macs.el -- Pakoulin.
-- Fix "do-nothing" bug in `derived-mode-merge-syntax-tables' -- Turnbull.
-- Fixes to `restore-saved-window' -- James.
-- Handle missing "EMACSPACKAGEPATH" env var in
     `package-get-package-index-file-location' -- Aichner.
-- Fix substring errors in `package-admin-find-top-directory' -- Aichner.
-- Fix `byte-compile-lambda' so it only discards the docstring if it is
     not also the value of the lambda -- Turnbull.
-- Don't insist in lib-src directory in `path-emacs-root-p' on WinNT -- Aichner.
-- Don't include '(' in `font-lock-function-name-face' -- Aichner.


to 21.5.14 "cassava"

This release has a few documentation updates thanks to Steve
Turnbull, better Makefile handling for modules on MacOSX from
Andrew Begel and Jerry James.  Also, it is now possible for the
user to specify the location of the package-index file for PUI to
use, see `package-get-package-index-file-location'.

Build

-- Autoconf tweaks for building modules on MacOSX -- James.
-- GCC fixes in ellcc.c -- James.
-- Module Makefile fixes -- Begel, James.
-- Fix shadow warning in regex.c -- James.

Documentation

-- New TeXinfo node "Searching and Matching" -- Turnbull.
-- New section "Legacy Versions" in FAQ -- Turnbull.
-- New FAQ question Q8.0.1 -- Turnbull.
-- Update split-string specs in "Regexp Search" -- Turnbull.

Internals

-- Package index file updated -- Koch.
-- Add some debug checks in file-coding.c -- Turnbull.

Lisp API

-- Make error message report the sym checked in
     `autoload-featurep-protect-autoloads' -- Turnbull.
-- `split-string' tweaks -- Turnbull.
-- Make the location of the package-index file user customisable -- Youngs.
-- Turn on package-index file PGP verification -- Youngs.
-- Only use message if interactive for functions in replace.el -- Josefsson.

to 21.5.13 "cauliflower"

Remember that bug that made return behave as linefeed in a TTY?  It's
gone!  Thanks go out to Jerry James and Steve Turnbull for squashing
this year old bug.  Of course, that wasn't the only bug fixed this
time around.

Here are the highlights:

Build

-- Don't look for Motif if it's already been found -- Buchholz.
-- Darwin, Cygwin, BerkDB autoconf fixes -- Turnbull.
-- Make DEFUNed functions be tags -- Buchholz.
-- Allow compiling with Motif 1 and linking with Motif 2 -- Buchholz.
-- Update regexp tests -- Turnbull.
-- Don't autodetect ESD (Enlightened Sound Daemon) -- Turnbull.


Documentation

-- New section in PROBLEMS auxilary programs for Windows -- Turnbull.
-- FAQ updates
	Q6.4.3 New aux programs for Windows -- Turnbull.
-- Document failed match preserves data -- Turnbull.


Internals

-- Don't use the u_int8_t etc typedefs on FreeBSD in database.c -- Pluim.
-- Better support for externally defined lrecord types -- Begel.
-- Only call `xm_update_progress' if Motif is defined -- Youngs.
-- Define __STDC__ for BerkeleyDB -- Buchholz.
-- Fix bug where XEmacs couldn't find its .dmp file -- Buchholz.
-- Move `filemodestring' from lisp.h to sysfile.h -- Golubev.
-- Clean ups against the possibility of sys/stat.h defining stat -- Turnbull.
-- Search/match updates -- Turnbull.


Lisp API

-- Fix bug preventing installing new packages -- Youngs.
-- Put exit message on separate line in `command-error' -- Turnbull.
-- Temporarily turn off PGP verification of package-index -- Youngs.
-- Remove keymapings for 'function-key-error' -- James.
-- Fix bug that mapped RET to LFD in TTYs -- James.


to 21.5.12 "carrot"

Lots of updates, fixes, and features from Ben Wing (he never stops).
Also, a lot of work has gone into cleaning up the test suite.  Thanks
to Steve Turnbull, Jerry James, Daiki Ueno because now all tests from
'make check' pass 100% (at least on GNU/Linux).

Here are the highlights:

Build

-- Updates to configure.in -- Steuck, James, Skyttä, Wing.
-- Major updates to Makefile.in.in -- Wing.
-- Allow for separate build and source directories -- Wing.
-- Fix some compiler warnings -- Wing.
-- Major clean up of xemacs.mak and friends -- Wing, Aichner.
-- Fix some Solaris 2.7 CC compiler warnings -- Persico.
-- Fix for building on Mac -- Palmer.
-- Work around a problem compiling with '--use-union-type' on Intel's
     ICC compiler -- Buchholz.
-- Fix problems with rel-alloc compilation -- Wing.
-- Sequentialize dependencies even more in update-elc-2 -- Sperber.
-- Don't fatal() in 'report_sheap_usage' when need to rerun Make -
     Wing.
-- Various updates to the test suite -- Turnbull.

Documentation

-- Updates to
	INSTALL -- Turnbull, Wing.
	PROBLEMS -- Turnbull, Wing.
-- Global substitution of .Xresources for .Xdefaults -- Turnbull.
-- Update packages in ./etc/BETA -- Skyttä.
-- Doc string updates -- Korytov, Turnbull, Wing.
-- TeXinfo updates -- Aichner, Turnbull, Wing, Youngs.

Internals

-- Fix stale match data after failed search bug -- Turnbull.
-- Reformat function definitions correctly in menubar-gtk.c and
     event-gtk.c -- Turnbull.
-- Fix bug matching ASCII character classes to Mule characters -
     Ueno.
-- Frame updates for MS Win -- Alexander.
-- Add .dylib as an acceptable shared library file extension to
     support MacOS X -- Begel.
-- Fix bug in database.c for Berkdb 4.1 -- Turnbull.
-- Regex fixes -- Turnbull, Wing.
-- Coding system updates -- Wing.
-- Add clear-left-side functionality in print.c -- Wing.
-- Seg fault rather than abort on Cygwin in 'assert_failed' -- Wing.
-- Delete popup-data object -- Wing.
-- Delete menubar_data field from frames -- Wing.
-- Clean up handling of lwlib callback data GCPRO'ing -- Wing.
-- Use ALLOCA() in regex.c to avoid excessive stack allocation -
     Wing.
-- Fix subtle problem with REL_ALLOC() -- Wing.
-- Change *run_hook*_trapping_problems to take a warning class, not a
     string -- Wing.
-- Mule-ize encrypt/decrypt-string code -- Wing.
-- Delete all support for bit-rotten CANNOT_DUMP -- Wing.
-- Fix crash due to attempt to free objects across dump/undump -
     Wing.
-- Don't get in an infinite loop running post-redisplay actions -
     Wing.
-- Make gc_currently_forbidden static -- Wing.
-- Defer redrawing if already in redisplay -- Wing.
-- Add debug code for locking a dynarr to catch invalid mods -- Wing.
-- Ensure that various glyph functions that eval within redisplay
     protect the evals -- Wing.
-- Defer specifier-changed updating till after redisplay -- Wing.
-- Require that every place inside of redisplay catch errors itself -
     Wing.
-- Introduce separate means of holding frame-size changes -- Wing.
-- Introduce "post-redisplay" methods for deferring things till after
     redisplay -- Wing.
-- Disable all quit checking in redisplay -- Wing.
-- Use _wexecve() when under Windows NT for Unicode correctness -
     Wing.
-- Update list of possibly valid console types -- Wing.
-- Turn on Vstack_trace_on_error 'Frun_emacs_from_temacs' so that
     errors are debuggable even when occurring extremely early in
     reinitialization -- Wing.
-- Define new function `emacs-run-status' -- Wing.
-- Fix crash caused by an edge condition in the syntax-cache macros -
     Wing.
-- Eliminate HAVE_WIN32_CODING_SYSTEMS, use WIN32_ANY instead -- Wing.
-- Don't check_quit() unless we're unbinding a real Lisp
     `unwind-protect' -- Wing.
-- Make absolutely sure there is no quit checking while we are in a
     "critical section" during frame deletion -- Wing.

Lisp API

-- Fix infloop in font-lock for java files -- Choi.
-- Fix split-string -- Turnbull.
-- Support '(filename)nodename' as argument to 'info' -- Steib.
-- Major clean up of the PUI code -- Youngs.
-- Use 'equal' instead of '=' in 'saved-window-equal' -- James.
-- Updates to wid-edit.el -- Turnbull.
-- Better layout for Tools -> Packages -> Download Site menu -
     Aichner.
-- More sites added to packages download sites menu -- Aichner.
-- Byte-compiler warning clean up and lots of synching with FSF 21.2
     code -- Wing.
-- Move lots of high-level code for computing paths into
   setup-paths.el from various places -- Wing.
-- Mule and coding system updates -- Wing, Turnbull.


to 21.5.11 "cabbage"

Lots of improvements and fixes this time around.  One of our key
players, Ben Wing, has drastically improved font-locking (go turn on
lazy-lock to check it out).  Apart from many other bug fixes, Ben
has also given us a speed up to the build process (--quick-build
configure option).

Other stars we should mention are:  Mike Sperber, for window
configuration fixes and updates; Stephen Turnbull for build fixes,
documentation and typo fixes.  Stephen also gave us some major updates
to autoload.el and wid-edit.el.  And also Jerry James with some more
DSO updates.

Here are the highlights:

Build

-- Updates to test suite -- Turnbull.
-- Use -no-autoloads with update-elc-2 -- Wing.
-- Check for strupr and strlwr -- Sperber.
-- Delete auto-autoloads.el* & custom-load.el* files on make clean -- Turnbull.
-- Fix --srcdir processing -- Turnbull.
-- Define DLSYM_NEEDS_UNDERSCORE on Darwin -- Turnbull.
-- Use opsys=aix4-2 for AIX 5 and above -- Buchholz.
-- Make ellcc search XEmacs directories for include files 1st -- James.
-- Set stack-trace-on-error, load-always-display-messages -- Wing.
-- Overhaul update-elc.el, cus-dep, autoload (speed ups) -- Wing.
-- Various compiler warning fixes -- Wing.
-- FreeBSD updates in modules/Makefile.common -- Pluim.
-- Warning fix in eldap.c -- James.
-- Support C++ & KKCC compilation in Windows -- Wing.
-- Various fixups in nt/config.in.samp -- Wing.
-- Fixes in xemacs.mak -- Wing.
-- Clean up compile errors with C++ under Windows -- Wing.
-- Re-order sections in ldflags for gcc 3.2 -- Okhapkin.
-- Restore USE_XFONTSET -- Turnbull.
-- New symbol: DLSYM_NEEDS_UNDERSCORE -- Turnbull.
-- Guard against multiple definitions of _ALL_SOURCE -- Buchholz.
-- QUICK_BUILD updates -- Wing.

Documentation

-- Major update to configure.usage -- Wing.
-- New developer bio's -- James, Skyttä, Golubev.
-- Amendments/additions to PROBLEMS:
	- PostgreSQL DSO with --error-checking=all -- James.
	- Consolidate Motif problems into one section -- Turnbull.
-- Amendments/additions to INSTALL:
	- Recommend Mule -- Turnbull.
	- Deprecate stripped binaries -- Turnbull.
-- General tidy up of etc/BETA, rewrite sections dealing with packages
   and building from scratch -- Youngs.
-- General doc fixes, typos etc -- Youngs, Turnbull, Palmer, Wing.
-- Fix xref in Auto-Saving -- Aichner.
-- Update Local.rules File section in packages.texi -- Youngs.
-- Clarify package hierarchy structure -- Turnbull.
-- Major fixup of internals.texi -- Wing.
-- Lots of Mule rewriting in lispref/mule.texi -- Wing.
-- Document USE_UNION_TYPE evilness -- Wing.
-- Document event-matches-key-specifier-p better -- Wing.
-- Change illegal (for C) '//' comments to '/* */' -- Shelton, Turnbull.

Internals

-- Synch rcs2log to GNU upstream -- Youngs.
-- Use symbolic name `XtExposeCompressMaximal' instead of `TRUE' in
   xlwMenuClassRec -- Buchholz.
-- In xm_update_progress, don't define unless LWLIB_WIDGETS_MOTIF -- Buchholz.
-- Rename class -> class_ & new -> new_ -- Wing.
-- KKCC update in postgresql.c -- Wing.
-- KKCC update in eldap.c -- James.
-- Fix for unix_create_process -- Ueno.
-- Set stack reserve size during unexec() -- Piper.
-- Use 'struct htentry' not 'struct hentry' in elhash.c -- Wing.
-- New macros ALIST_LOOP_3, ALIST_LOOP_4.
-- Fix 'xemacs -batch -l dunnet' under Cygwin -- Wing.
-- Implement delaying of XFlush() if pending expose events -- Wing.
-- Fix some longstanding bugs in X quit handling -- Wing.
-- Correct the message output upon crashing to be more up-to-date -- Wing.
-- Add dp() & db() as short synonyms of debug_print() &
   debug_backtrace() -- Wing.
-- Add C++ error-checking code to verify problems with GCPRO/UNGCPRO -- Wing.
-- Change the way gap arrays are allocated (for KKCC) -- Wing.
-- Now lcrecords set the type of items sitting on the free list to
   lcrecord_type_free -- Wing.
-- All lcrecord allocation functions now zero out the returned
   lcrecords -- Wing.
-- Additional asserts in FREE_FIXED_TYPE -- Wing.
-- Make bit vectors lcrecords, like vectors -- Wing.
-- MARKED_SLOT() call no longer includes semicolon -- Wing.
-- Factor out some code duplicated in KKCC and pdump -- Wing.
-- KKCC updates -- Wing.
-- Add a fifth field "flags" to memory_description -- Wing.
-- Add support for "description maps" -- Wing.
-- Redo XD_UNION so it works inline and change format to provide info
   for pdump -- Wing.
-- Textual changes:
	- lrecord_description -> memory_description -- Wing.
	- struct_description -> sized_memory_description -- Wing.
-- Initialize protect_me field of popup_data in set_frame_menubar -- Sperber
-- GTK updates -- Sperber.
-- Don't lead to a crash if dealing with a dead
   window/frame/device/console -- Sperber.
-- Prevent crash for combination windows -- Sperber.
-- Window fixes in Fdelete_window -- Sperber.
-- Module updates in emodules.h -- James.
-- Fprovide from 'vars_of_file_coding' not 'syms_of_file_coding' -- Turnbull.
-- Fix syntax of macro in 'mark_object_maybe_checking_free -- Turnbull.
-- Eliminate bogus require-prints-loading-message -- Wing.
-- Turn on `load-warn-when-source-newer' by default -- Wing.
-- Fix up crashes when selecting menubar items due to lack of GCPROing
   -- Wing.
-- Implement tail-recursion in KKCC -- Wing.
-- Fix UTF-(8|16) detector -- Wing.
-- Fix problems with reentrant calling of lwlib and associated crashes
   when selecting menu items -- Wing.
-- Improve redisplay handling of preemption -- Wing.
-- Return the parameter from strlvr, strupr, depend on !HAVE_STRUPR -- James.
-- In sysdll.c included lisp.h to define needed alloca_array -- Begel.
-- Pull GC_CHECK_NOT_FREE out of USE_KKCC -- Sperber.
-- Abort when any attempts to output a stream console are made -- Wing.
-- Formatting fixes in redisplay-output.c -- Wing.
-- Clean up redisplay a bit -- Wing.
-- Fix scrollbar code TTY devices don't have them -- Sperber.
-- Major reworking of profile code -- Wing.
-- Dramatically improve redisplay speed over slow X connections -- Buchholz.
-- Move syntax table description from buffer.c to syntax.c -- Wing.
-- Updates to char,mirror,syntax tables code -- Wing.
-- Niggly whitespace fixups -- Wing.

Lisp API

-- Updates to (japan|cryil)-util.el -- Turnbull.
-- Updates to how XEmacs computes various paths -- Sperber.
-- Window configuration fixes -- Sperber, Wing.
-- Make Info-insert-dir end n separator -- Buchholz.
-- Drastically reorganise autoload.el -- Turnbull.
-- Omit M-S-home/end from motion keys -- Wing.
-- Synch wid-edit to GNU/Emacs 21.3.50 -- Turnbull.
-- Updates to hyper-apropos -- Wing.
-- Reorganise Help -> Info submenu -- Wing.
-- Fix bug when end > start in text-props -- Wing.
-- Fix walk-windows -- Wing.
-- Fix for call to set-language-unicode-precedence-list -- Nyyssönen.
-- Synch up byte-optimize.el -- Wing.
-- Include FUNLIST argument to generate-c-file-autoloads-1 -- Wing.


to 21.5.10 "burdock"

Please accept my apologies for the very long wait between releases
this time around.  My PC chose the 21.5.10 development cycle to go up
in a sickening cloud of smoke. :-( (Steve Youngs <youngs@xemacs.org>)

Lots of updates from Ben Wing (as always), also from Andy Piper, Mike
Sperber, and Stephen Turnbull with lots of documentation updates and
fixes.  One new exciting addition in this release is that the LDAP and
PostgreSQL code has been extracted out of the core C code and moved to
DSO's.  We have Jerry James to thank/blame/worship for that.

Build

-- Reset sheap-adjustment to zero -- Piper.
-- Make --pdump default to yes on Linux -- Turnbull.
-- Only use -Wpacked in GCC v3 -- Wing.
-- Remove LISP_FLOAT_TYPE definition. -- James.
-- Temporarily disable DSO's under Cygwin -- Wing.
-- Updates to DSO building code (Makefile.in, configure.in etc) -- Wing, James.
-- Separate compiler warning flags from CFLAGS -- Wing.
-- Delete auto-autoloads.e* & custom-load.e* on 'make clean' -- Turnbull.
-- Disable detection of 'getaddrinfo' for HP-UX 11.XX -- Turnbull.
-- Include modules directories in 'make tags' -- Youngs.
-- Fix shadowing warnings in make-docfile.c -- Wing.
-- Move the common stuff from postgresql/ldap Makefile.in.in &
     configure.ac's into a "common" Makefile and configure script -
     Wing.
-- Major cleanup of ellcc -- Wing, James.
-- Add Makefile var to pick up '--site-libraries' in DSO's -- Youngs.
-- Avoid unnecessary deviations from UNIX 'describe-installation' in
     xemacs.mak -- Aichner.
-- Don't confirm overwriting files in xemacs.mak -- Aichner.
-- Support 'xemacs_extra_name' in xemacs.mak -- Aichner.
-- Some gcc/g++ 3 fixes -- Wing.
-- Warning fixes -- Wing.
-- Fix some C++ errors -- Wing.
-- Allow for C needing volatile and C++ that can't have volatile,
     remove previous volatile hacks -- Wing.
-- Try for a working Cygwin build with old unexec -- Wing.
-- Warning suppression -- Turnbull.
-- New Mule character class regexp tests -- Turnbull, Ueno.
-- Better handling of known bugs in tests -- Turnbull.
-- Add test for stale subexpr match-data -- Turnbull.
-- Update syntax-table tests -- Turnbull.
-- Add word-boundary regexp tests -- Turnbull.

Documentation

-- Updates to PROBLEMS file
	Running/Linux - Lesstif 0.93.36 -- Turnbull
	Running/IRIX - Irix 6.5 coredumps -- Turnbull
	Running/Cygwin - "No cygXpm-noX" fatal error -- Turnbull
	Missing charsets - Remove ambiguity -- Turnbull
	Running, General - FontSet warnings -- Turnbull
	MacOS/X - Stack limitation -- Turnbull
	Digital Unix - Generalise -- Turnbull
	AIX - USE_KKCC lossage -- Turnbull.
-- Update instructions in info/dir -- Wallington.
-- Recommend TeXinfo 4.2 in INSTALL -- Turnbull.
-- Add example in sample.Xdefaults -- Boffi.
-- Typo fixes -- Yamaoka, Youngs, Turnbull, Wing.
-- Docstring fixes -- Turnbull, Piper, Skyttä, Wing.
-- Update description of XEmacs Patches and Design ML's -- Turnbull.
-- Incorporate ChangeLog.X into ChangeLog -- Wing.
-- FAQ additions/amendments:
	Debugging FAQ improvements -- Wing.
	Mention union type bugs -- Turnbull.
	Debugging HOWTO improvements -- Turnbull.
	Decoding Lisp objects in the debugger -- Turnbull.
	Fix location of FAQ on website -- Skyttä.
	Add missing menu entry for Q3.2.7 -- Verna.
	Displaying non-ASCII -- Turnbull.
	Mention bug report commands -- Turnbull.
	Revise Q1.3.[1-6] -- Turnbull.
	New FAQ for "no cygXpm-noX" fatal error -- Turnbull.
-- New TeXinfo nodes:
	"Widget Internals" -- Turnbull.
	"Simple Specifier Usage" -- Turnbull.
	"Compilation Options" -- Turnbull.
-- Document charset Unification and Tables -- Turnbull.
-- Better short description of Mule in Mule submenu -- Turnbull.
-- Regression Testing XEmacs design hints & rewrite -- Turnbull.
-- Document 'face-frob-from-locale-first' -- Golubev.
-- Document 'set-face-background-pixmap-file' -- Verna.
-- Add urefs to Doug Lea's * Wolfram Gloger's home pages in "Low-Level
     Modules" -- Turnbull.
-- Update "Available Packages" -- Skyttä.
-- Document 'append' arg of 'add-to-list' -- Skyttä.
-- Add optimisation hints in "Techniques for XEmacs Developers" -- Turnbull.

Internals

-- Add *menubar*FontSet and *popup*FontSet entries -- Turnbull, Skyttä.
-- Extract ldap and postgresql code from core and put them into DSO's -- James.
-- 'Fset_window_point' Correct to GNU/Emacs behaviour (fixes some bugs
     in Gnus) -- Wing.
-- Inhibit GC in critical sections -- Wing.
-- Fix calculation in 'report_sheap_usage' -- Piper.
-- Implement and use new var 'garbage_collection_messages' -- Wallington.
-- Fix 'open_database' for Berkeley DB 4.1.x -- Allen.
-- Updates to frame code -- Sperber.
-- Change C debugger entrance: error message, then stack trace, then
     exiting message, then force debugger -- Wing.
-- Use EQ not EQUAL in 'mswindows_init_frame_1' -- Wing.
-- Better redisplay-related asserts -- Wing.
-- Don't generate large warning strings when they'll be discarded -- Wing.
-- Implement 'debug-on-error' as documented -- Wing.
-- Fix docs relating to QUIT which can't GC under any circumstances -- Wing.
-- More robust package compilation and debugging -- Wing.
-- Overhaul profile code -- Wing.
-- Fix crashes due to incorrectly ported GNU/Emacs code -- Wing.
-- Clean up realpath.c -- Wing.
-- DdeCreateStringHandle needs to be manual due to new Cygwin bug -- Wing.
-- Fix some Cygwin complaints -- Wing.
-- Unconditionally use LISP_FLOAT_TYPE code -- James.
-- Improve crash message in 'shut_down_emacs' -- Turnbull.
-- Update NAS code for NAS 1.6 and later -- Toy.
-- Fix "unused variable" warnings in mule-canna.c -- Turnbull.
-- Prototype 'enqueue_focus_event' -- Turnbull.
-- Use BORDER_FIDDLE_FACTOR instead of 10 in 'layout_layout' -- Piper.
-- Add optional 'noerror' arg to 'Frequire' -- Wallington.
-- Only resize 'layout_query_geometry' dynamically if static sizes
     haven't been set -- Piper.
-- Fix infloop upon a gdm logout -- Sigelman.
-- Fix scope of 'num_nonshy_regs' -- Turnbull.
-- Fix "stale match data" bug -- Turnbull.
-- Don't call 'XtDisplay' on a destroyed widget -- Golubev.
-- Update specifier code -- Sperber.
-- Update process code -- Sperber.
-- Move ldap/postgresql code out to DSO's -- James.
-- Normalise Ffile_truename and drive spec on cygwin to win32 format
     -- Piper.
-- Use 'closesocket' instead of 'CloseHandle' in 'winsock_closer' -- Alexander.
-- Coding system updates -- Ikiuo.

Lisp API

-- Update window-xemacs.el to fix 'goto-line' -- Wing.
-- Add garbage collection messages -- Wallington.
-- Re-implement window configurations in Emacs Lisp -- Sperber.
-- Enhance background-pixmap-file code -- Verna.
-- New macro 'save-window-excursion' to eventually replace bytecode
     instruction -- Sperber.
-- Move window.el et al up the order in dumped-lisp.el -- Sperber.
-- Don't use 'save-window-excursion' in
     'shrink-window-if-larger-than-buffer' -- Sperber.
-- Updates to pixel-size code in dialog.el -- Sperber.
-- Remove nonworking 'breakpoint-on-error' -- Wing.
-- Extract out 'with-displaying-help-buffer' into a more general mechanism
     -- Wing.
-- Don't catch errors when noninteractive in startup.el -- Wing.
-- Fix warnings in code-files.el, loadhist.el, & package-get.el -- Wing.
-- Simplify code in '*-reset-device-font-menus' -- James.
-- Synch font-menu.el to the 21.4 version -- Turnbull.
-- Preserve return value from 'call-process' -- Sperber.
-- New functions in replace.el that operate on regions -- Evans.
-- Run 'delete-frame-hook' in general dialogs only -- Piper.
-- Add a margin parameter in autoload.el for DSO autoloads -- James.
-- Conditionalise autoloads for DSO's on the existence of the DSO -- James.
-- Always set module directories/paths in dump-paths.el -- James.
-- Bring list of package sites up to date -- Skyttä.
-- Add "Find Variable" menu entry for 'hyper-apropos-find-variable' -
     Wallington
-- Fix 'view-lossage' interactive spec -- Wallington.
-- Synch 'with-output-to-string' with GNU/Emacs 21 -- Wallington.
-- Bind C-xrd to 'delete-rectangle' -- Yamaoka.
-- Move entries in 'auto-mode-alist' out to packages for the modes
     that are in packages -- Skyttä
-- New compatible alias for 'lookup-syntax-properties'
     ('parse-sexp-lookup-properties') -- Turnbull.
-- Enable C autoloads for DSO's -- James.
-- Update revert-buffer code -- Piper.
-- Add new coding system 'utf-8-bom' -- Ikiuo.


to 21.5.9 "brussels sprouts"

The main thrust of this release is the new GC algorithms.  If you want
to test this out configure with '--use-kkcc'.

There are of course, the usual swag of bug fixes, typo fixes, and
document updates.

-- Add an extra element to the version string that can be used to
   include a date in the version string -- Youngs.
-- Improve help string for --with-widgets configure option -- Skyttä.
-- Define runtime & build problems, and rewrite "Hannibal Lecter"
   stuff in PROBLEMS -- Turnbull.
-- Add builtin and constant faces to font-lock-face-list -- Skyttä.
-- Japanese language fixes -- Yamaoka.
-- Fix find-library to allow Mule XEmacsen to find compressed
   libraries -- Youngs.
-- New alias for 'delete-indentation' (join-line) -- Wallington.
-- Support docstring for define-derived-mode -- Turnbull
-- Doc fix for keybindings in term.texi and misc.texi -- Skyttä.
-- Bring package list up to date in packages.texi -- Skyttä.
-- Document purecopy as a no-op -- Josefsson.
-- New document chapter "Regression Testing XEmacs" -- Turnbull.
-- Add "USE_KKCC" option to ./nt/xemacs.mak -- Aichner.
-- New GC algorithms implemented (Turn them on with --use-kkcc
   configure option) -- Sperber, Crestani, Kaltenbach, Bush.
-- Define HAVE_WCHAR_H for native Win32 builds -- Harris.
-- Fix x_locate_pixmap_file make sure path is not 0 -- MacLennan.
-- Fix memory leak -- Verna.
-- Add missing call to 'xfree (newname)' in 'make_coding_system_1
   -- Verna.
-- Fix --with-mule --with-gtk builds -- Barta.
-- Make SEPCHAR a required arg to Fsplit_string_by_char -- Palmer.
-- Make locate_file indicate success with nonnegative return if MODE
   is nonnegative -- James.
-- Fix splitting window horizontally not splitting evenly -- James.
-- ORDINARY_LINK OK for Linux -- James.
-- Don't bogusly reinitialise ascii_character property in
   maybe_define_x_key_as_self_inserting_character -- Astapov.
-- Add warning to SOE_DEBUG about not using until debugging functions
   are rewritten -- Turnbull.
-- Update 'do_autoload' to GCPRO both arguments -- Turnbull.
-- Update automated tests so they don't barf if required packages
   aren't present -- Turnbull.
-- Organise NSIG setting code for SVR4 in a better way -- James.
-- Various typo fixes -- Skyttä, Turnbull, James.


to 21.5.8 "broccoli"

Lots of fixes and changes.  This release is primarily been done to
make way for the new GC stuff from Mike Sperber.

CHANGES now uses surnames as listed in the ChangeLogs to identify
contributors.  And I haven't sorted the changes into different
categories.  Maybe next release...

-- New configure option "--use-kkcc" for the upcoming new GC
   algorithms -- Sperber.
-- Identify "--with-modules" as an autodetected configure option -
   James.
-- Add a couple of configuration questions to PROBLEMS -- Turnbull.
-- Test for wchar.h in configure -- Sperber.
-- Update package-index files -- Youngs.
-- s/Xemacs/XEmacs/ doc fixes -- Aichner.
-- Sync make-docfile.c with GNU -- James.
-- Updates to gutter-items -- Palmieri.
-- Sync setenv with GNU -- Wallington.
-- Remove package-get's dependence on APEL -- Youngs.
-- Fix case fold bug in replace-in-string -- Verna.
-- Updates to code-process.el and process.el -- Alexander.
-- Updates to mule/kinsoku.el -- Yamaoka.
-- Updates to define-derived-mode -- Wallington.
-- Printer fixes -- Piper.
-- Updates to window-xemacs.el & frame.el -- James.
-- Doc fix gutter-items.el -- Piper.
-- Sync ":set-after" in custom with GNU -- Piper.
-- Sort the lists in enabled-behavior-list -- Galibert
-- Updates to lwlib-Xm.c -- Piper.
-- Various doc fixes to the TeXinfo docs -- Aichner.
-- GC fixes -- Sperber.
-- Updates to lisp.h, symbols.c for DSO's -- James.
-- Fix to mswindows_need_event -- Alexander.
-- Declare Fcdr_safe to be callable from C -- Turnbull.
-- Ffunctionp return nil for autoloaded macros & keymaps -- Niksic.
-- Subwindow fixes -- Ueno.
-- Include wchar.h only if available, define wclsen if not -- Sperber.
-- Fixes to Fstart_process_internal -- Sperber.
-- Fixes to init_ralloc for pdump -- Sperber.
-- Remove duplicated definition of Lisp_Devmode -- Bush.
-- Fixes to toolbar/redisplay -- Piper.
-- Windows DDE fixes -- Moore.
-- Fixes to 'query_string_geometry' and 'widget_logical_unit_height' -
   Piper.
-- Fix problem with XEmacs freezing with certain virtual window
   managers on Windows -- Rankin.
-- Conditionalise calls to syms_of_dired_mswindows &
   vars_of_dired_mswindows on WIN32_NATIVE instead of HAVE_MSW_C_DIRED
   -- Harris.
-- Process related fixes -- Sperber.
-- Fix #includes in input-method-motif.c -- Galibert.
-- Fixes to automated tests -- Sperber.


to 21.5.7 "broccoflower"

CHANGES now uses @xemacs.org alias to identify contributors.  If the
contributor doesn't have one (that I know about), the full name from
the ChangeLog is used.

UI changes and runtime bugs

-- Add: ask "yes/no/diff" question when recovering; known problem: dialog
   is modal, so you can't scroll the diff -- ben
-- Add: balloon help for package-ui -- youngs
-- Add: global-abbrev-mode, defining-abbrev-turns-on-abbrev-mode -- ben
-- Add: lots of new menubar items -- ben
-- Add: new winclient for MS Windows -- acs
-- Add: option kill-word-into-kill-ring controls whether words are "cut"
   into the kill ring, or "cleared" into nothingness -- ben
-- Add: revert-buffer optimization for unchanged files -- andy
-- Add: undo-all-changes back to the beginning -- ben
-- Fix:	M-C-backslash does indent-region-or-balanced-expression, S-Tab
   inserts a TAB char -- ben
-- Fix: Cmds menu so that most used commands appear directly on the menu and
   less used commands appear in submenus -- ben
-- Fix: NILP(lim) crash in search.c -- mike
-- Fix: STACK_TRACE_EYE_CATCHER now visible in MS Windows traces -- jonathan
-- Fix: XmProcessTraversal crash -- stephen
-- Fix: avoid infinite loop in extent code -- ben
-- Fix: crash due to errant xfree() -- ben
-- Fix: crash in gtk_popup_menu -- wmperry
-- Fix: crashes due to excessive alloca -- ben
-- Fix: detection of metric units on MS Windows -- jonathan
-- Fix: don't output bell as ^G in console-stream when not a TTY -- ben
-- Fix: improve MS Windows printer support -- andy
-- Fix: improve appearance for gutters and dialogs -- andy
-- Fix: improve lisp-mode indentation handling -- ben
-- Fix: interprogram cut functions now don't add selection twice -- stephen
-- Fix: many netinstaller improvements -- andy
-- Fix: popup dialogs on MS Windows -- andy
-- Fix: recover-session only shows session files with recoverable files,
   and in chronological order -- ben
-- Fix: save customized values MUCH faster and in alphabetic order,
   custom-save-pretty-print turns on/off pretty-printing values
   -- Nickolay Pakoulin
-- Fix: semicolons inside strings are not comments in lisp-mode -- ben
-- Fix: short filename handling on Windows -- Peter Arius
-- Fix: some crashes in syntax code -- ben
-- Fix: some crashes with multibyte text -- ben
-- Fix: two frames displaying the buffer, in different places; in one,
   temporarily switch away to another buffer and then back, and your position
   has been reset to the other one in the other frame -- ben
-- Fix: update installed.db after updating packages -- andy

Documentation

-- Add: New FAQs -- stephen, adrian
-- Add: New or improved code and documentation in sample.init.el -- ben,
   stephen
-- Add: PROBLEMS: Hannibal Lecter crash, EFS AUTH failure, mail locking
   -- stephen
-- Add: etc/TUTORIAL.se -- Mats Lidell
-- Add: new Internals manual nodes -- ben, stephen, darrylo
-- Add: why modules don't use RTLD_GLOBAL -- james
-- Fix: README.integral-types doc moved to Internals, code moved to
   README.global-renaming -- ben
-- Fix: README.packages: info about --package-path -- ben
-- Fix: improve docstrings and comments -- ben, stephen, adrian,
   John H. Palmieri
-- Fix: typos, minor updates -- stephen, I. N. Golubev, Frank Schmitt,
   adrian, youngs
-- Fix: update etc/BETA -- Jarl Friis
-- Fix: update etc/package-index.LATEST.pgp -- youngs
-- Fix: update photos -- hniksic

Lisp API

-- Add: functions: args-out-of-range, argument-in-range-p,
   check-argument-range, indent-balanced-expression-function,
   indent-balanced-expression, indent-region-or-balanced-expression,
   image-instance-instantiator, truncate-string-with-continuation-dots,
   get-user-response, unicode-precedence-list -- ben, stephen
-- Fix: GNU synchs of frame-parameter, makehash, buffer-local-value,
   line-beginning-position, line-end-position, with-temp-message,
   bound-and-true-p, propertize, delete-and-extract-region, add-to-list,
   string-to-char-list, find-non-ascii-charset-region,
   find-non-ascii-charset-string, truncate-string-to-width, plist-to-alist,
   kill-ring-max, kill-new -- John Paul Wallington, youngs, ben, james, ville
-- Add: set-frame-pixel-width, set-frame-pixel-size -- andy
-- Add: args to map-specifier, various "heuristic" specifier functions -- ben
-- Fix: call-process moves to Lisp -- ben
   -- allows a buffer to be specified for input and stderr output
   -- use it on all systems
   -- implement C-g as documented
   -- clean up and comment
   -- call-process-region uses new call-process facilities; no temp file.
   -- remove duplicate funs
-- Add: compat.el, preliminary (not working) code -- ben
-- Add: handle subprocess stderr separately (src/ChangeLog 2002-05-28) -- ben
-- Add: new error trapping mechanism (src/ChangeLog 2002-05-28) -- ben
-- Add: pixel-based sizing APIs: set-frame-pixel-height,
-- Add: preliminary support for ELL autoloads -- james
-- Add: toolbar face -- wmperry
-- Add: widget "logical-unit" sizing APIs: widget-logical-to-character-width,
   widget-logical-to-character-height -- andy
-- Fix:	paths-find-architecture-directory searches in
   `system-configuration'/`base', not `base'`system-configuration' -- james
-- Fix: default CRLF conversion of process output off -- ben
-- Fix: default value of gethash to Qunbound -- ben
-- Fix: face-handling code (superseded by ben's overhaul) -- jan, andy
-- Fix: layout improvements -- andy
-- Fix: major overhaul of face-handling code -- ben
  -- avoid truenaming fonts
  -- msw-faces.el APIs now accept names and font instances, return names
  -- rewrite frobbing functions in faces.el
  -- don't duplicatively set a global specification for the default font
  -- remove redundant face lists from x-faces.el and msw-faces.el
  -- call init-global-faces under MS Windows!
  -- correct weight names in font.el.

Internals

-- Add: new APIs -- ben
   -- macros to GCPRO arrays
   -- default argument for char tables
   -- signal extent changes
   -- internal_bind_*, check_specbind_stack_sanity
   -- partial support for 8-, 16-, and 32-bit fixed-width text
   -- new cons treatment (src/ChangeLog 2002-05-28)
   -- rename character types to Itext, Ibyte, Ichar (src/ChangeLog 2002-06-05)
   -- rename various identifiers for consistency
-- Add: New GC preparation -- mike, Martin Köbele, Jens Müller
-- Add: support for fastcall in MS Windows -- ben
-- Fix: ELL APIs -- james
   -- load only once
   -- no longer use RTLD_GLOBAL
-- Fix: ELLs now use RTLD_NOW instead of RTLD_LAZY -- Andrew Begel
-- Fix: Many Mule changes -- ben
-- Fix: call-process ensures that the argument to `symbol-value-in-buffer'
   is a buffer even if `buffer' is a string -- mike
-- Fix: code that outputs into a buffer, use unwind protects, etc. -- ben
-- Fix: complete implementation of some Unicode functions, S-caron test
   failure -- stephen
-- Fix: conditionalize code depending on features like toolbar -- jonathan,
   Mike Alexander
-- Fix: create new process-synchronize-point to avoid dynamic binding
   problems; fix bogosity in setting process sentinels -- ben, mike
-- Fix: make a lot of code use common includes and implementations
   -- see 2002-06-20 src/ChangeLog) -- ben
-- Fix: move global-map to keydefs.el -- ben
-- Fix: new signal/C-g handling (src/ChangeLog 2002-05-28) -- ben
-- Fix: numerous problems with the case-table implementation -- ben
-- Fix: quoting of native-coding-system in CJK files -- Daiki Ueno
-- Fix: race condition in process handling -- Nix
-- Fix: recover gracefully from internal XOpenDevice failure -- mike
-- Fix: redo syntax cache code -- ben
-- Fix: save-restriction now uses markers -- ben
-- Fix: small bugs -- stephen, ben, andy, martin, Eric Gillespie Jr

Build

-- Add: basic support for handling ISO 2022 doc strings in make-docfile -- ben
-- Add: tmpdir for install, allowing simultaneous run & build -- andy
-- Fix: "Stop Build" in VC++ now works -- Ben
-- Fix: #undef INTERNET_DOMAIN_SOCKETS build of gnuserv -- Greg Steuck
-- Fix: --with-widgets autodetection -- jan
-- Fix: 64-bit support -- Andreas Jaeger, Gregory Steuck
-- Fix: MS Windows Makefile cleanups -- ben, jonathan
-- Fix: MS Windows builds default to pdump -- ben
-- Fix: assorted build breakage -- ben, mike, andy, Malcolm Purvis
-- Fix: check for EOF in make-docfile -- ben
-- Fix: config.h.in organization -- ben
-- Fix: ensure combined X and windows build gets widgets -- andy
-- Fix: implement configure option moduledir -- Mike Fabian
-- Fix: spurious failures in tests -- ben, stephen
-- Fix: test harness now outputs FAIL messages to stderr in batch mode -- ben
-- Fix: test-harness.el now cleans up Check-Message and Check-Error-Message
   when done -- stephen
-- Fix: typos and platform specific bugs in configure -- Malcolm Purvis,
   galibert, Paul Stodghill
-- Fix: warnings -- ben, wmperry, stephen, didier

to 21.5.6 "bok choi"

UI changes and runtime bugs

-- Fix: process waiting on MS Windows -- Mike Alexander
-- Fix: (maybe) GTK progress bar crashes at startup -- William M. Perry
-- Fix: detect printer set up for metric units -- Jonathan Harris
-- Fix: add_charsets_to_precedence_list -- IKEYAMA Tomonori
-- Change: misc menubar -- John Paul Wallington
-- Add: auto-mode-alist: GNUmakefile is a Makefile, "system default"
   Xdefaults and friends get xrdb-mode -- Ville Skyttä
-- From  Ben Wing  <ben@xemacs.org>.
  -- Fix: init_process_io_handles obeys coding-system-for-{read,write}.
  -- Fix: bug in md5 handling.
  -- Fix: data corruption in print.c from print_depth becoming negative.
  -- Fix: "nil channel" in MS Windows magic events crashes.
  -- Fix: (tentative) redisplay crash freeing display line structures.
  -- Fix: (tentative) TTYs don't work.
  -- Fix: too-small SHEAP_ADJUSTMENT on Cygwin (can't run temacs).
  -- Fix: hscroll/truncation/continuation glyphs causing "jumping lines".
  -- Fix: problem with text files with no newlines ().
  -- Fix: errors when opening (e.g.) mule-ucs/lisp/reldata/uiso8859-6.el.
  -- Fix: (partial) excess memory use in Unicode processing, esp. at startup
  -- Fix: sample.init.el (grep-all-files-in-current-directory-and-below):
     Missing argument.
  -- Fix: smoother scrolling on MS Windows.
  -- Change: Move the menubar frame commands from the View menu to
     the File menu, to be consistent with how most other programs do
     things.  Move less-used revert/recover items to a submenu.  Make
     "recover" not prompt for a file, but recover the current buffer.
  -- Change: implementation of matching font to charset.
  -- Change: default MS Windows font to Lucida Console, increase
     default frame size on Windows to 50 lines.
  -- Add: runtime flag -no-packages inhibits adding package lisp to load-path.
  -- Add: much functionality to behavior.el.
  -- Add: more Unicode translation files.

Documentation

-- Add: define STACK_TRACE_EYE_CATCHER for Windows -- Jonathan Harris
-- Texinfo (internals): Add xref in emodules.texi -- Stephen J. Turnbull
-- Texinfo (lispref): Unicode Support, Behaviors -- Stephen J. Turnbull
-- Texinfo (user): Behaviors -- Stephen J. Turnbull
-- Improve auto-mode-alist -- Simon Josefsson
-- Docstrings: completion-ignored-extensions, file-name-all-completions --
   John H. Palmieri
-- From  Ben Wing  <ben@xemacs.org>.
  -- New ChangeLog for ./etc/.
  -- Updated: NEWS.
  -- Improve docs (developers): tree layout, merging branch to trunk.
  -- Improve docs (lispref): CL loop, menu sorting, sound-default-alist
  -- Obsoleted Lisp: 'sref, char-bytes.
  -- Internals: Revamped the sound documentation.
-- Typo fixes -- Adrian Aichner

Lisp API

-- From  Ben Wing  <ben@xemacs.org>.
  -- Fixed: bug in keymap iteration in cl-macs.el.
  -- Fix: bugs in language environments English and Ethiopic
  -- Change: lisp/mule/*.el -- convert to XEmacs style.
  -- Add (synch to GNU): get-window-with-predicate, ALL-FRAMES,
     some-window, count-windows, window-safely-shrinkable-p,
     count-screen-lines, shrink-window-if-larger-than-buffer
  -- Add (line-oriented mouse selection):  New functions
     mouse-consolidated-yank mouse-yank, mouse-track,
     default-mouse-track-normalize-point,
     default-mouse-track-return-dragged-selection, mouse-track-by-lines,
     mouse-track-insert mouse-track-adjust-by-lines, mouse-track-insert-1,
     mouse-track-insert-by-lines, mouse-track-delete-and-insert-by-lines
  -- Add (warnings): Add a consistent way to execute code,
     catching all errors and displaying a warning, including a
     backtrace showing where the error occurred.  New functions
     backtrace-in-condition-handler-eliminating-handler, with-trapping-errors,
     view-warnings.  Integrate show-message-log with view-lossage.
  -- Add (debugging): New functions  debug-print-1, debug-print,
     debug-backtrace.
  -- Add (misc utils): map-plist, show-memory-usage, compare-strings,
     truncate-string-to-width, variable require-prints-loading-message.
  -- Add many languages and charsets.
  -- Add (autoloads): Support defun*, defmacro*.
  -- Add (byte-compiler): with-boundp, if-boundp, when-boundp,
     and-boundp, declare-boundp, globally-declare-boundp, with-fboundp,
     if-fboundp, when-fboundp, and-fboundp, declare-fboundp,
     globally-declare-fboundp, with-byte-compiler-warnings-suppressed
  -- Warning fixes.

Internals

-- Add: Get & SetLocaleInfo from winnls.h -- Jonathan Harris
-- Add: codepages latin-jisx0201, japanese-jisx0212, remove
   japanese-jisx0208-1978 -- IKEYAMA Tomonori
-- Fix: Use wrap_emacs_*(), not wrap_*() for gtk_boxed, gtk_object, ffi --
   William M. Perry
-- Fix: I18N APIs on windows -- Jonathan Harris
-- Fix: typos causing GTK build errors -- Malcolm Purvis
-- Warning fixes -- William M. Perry
-- From  Ben Wing  <ben@xemacs.org>.
  -- Change: error-checking macros: ERROR_CHECK_TYPECHECK -> ERROR_CHECK_TYPES,
     ERROR_CHECK_CHARBPOS -> ERROR_CHECK_TEXT, add ERROR_CHECK_DISPLAY,
     ERROR_CHECK_STRUCTURES.
  -- Change: Redo print_*().
  -- Change: character-to-unicode char-to-unicode; also unicode-to-char{acter}.
  -- Change: Replace XSETFOO with wrap_foo().
  -- Change: symbol->name a Lisp_Object, not Lisp_String *.  Eliminate latter.
  -- Change: rearrange init calls in emacs.c.
  -- Add: (partial) category API compatible with FSF.
  -- Add: (partial) GC triggering based on percentage of total memory
     usage.  Not currently activated.
  -- Add: (partial) sledgehammer redisplay check.
  -- Add: error-behavior ERROR_ME_DEBUG_WARN.
  -- Add: more error checking on Dynarrs.
  -- Add: assert_at_line(), for use in asserts inside of inline functions.
  -- Add: resizing_buffer_to_lisp_string().
  -- Add: function get_charset_limits.
  -- Add: (tentative, may go away) foo_checking_assert_at_line() macros.
  -- Add: new event methods for printing, comparing, and hashing magic
     events, to avoid event-type-specific stuff.
  -- Fix eifree().  Use Eistrings in various places
  -- Fix: bugs in chartab implementation and doc strings.

Build

-- Fix: make-mswin-unicode.pl -- Ben Wing, Jonathan Harris
-- Fix: .texi files for Cygwin makeinfo -- Jonathan Harris
-- Fix: Perl quoting in Windows build -- Jonathan Harris, Ben Wing
-- Fix: Generate more intermediate files in obj subdirectory -- Jonathan Harris
-- From Ben Wing  <ben@xemacs.org>.
  -- Fix: require errors in behavior.el
  -- Fix: compile error when TTY-only.
  -- Change: update check_cygwin_setup.sh for current Cygwin reality.
  -- Change: Makefile regenerates itself if out of date.
  -- Change: improve error-checking config for Windows
  -- Add: HAVE_SYS_TIMES_H config.h #define.
  -- Add: new error-checking types in configure.
  -- Add: .cvsignore

to 21.5.5 "beets"

Documentation
-- new external-widget example node -- Stephen Turnbull
-- new packaging manual nodes -- Steve Youngs, Stephen Turnbull
-- new Swedish TUTORIAL -- Mats Lidell
-- update etc/BETA -- Jarl Friis, Stephen Turnbull
-- update FAQ, new FAQs -- Adrian Aichner, Stephen Turnbull
-- fixes for build-breaking typos in Info docs -- Jeff Miller, Darryl Okahata
-- misc comment and docstring improvements -- Valdis Kletnieks
   Pretty much all the code fixers fixed docs too:  keep up the good
   work, folks!

UI
-- fix switching between virtual desktops on MS Windows -- Adrian Aichner
-- improve Customize: modifier-keys-sticky-time, abbrev-mode-line-string,
   overwrite-mode-line-string, auto-fill-mode-line-string,
   defining-kbd-macro-mode-line-string -- John Paul Wallington
-- improve GTK clipboard handling -- Eric Gillespie, Jr.
-- improve Info dir - generate file if non-existent -- Michael Sperber
-- improve printer handling -- Adrian Aichner, Björn Torkelsson
-- support GUI toolbar shadow thickness adjustment -- Bill Perry
-- support ISO 8859/15 (Euro) -- Stephen Turnbull
-- support Sieve in auto-mode-alist -- Simon Josefsson
-- suppress ask-user-about-supersession-threat if CLASH_DETECTION -- Daiki Ueno

Lisp API
-- synch from GNU Emacs 21: quit-window -- Christoph Wedler

Internals
-- improve dead console handling in post-command code -- Ben Wing
-- improve handling when XOpenDevice calls error handler -- Mike Sperber
-- move disabled-command-loop to C -- Jan Vroonhof

Build
-- improve Athena widgets detection -- Jan Vroonhof

to 21.5.4 "bamboo"
-- auto-mode support .9 files as man pages -- Michael Sperber
-- auto-mode support configure.ac as m4 -- Edward M. Lee
-- bind `replace-rectangle' to `C-x r p' -- Didier Verna
-- bind `hyper-apropos-find-variable' (new) to `v' in hyper-apropos-help-map
   -- David A. Panariti
-- bind `delete-other-frames' to `C-x 5 1' -- John Paul Wallington
-- default Info-auto-generate-directory to 'if-outdated -- Adrian Aichner
-- improve printer handling -- Andy Piper, Mike Alexander, Adrian Aichner
-- mark buffer as modified when changing coding system -- Andy Piper
-- minor mode mode-line-strings now customizable -- John Paul Wallington
   isearch-mode, abbrev-mode, overwrite-mode, auto-fill-mode,
   gnuserv-mode, defining-kbd-macro-mode, font-lock-mode, view-mode
-- search the core etc/ for package index if not in ~/.xemacs/ -- Steve Youngs
-- support sub-expression replacement in replace-match -- Torsten Duwe
-- support user {site,infodock}-packages hierarchies -- Michael Sperber
-- truncate-partial-width-windows now applied in redisplay -- Ben Wing
-- use version-specific name for root testing -- Michael Sperber
   Eg, /usr/local/lib/xemacs-21.5.4.  Fixes common "can't find root" bug,
   but run-in-place XEmacs won't find installed packages.

-- HTML docs from Texinfo sources -- Adrian Aichner
-- document fix for Motif related crashes (Sun/Solaris) -- Robert Pluim
-- improve package system documentation -- Stephen Turnbull
-- new Japanese translation of xemacs.1 -- Kazuo Oishi
-- update developer personal info -- Jan Vroonhof, Michael Diers
-- many doc fixes and improvements, sorry about the credits :-(

-- alias `interactive-form' to `function-interactive' -- John Paul Wallington
-- etags to Potorti` version 14.28. -- Yoshiki Hayashi
-- mark-paragraph - added optional argument -- John Paul Wallington

-- arch-specific files go under ${libdir}, not ${datadir} -- Jered Floyd
-- configure recognizes LDFLAGS and adds to top Makefile -- Lutz Jaenicke
-- eliminate bogus check for Athena widgets -- Alexey Mahotkin
-- omit -Wshadow when compiling with g++ -- Ben Wing
-- use the ld reported by gcc, not gcc -- Andrew Begel
-- work around lack of support for autoconf 2.5x -- Didier Verna

-- fix "can't Customize standard faces" bug (partially) -- Jan Vroonhof
-- fix "can't close last window" bug -- Adrian Aichner
-- fix "doubled escape" bug in Mule (ISO-2022-7) autosave files -- Kyle Jones
-- fix "fail to save (non-themed) variable customizations" bug -- Andy Piper
-- fix PGP signature handling in package UI -- Steve Youngs
-- fix allocation of module-defined names in symbol table -- Andrew Begel
-- fix conversion of host and network byte order in multicast -- Daiki Ueno
-- fix crash from missing XIM unregister callback on Motif -- Glynn Clements
-- fix crash/infloops in read_key_sequence -- Hirokazu FUKUI
-- fix early dereference crash in decode_buffer -- Torsten Duwe
-- fix handling of negative C times -- Simon Josefsson and Stephen Turnbull
-- fix 'report-xemacs-bug' issues -- Steve Youngs
-- fix several font-lock bugs -- Jan Vroonhof, Andy Piper, Bill Perry
-- fix several package-get bugs -- Steve Youngs
-- fix some slow startups - default with_ipv6_cname=no -- Stephen Turnbull
-- fix unsigned warnings; turn sign-compare warnings on for NT -- Ben Wing
-- fix window_loop iteration across multiple devices -- Darryl Okahata
-- fix/avoid GNU ld -z combreloc lossage -- Stephen Turnbull
-- make sure installed.db gets updated after updating packages -- Andy Piper

-- GTK improvements/fixes -- Bill Perry
   -- add face mappings
   -- fix "can't shut up bell" bug
   -- fix some face initialization bugs
   -- fix subwindow handling
   -- fix yes-or-no-p lossage
   -- improve conformance to internal APIs
   -- munge highlight, zmacs-region, toolbar, and gui-button faces from
      default GtkStyle
   -- remove useless XPM color symbol checks

-- MS Windows improvements/fixes -- Andy Piper
   -- better build portability
   -- change registry key to XEmacs.
   -- add/fix Cygwin handling of URLs and win32 paths
   -- fix focus and event handling in scrollbars
   -- fix get-popup-menu-response bug
   -- improve DDE support
   -- improve netinstaller, especially uninstall and shortcuts
   -- improve popup dialog handling
   -- new directory dialog support
   -- quit if the user cancels in directory dialog
-- Cygwin nox-xpm detection -- Charles Wilson
-- fix compile problems when --with-msw, --with-x=no, --with-tty=no -- Ben Wing
-- fix file handle leak in pipes -- Mike Alexander
-- initial VC.NET support -- Andrew Begel

-- Rename/redefine integral types -- Ben Wing
   -- See src/ChangeLog for details and rationale.
   -- All integral types that measure quantities of anything are signed.
   -- All quantity types boil down to EMACS_INT, except Hashcode,
      which is an unsigned value of the same size as EMACS_INT.
   -- Type names should be relatively short, with the first letter
      capitalized and no underscores if they can be avoided.
   -- "*count" == zero-based quantity.  Includes sizes, offsets, and indexes.
   -- "*bpos" == one-based buffer position.
   -- "Char" refers to internal-format characters, not to the C type "char".
-- CVS: improve .cvsignore files -- Adrian Aichner
-- autoload handling improvements -- Didier Verna
-- improve handling of face inheritance/fallback -- Jan Vroonhof
-- condense repetitive window-system settings to 'win default' -- Bill Perry
-- improve debugging in event-msw.c -- Adrian Aichner
-- rename Menubar-items-truncate-list to Menubar-items-truncate-history
   -- Adrian Aichner
-- rename default package index to 'package-index.LATEST.gpg' -- Steve Youngs
-- unify GUI pixmap handling -- Bill Perry
-- unify toolbar handling across GUI platforms -- Bill Perry

to 21.5.3 "asparagus"
-- Add missing XIM unregister callback on Motif -- Glynn Clements
-- Improve debugging in event-msw.c, fix "can't close last window" bug
   -- Adrian Aichner
-- Improve Info docs for widget.el -- Stephen J. Turnbull
-- Many small bug, typo, and warning fixes -- Ben Wing, Stephen J. Turnbull,
   Adrian Aichner
-- Autoload handling improvements -- Didier Verna
-- More 'report-xemacs-bug' updates -- Steve Youngs
-- Fix unsigned warnings; turn sign-compare warnings on for NT -- Ben Wing
-- Synch configure.usage options with configure -- Peter Brown

to 21.5.2 "artichoke"
-- fixes and improvements -- Ben Wing
   -- etags.c synched to upstream
   -- lisp/term/*.el cleanup
   -- miscellaneous help improvements
   -- transpose-line-up/down maybe moves the region
   -- MS Windows init improvements
   -- add scroll-in-place, jka-compr, efs, some fixes in behavior-defs.el
   -- paths-find-recursive-path: fix error with null EXCLUDE-REGEXP
   -- font-lock-mode: fix problem with buffers starting with a space
   -- make find-library search patch configurable
   -- fix Dired problem with directories containing [] and code that
      destructively modifies an existing string
   -- stop mark_window_as_deleted from deleting information that needs to
      be accessed by set-window-configuration
   -- Lisp object structure rationalization
   -- fix two nasty bugs in the unwinding code
   -- fix mouse wheel/dead window crash under MS Windows
   -- mswindows_utime, close_file_data: fix off-by-one-indirection error
   -- control-G handling fixes for MS Windows
   -- debug-mswindows-events and related code introduced
   -- rearrange the signal-handling code to eliminate the former
      spaghetti logic paths in it; document; fix numerous bugs
   -- maintain the "iconified" state, to fix the "can't delete a frame" bug
   -- use CBufbyte instead of char for error/warning functions
   -- prepare to remove encapsulation
   -- make play_sound_data return an int, like all other such functions
   -- use EMACS_SIGNAL to avoid preprocessing games with signal()
   -- gc-in-window-procedure fixes
   -- Cygwin setitimer fixes
   -- windows shell fixes
   -- more structured errors
   -- MS Windows network stream data corruption fixes
   -- fix ~user file name handling
   -- rename MAX_PATH to standard PATH_MAX
   -- fix error compiling regexps with back-references in them

-- fixes and improvements -- Martin Buchholz
   -- byte optimizer fixes
   -- move alloca twiddling after the feature test definitions, but
      before the first "real" code
   -- internal DECIMAL_PRINT_SIZE macro
   -- s&m elimination: Eliminate the need to define HAVE_PTYS in s&m files
   -- avoid test failure if (temp-directory) is a symlink
   -- handle buggy Sun realloc()

-- GTK fixes -- Bill Perry
   -- GTK popup dialog fix
   -- GTK added to font-window system mappings
   -- gtk-marshal.el updated for new hash.c, and generator fixes,
   -- GTK scrollbar fixes
   -- buttons are now modifiers, so selection with the mouse works again
   -- fix the disappearing GTK scrollbar problem

-- movemail.c uses mkstemp if available -- Karl M. Hegbloom
-- specifiers may now conditionalize on GTK -- Stephen J. Turnbull
-- new hooks for package installation and deletion -- Sean MacLennan
-- locate-library completes and other package UI improvements -- Robert Pluim
-- save-some-buffers doesn't prematurely zap help window -- Michael Sperber
-- MS windows subprocess quoting arguments -- Ben Wing, Dan Holmsand
-- remove side effects from font-lock-compile-keywords -- Daiki Ueno
-- custom-display works on the GTK platform -- Karl Hegbloom
-- mouse-track fixes -- Adrian Aichner, Ben Wing
-- dragdrop fix for windowless events -- Mike Alexander
-- fix `unbalanced parentheses' bug in syntax -- Matt Tucker
-- gpmevent.c header inclusion fixes -- Bill Perry
-- make more glyph code shared across platforms -- Ben Wing, Bill Perry
-- remove lisp_string_set_file_times() because set_file_times() now
   takes Lisp_Object path, instead of char* -- Adrian Aichner and Ben Wing
-- allow preemption on redisplay -- Kirill 'Big K' Katsnelson
-- new, faster implementation of long_to_string -- Hrvoje Niksic
-- Qccl_error: New error -- Yoshiki Hayashi
-- remove support for old beta versions of cygwin -- Ben Wing, Craig Lanning
-- fix crash with an unavailable network printer -- Mike Alexander
-- add support for MacOS X -- Greg Parkin and Martin Buchholz
-- better win9x (including WinMe) support -- Ben Wing, Stephen J. Turnbull
-- fix off-by-one error in EMACS_INT_MAX -- Yoshiki Hayashi

-- warning, style, and doc fixes and improvements
   -- warning fixes -- Ben Wing, Kirill 'Big K' Katsnelson, Martin Buchholz
   -- eliminate numerous C++ errors -- Ben Wing, Martin Buchholz
   -- code style corrections -- Ben Wing, Martin Buchholz
   -- build improvements -- Ben Wing, Martin Buchholz
   -- configure improvements and fixes -- Martin Buchholz, Ben Wing,
      Stephen J. Turnbull
   -- doc updates -- Adrian Aichner, Ben Wing, Alexey Mahotkin, Steve
      Youngs, Stephen J. Turnbull, Yoshiki Hayashi, Steve Youngs, Paul
      Stodghill, Malcolm Purvis, Jim Horning, Nick V. Pakoulin, Kirill
      'Big K' Katsnelson

to 21.5.1 "anise"
-- This release contains a huge pile of changes by Ben Wing, including
   both bug fixes and features.  Highlights:
   -- Many changes to make printing work on Windows
   -- byte-compilation speed improvements
   -- New functions for cleanly eliminating byte-compiler warnings
   -- Remove core bytecompiler warnings
   -- Improve interactive help interface
   -- etags improvements
   -- Better "About XEmacs" page
   -- Windows configury changes
   -- Get QUIT working on Windows
   -- Fix shy group regexp code
   -- etc. etc.

-- The `short-name' argument to make-charset now works correctly
   -- Yoshiaki Kasahara
-- `custom' changes -- Didier Verna
-- SET_FACE_PROPERTY bug fix -- Jerry James
-- Unix tty configury changes -- Martin Buchholz
-- Fix compile error with g++ on bsdi -- Martin Buchholz
-- Fix crash with xlc -O3 -- Martin Buchholz
-- Fix link error with (pre-release) gcc 3.0 -- Martin Buchholz
-- Fix build error if system has makeinfo 3.12 -- Martin Buchholz
-- Speed up `intern' and hash tables containing strings -- Martin Buchholz
-- Make hash table mapping safe -- Martin Buchholz

Fork from 21.2: 21.5.0 "alfalfa"
-- For changes up to 21.4.0, see etc/NEWS
